2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Update AUTHORS file.

	* AUTHORS: Add 2013 students.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Include star alphabet (taf-kit) command.

	* taf-kit/src/Makefile.am: Add star alphabets.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Update domain and image algorithms.

	* include/vaucanson/algorithms/domain.hxx,
	* include/vaucanson/algorithms/image.hxx: Add latest
	version for domain and image algorithms.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Update vcsn-char-q.test and vcsn-char-r.test
	* taf-kit/tests/vcsn-char-r.test: Read the alphabet '01'
	instead of 'ab'.
	* taf-kit/tests/vcsn-char-q.test: Delete latest test.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Update Vaucanson version (1.3.9)

	* configure.ac: Update Vaucanson version to 1.3.9.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Downgrade sub_normalized.hxx
	* include/vaucanson/algorithms/sub_normalized.hxx: Downgrade (check
	error for fmp).

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Add star_alphabet_command file

	* taf-kit/src/Makefile.am: add
	taf-kit/src/star_alphabet_command.hh, and
	taf-kit/src/star_alphabet_command.hx

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Work on infiltration, sub_normalize, and shuffle

	* include/vaucanson/algorithms/infiltration.hxx,
	* include/vaucanson/algorithms/sub_normalize.hxx,
	* include/vaucanson/algorithms/shuffle.hxx: Correct
	bug.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Change type for RationalNumber.

	* include/vaucanson/algebra/implementation/semiring/q_number.hh,
	* include/vaucanson/algebra/implementation/semiring/q_number.hh:
	Chagen type for RationalNumber.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Correct demonstration.

	* data/automata/Makefile.am,
	* data/automata/char-q/Makefile.am,
	* data/automata/char-q/b1.cc,
	* data/automata/char-q/c1.cc,
	* data/automata/char-q/d1.cc,
	* data/automata/char-r/Makefile.am,
	* data/automata/char-r/b1.cc,
	* data/automata/char-r/c1.cc,
	* data/automata/char-r/d1.cc,
	* data/automata/char-rw-b/Makefile.am,
	* data/automata/char-rw-b/add1-rw.xml,
	* data/automata/char-rw-b/quot-3-rw.xml,
	* data/automata/char-z/Makefile.am,
	* data/automata/char-z/b1.cc,
	* vaucanson.mk: Correct demonstration
	and compile.


2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Correct Rational Number.
	* include/vaucanson/algebra/implementation/semiring/q_number.hxx:
	Correct rational number operator.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Add star_alphabet in taf-kit.

	* taf-kit/src/cmd_wt.cc,
	* taf-kit/src/star_alphabet_command.hh,
	* taf-kit/src/star_alphabet_command.hxx:
	Add star_alphabet in taf-kit factory.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Create demonstration in data/automata
	* configure.ac,
	* data/automata/Makefile.am,
	* data/automata/char-b/Makefile.am,
	* data/automata/char-b/evena.cc,
	* data/automata/char-b/oddb.cc,
	* data/automata/char-char-b/Makefile.am,
	* data/automata/char-f2/Makefile.am,
	* data/automata/char-f2/ring.cc,
	* data/automata/char-fmp-z/Makefile.am,
	* ata/automata/char-int-b/Makefile.am,
	* data/automata/char-q/Makefile.am,
	* data/automata/char-r/Makefile.am,
	* data/automata/char-zmax/Makefile.am,
	* data/automata/char-zmax/gag.cc,
	* data/automata/char-zmax/maxab.cc,
	* data/automata/char-zmin/Makefile.am,
	* data/automata/char-zmin/minab.cc,
	* data/automata/char-zmin/sag.cc,
	* data/automata/int-b/Makefile.am,
	* data/automata/int-z/Makefile.am: Create demonstration
	in data/automata for int-z, int-b, char-zmin, char-zmax,
	char-r, char-q, char-int-b, char-fmp-z, char-f2, char-char-b,
	and char-b. Create Makefile.am for demonstration, and update
	main Makefile.am

2011-07-08    <moreira@lrde.epita.fr>

	Correct bug in Taf-kit

	* taf-kit/src/library_command.hh: Correct three letters file
	bug.

2011-07-08  David Moreira  <moreira@lrde.epita.fr>

	Correct operator== and change data type in Rational Number.

	* include/vaucanson/algebra/implementation/q_number.hh,
	* include/vaucanson/algebra/implementation/q_number.hxx: Change
	data type to 'long long' instead of int. Correct operator== for
	null numbers.
	* include/vaucanson/misc/algebra.hh,
	* include/vaucanson/misc/algebra.hxx: Change type for lcm pgm
	and is_coprime functions (unsigned long long).

2011-07-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix a bug in positive_path_covering().

	* include/vaucanson/algorithms/eps_removal.hxx
	(positive_path_covering): Fix iteration on supp().

2011-07-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix XML output for F2.

	* include/vaucanson/xml/builders.hxx (get_semiring_operations):
	Add specialization to output CyclicSemirings as "field".
	* data/vaucanson.xsd: Update it.

2011-07-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Add a way to output fully parenthesized expressions.

	* taf-kit/src/pipe.hh: Declare OUTPUT_TYPE_FPEXP.
	* taf-kit/src/pipe_writers.hxx: Handle it.
	* taf-kit/src/main.cc: Handle "-o EXP" and "-o FPEXP".

2011-07-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix specialization of eps_removal for positive semirings.

	* include/vaucanson/algorithms/eps_removal.hxx
	(EpsilonRemover::test_for_non_positive_semiring): Move ...
	(test_for_non_positive_semiring::run): ... here in a separate
	struct that we can specialize if the semiring is positive.

2011-06-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix compilation of eps_removal.hxx on Q (it still does not compile
	on FMP).

	* include/vaucanson/algorithms/eps_removal.hxx
	(positive_path_covering): Use "weight < semiring_elt_zero" instead
	of "weight.value() < 0".

2011-05-26  Sylvain Lombardy  <lombardy@univ-mlv.fr>

	* include/vaucanson/algorithms/eps_removal.hxx: Rewrite.

2011-04-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement a is_positive_semiring() function in semiring implementations.

	* include/vaucanson/algebra/concept/semiring_base.hh
	(semiring_traits<T,U>): New trait.
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hxx,
	include/vaucanson/algebra/implementation/series/krat.hh,
	include/vaucanson/algebra/implementation/series/krat.hxx
	(is_positive_semiring): Remove and...
	(semiring_traits<T,U>): ... specialize.
	* taf-kit/src/cmd_gen.cc (semiring-info): Adjust caller.

2011-07-06  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Check is_trim() in prefix(), factor(), and suffix().

	* include/vaucanson/algorithms/factor.hh,
	include/vaucanson/algorithms/factor.hxx,
	include/vaucanson/algorithms/prefix.hh,
	include/vaucanson/algorithms/prefix.hxx,
	include/vaucanson/algorithms/suffix.hh,
	include/vaucanson/algorithms/suffix.hxx: Add is_trim precondition
	as reported by Jacques Sakarovitch.
	* src/tests/sanity/hhck.pl: Add support from checking is_trim()
	preconditions.

2011-06-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix two bugs in expand.

	* include/vaucanson/algorithms/krat_exp_expand.hxx (list_concat):
	Handle ONE and ZERO in lists.
	(MATCH__(Product, lhs, rhs)): Sum weights of identical element
	generated while expansing the product.
	* taf-kit/tests/vcsn-char-z.test: Add some test cases based on
	a report by Jacques Sakarovitch.

2011-06-29  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix parsing of Q numbers with g++-4.6.

	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx
	(op_parse): Remove this overloading for RationalNumber.  Its
	incorrect usage of tellg() broke with g++-4.6, and the general
	definition of op_parse() in
	include/vaucanson/algebra/concept/semiring_base.hxx will call the
	operator<< code that is specialized for RationalNumber already.
	* include/vaucanson/algebra/implementation/semiring/q_number.hh,
	include/vaucanson/algebra/implementation/semiring/q_number.hxx
	(operator<<): Move into the vcsn::algebra namespace, so that Koening
	lookup works.  Also to not try to read past the end of the stream.

2011-06-29  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Do not call realtime in quotient.

	* taf-kit/src/cmd_wt.cc (quotient_command): Do not call realtime.
	* taf-kit/tests/vcsn-int-z.test, taf-kit/tests/vcsn-int-b.test: Adjust.
	Do not call realtime in quotient.

2011-06-29  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce eval-S.

	* taf-kit/src/cmd_wt.cc (eval_command): Rename as ...
	(eval_S_command): ... this.
	(eval_command): New version that does not call realtime.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-z.test, taf-kit/tests/vcsn-int-b.test,
	taf-kit/tests/vcsn-int-z.test: Adjust.

2011-06-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Integrate shuffle and infiltration algorithm, from Pierre-Yves
	Angrand <pangrand@gmail.com>.

	* include/vaucanson/algorithms/infiltration.hh,
	include/vaucanson/algorithms/infiltration.hxx,
	include/vaucanson/algorithms/shuffle.hh,
	include/vaucanson/algorithms/shuffle.hxx: New files.
	* include/Makefile.am: Add them.
	* lib/generate_libvcsn.rb (create?): Do not compile these
	in FMP contexts.
	* taf-kit/src/cmd_wt.cc (shuffle_command, infiltration_command):
	New functions.

2011-06-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename u-composition as composition.

	* taf-kit/src/cmd_fmp.cc (u_composition): Rename as ...
	(composition_R): ... this.
	(composition): New function similar to composition_R, but
	without subnormalization.
	* taf-kit/tests/vcsn-char-fmp-b.test: Adjust.

2011-06-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Call eps_removal after composition.

	* include/vaucanson/algorithms/normalized_composition.hxx
	(do_compose): Call eps_removal_here() after composing two
	Boolean transducers.

2011-06-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename composition as b-composition.

	* taf-kit/src/cmd_fmp.cc (composition, composition_R): Rename as ...
	(b_composition, b_composition_R): ... these.  And compile
	only for Boolean weights.
	* taf-kit/tests/vcsn-char-fmp-b.test: Adjust.

2011-06-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement the characteristic command (for free monoids only).

	* include/vaucanson/algorithms/characteristic.hxx,
	include/vaucanson/algorithms/characteristic.hh: New files.
	* include/Makefile.am: Add them.
	* taf-kit/src/Makefile.am: Define BOOL_CONTEXT macros for
	all instances.
	* taf-kit/src/cmd_wt.cc (characteristic_command): New function.
	* taf-kit/src/common.hh (BOOL_CONTEXT_HEADER): Define.
	* taf-kit/src/getters.cc, taf-kit/src/getters.hh
	(get_boolean_aut): Rename as ...
	(get_single_band_aut): ... this because the automaton we
	read with this function is not always Boolean.
	(get_boolean_aut, locate_boolean_file): New functions.
	* taf-kit/src/cmd_fmp.cc (evaluation_command): Adjust call.
	* taf-kit/src/library_commands.hh (get_base_path): Define
	base_path as static so that it is computed only once.
	* taf-kit/src/pipe.hh, taf-kit/src/pipe_getters.hh,
	taf-kit/src/pipe_getters.hxx, taf-kit/src/pipe_writers.hxx:
	Implement I/O for BOOL_CONTEXT.

2011-06-09  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Add missing interface for aut_to_exp().

	* include/vaucanson/algorithms/aut_to_exp.hh: Add missing
	interface for the two-argument version of aut_to_exp when the
	second argument is vcsn::DefaultChooser.  G++ 4.6 complained
	today, but I'm surprised this issue hasn't come up before.

2011-06-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement chain.

	* taf-kit/src/cmd_gen.cc (command_chain): New function.

2011-06-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Restrict prefix, suffix, and factor to Boolean automata.

	* taf-kit/src/cmd_wt.cc (prefix_command, suffix_command,
	factor_command): Move these functions ...
	* taf-kit/src/cmd_b.cc (prefix_command, suffix_command,
	factor_command): ... here, on Jacques' request.

2011-05-19  Guillaume Fiette  <fiette@fiette.lrde.epita.fr>

	Correct a bug in cyclic semiring.

	* include/vaucanson/algebra/implementation/semiring/cyclic_semiring.hxx:
	remove "unit" for "unsigned int".

2011-05-02  Guillaume Fiette  <fiette@lrde.epita.fr>

	Add tests for f2 in taf-kit.

	* taf-kit/tests/vcsn-char-f2.test: Add tests for f2.

2011-05-02  Guillaume Fiette  <fiette@lrde.epita.fr>

	Fix some problems due to the previous rebase on next.

	* taf-kit/src/cmd_r.cc: Fix bug in are_equivalent_command
	for compatibility with the f2 semiring.
	* include/vaucanson/algebra/implementation/semiring/cyclic_semiring.hxx:
	Remove useless inlines.
	* include/vaucanson/algebra/implementation/semiring/q_number.hh,
	include/vaucanson/algebra/implementation/semiring/q_number.hxx:
	Fix the >> operator.

2011-04-28  Guillaume Fiette  <fiette@lrde.epita.fr>

	Add missing include in taf-kit.

	* taf-kit/src/cmd_gen.cc: Include is_trim algorithm.

2011-04-28  Guillaume Fiette  <fiette@lrde.epita.fr>

	Change z2z to f2.

	* include/vaucanson/automata/generic_contexts/f2_automaton.hh,
	include/vaucanson/automata/generic_contexts/f2_automaton_structures.hh,
	src/tests/test-suites/generate-all.sh,
	taf-kit/src/Makefile.am,
	taf-kit/tests/Makefile.am,
	lib/Makefile.am,
	lib/generate_libvcsn.rb,
	include/vaucanson/contexts/f2_semiring.thh,
	configure.ac: Change the context name.
	* include/Makefile.am: Add files to distcheck

2011-04-28  David Moreira  <moreira@knokke-le-zout.lrde.epita.fr>

	Clean code on taf-kit sources.

	* taf-kit/src/library_commands.hh: Delete dead code from search
	path fix from taf-kit.
	* taf-kit/src/getters.cc, taf-kit/src/getters.hh: Delete the
	get_pair_aut function (cause: unused).

2011-04-27  David Moreira <moreira@lrde.epita.fr>

	Fix search path for automaton with two alphabets

	* taf-kit/src/getter.cc: Create the locate_fmp_file
	calling get_fmp_aut_path into library_commands.hh.
	Fix get_boolean_aut for calling locate_fmp_file.
	* taf-kit/src/getter.hh: Create the locate_fmp_file
	function.
	* taf-kit/src/library_commands.hh: Create
	get_fmp_aut_path deleting the pattern '-fmp' from the program
	name. Factorize get_automata to avoid copying code.

2011-04-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement a is_positive_semiring() function in semiring implementations.

	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hxx,
	include/vaucanson/algebra/implementation/series/krat.hh,
	include/vaucanson/algebra/implementation/series/krat.hxx
	(is_positive_semiring): Implement this new function.
	* taf-kit/src/cmd_gen.cc (semiring-info): New hidden command
	to help debugging the above.

2011-04-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Install some automaton factories.

	* data/automata/char-b/Makefile.am (divkbaseb, ladybird,
	double_ring): Rename these as...
	(divkbaseb-char-b, ladybird-char-b, doublering-char-b): ... these,
	and install them.
	* data/automata/char-fmp-b/Makefile.am (quotkbaseb): Rename as ...
	(quotkbaseb-char-fmp-b): ... this and install it.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix operator precedence for kratexp parser.

	* lib/src/krat_exp/krat_exp_bison.yy: Do not declare token twice
	i.e, once for type and once for precedence.  Do not declare "("
	and ")" as associative operators, it breaks proper grouping in
	"a+b(a)".
	* taf-kit/tests/vcsn-char-b.test: Add test cases.
	Reported by Jacques Sakarovitch.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement are-equivalent-E for expressions with Boolean weights.

	* taf-kit/src/cmd_b.cc (are_equivalent_E_command): New command.
	* taf-kit/tests/vcsn-char-b.test: Add some small tests.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement are-equivalent-E for expressions with weights in fields.

	* taf-kit/src/cmd_r.cc (are_equivalent_E_command): New command.
	* taf-kit/src/commands.cc, taf-kit/src/commands.hh: Add support
	for the "ExpExp" command prototype.
	* taf-kit/tests/vcsn-char-r.test: Add a small test.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement are-equivalent for automata with weights in fields.

	* taf-kit/src/cmd_r.cc (are_equivalent_command): New command.
	* taf-kit/tests/vcsn-char-r.test: Add a small test.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Implement left-mult and right-mult.

	* include/vaucanson/algorithms/standard.hh,
	include/vaucanson/algorithms/standard.hxx
	(left_mult_of_standard_here, right_mult_of_standard_here): New
	functions.
	* taf-kit/src/cmd_gen.cc (left_mult_command, right_mult_command):
	New commands.
	* taf-kit/src/getters.cc, taf-kit/src/getters.hh (get_weight): New
	function.
	* taf-kit/src/commands.cc, taf-kit/src/commands.hh: Add support
	for the "AutWeight" command prototype.
	* taf-kit/tests/vcsn-char-b.test, taf-kit/tests/vcsn-char-r.test:
	Add some tests.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix op_parse for weights.

	* include/vaucanson/algebra/concept/semiring_base.hxx (op_parse):
	Rewrite using stringstream::eof() instead of assuming that tellg()
	will return 0 at the end (not the case with my compiler/libstdc++
	combination, most of the TAF-Kit tests were failing).

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Update to gnulib 7d06b32684363a39fae65c616b84bc7589768106.

	* gnulib/dosname.h: New file.
	* gnulib/stdio-write.c, gnulib/strcasecmp.c, gnulib/strings.in.h,
	gnulib/strncasecmp.c, m4/asm-underscore.m4, m4/dos.m4,
	m4/strcase.m4, m4/strings_h.m4: Delete.
	* build-aux/arg-nonnull.h, build-aux/c++defs.h,
	build-aux/warn-on-use.h, gnulib/alloca.c, gnulib/alloca.in.h,
	gnulib/argp-ba.c, gnulib/argp-eexst.c, gnulib/argp-fmtstream.c,
	gnulib/argp-fmtstream.h, gnulib/argp-fs-xinl.c, gnulib/argp.h,
	gnulib/argp-help.c, gnulib/argp-namefrob.h, gnulib/argp-parse.c,
	gnulib/argp-pin.c, gnulib/argp-pv.c, gnulib/argp-pvh.c,
	gnulib/argp-xinl.c, gnulib/asnprintf.c, gnulib/basename-lgpl.c,
	gnulib/dirname.h, gnulib/dirname-lgpl.c, gnulib/errno.in.h,
	gnulib/float+.h, gnulib/float.in.h, gnulib/getopt1.c,
	gnulib/getopt.c, gnulib/getopt.in.h, gnulib/getopt_int.h,
	gnulib/gettext.h, gnulib/intprops.h, gnulib/Makefile.am,
	gnulib/malloc.c, gnulib/memchr.c, gnulib/mempcpy.c,
	gnulib/printf-args.c, gnulib/printf-args.h, gnulib/printf-parse.c,
	gnulib/printf-parse.h, gnulib/progname.c, gnulib/progname.h,
	gnulib/rawmemchr.c, gnulib/size_max.h, gnulib/sleep.c,
	gnulib/stdbool.in.h, gnulib/stddef.in.h, gnulib/stdint.in.h,
	gnulib/stdio.in.h, gnulib/stdlib.in.h, gnulib/strchrnul.c,
	gnulib/strerror.c, gnulib/string.in.h, gnulib/stripslash.c,
	gnulib/strndup.c, gnulib/strnlen.c, gnulib/sysexits.in.h,
	gnulib/unistd.in.h, gnulib/vasnprintf.c, gnulib/vasnprintf.h,
	gnulib/verify.h, gnulib/vsnprintf.c, gnulib/wchar.in.h adl@haze,
	gnulib/xsize.h, m4/00gnulib.m4, m4/alloca.m4, m4/argp.m4,
	m4/dirname.m4, m4/double-slash-root.m4, m4/errno_h.m4,
	m4/extensions.m4, m4/float_h.m4, m4/getopt.m4, m4/gnulib-cache.m4,
	m4/gnulib-common.m4, m4/gnulib-comp.m4, m4/gnulib-tool.m4,
	m4/include_next.m4, m4/intmax_t.m4, m4/inttypes_h.m4,
	m4/longlong.m4, m4/malloc.m4, m4/memchr.m4, m4/mempcpy.m4,
	m4/mmap-anon.m4, m4/multiarch.m4, m4/printf.m4, m4/rawmemchr.m4,
	m4/size_max.m4, m4/sleep.m4, m4/stdbool.m4, m4/stddef_h.m4,
	m4/stdint_h.m4, m4/stdint.m4, m4/stdio_h.m4, m4/stdlib_h.m4,
	m4/strchrnul.m4, m4/strerror.m4, m4/string_h.m4, m4/strndup.m4,
	m4/strnlen.m4, m4/sysexits.m4, m4/unistd_h.m4, m4/vasnprintf.m4,
	m4/vsnprintf.m4, m4/warn-on-use.m4, m4/wchar_h.m4, m4/wchar_t.m4,
	m4/wint_t.m4, m4/xsize.m4: Update.

2011-04-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/reduce.hxx (semi_reduce): Check
	precondition.

2011-04-26  Fiette Guillaume <fiette@lrde.epita.fr>

	Add the is_realtime precondition to the new algorithms.

	* include/vaucanson/algorithms/factor.hxx,
	include/vaucanson/algorithms/prefix.hxx,
	include/vaucanson/algorithms/suffix.hxx: Add the precondition.
	* lib/generate_libvcsn.rb,
	taf-kit/src/cmd_gen.cc,
	taf-kit/src/cmd_wt.cc: Do not include these
	algorithms for transducers.

2011-04-26  Fiette Guillaume <fiette@lrde.epita.fr>

	Add the new algorithms to taf-kit.

	* include/Makefile.am,
	include/vaucanson/contexts/automaton_functions.thh,
	taf-kit/src/cmd_gen.cc: The commands currently work with
	any automaton because of a problem with is_realtime.

2011-04-26  Fiette Guillaume <fiette@lrde.epita.fr>

	Add the suffix and factor algorithms.

	* include/vaucanson/algorithms/factor.hh,
	include/vaucanson/algorithms/factor.hxx: Implement the
	factor algorithm.
	* include/vaucanson/algorithms/suffix.hh,
	include/vaucanson/algorithms/suffix.hxx: Implement the
	suffix algorithm.

2011-04-26  Fiette Guillaume <fiette@lrde.epita.fr>

	Add the prefix algorithm.

	* include/vaucanson/algorithms/prefix.hh,
	include/vaucanson/algorithms/prefix.hxx: Implementation of the
	prefix algorithm.

2011-04-07  Guillaume Fiette  <fiette@lrde.epita.fr>

	Update ChangeLog.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update file, for compilable with the RationalNumber.

        * vcsn/algebra/implementation/semiring/tropical_semiring.hxx:
    	The construction of null value is generic. RationalNumber
    	interface is available for this file.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update Numerical test for accept RationalNumber.

	* src/tests/include/tests/algebra/numerical_semiring/numerical_semiring_test.hh:
	Update the test. Now, the test accumulator is a float. The Overflow for the
	RationalNumber is deleted.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Add RationalNumber type for Xml reading.

	The Rational Number are defined on the Xml with the 'Q' letters.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update Generate for tests suites. Add RationalNumber.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Delete old contexts for RationalNumber class.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update Test for RationalNumber taf-kit.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update Context for RationalNumber class Tests.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Delete old interface for RationalNumber class.

        * include/vaucanson/algebra/implementation/semiring/rational_number.hh:
        Delete dead code for RationalNumber class.
        * include/vaucanson/algebra/implementation/semiring/rational_number.hxx:
        Delete dead code for RationalNumber class.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Correct bug in RationalNumber class.

	* include/vaucanson/algebra/implementation/semiring/q_number.hxx:
    	Correct bug for operator>> in the class RationalNumber.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Update op_parse specialized for RationalNumber
        * vcsn/algebra/implementation/semiring/numerical_semiring.hxx
        Write op_parse for accept Integer number (ie without the denominator
    	part).

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Optmize RationalNumber and correct bugs.
    	Fix Bugs:
    	* include/vaucanson/misc/algebra.hh:
    	* include/vaucanson/misc/algebra.hxx:
    		Fix the random Number.
    		Delete old version.
    	* include/vaucanson/algebra/implem/semiring/q_number.hh:
    	* include/vaucanson/algebra/implem/semiring/q_number.hxx:
    	Optimize multiplication, division, addition and soustraction.
    	Optimize comment for test debug.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Add context for test in src/test/test-suites
    	Add:
    	* algebra_numerical_semiring_q.defs
    	* algebra_tropical_semiring_max_q.defs
    	* algebra_tropical_semiring_min_q.defs

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Clean Rational Number files. Fix misc/random.hxx.

    	* vcsn/algebra/implementation/semiring/numerical_semiring.hxx
    	* include/vaucanson/algebra/implementation/semiring/q_number.hh
    	* include/vaucanson/algebra/implementation/semiring/q_number.hxx
    	Move gcd, lcm and is_coprime in misc/algebra.hh.
    	Must update misc/random.hxx on RationalNumber generate:
    	* include/vaucanson/misc/random.hxx

    	Delete for clean:
    	* include/vaucanson/algebra/implementation/semiring/q_semiring.hh

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Add test for Rational Number

    	Modified for include Rational Number test:
    	* configure.ac
    	* include/Makefile.am
    	* taf-kit/tests/Makefile.am
    	Add the Rational Number test:
    	* taf-kit/tests/vcsn-char-q.test

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Clean operator on Prime Number.

    	Delete :
    	* include/vaucanson/misc/algebra.cc
    	Add & Clean :
    	* include/vaucanson/misc/algebra.hh
    	* include/vaucanson/misc/algebra.hxx

2011-03-24  David Moreira <moreira@lrde.epita.fr>
	Fix reduce.hh bug

    	* include/vaucanson/algorithms/reduce.hxx: Fix bug.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Add Rational Number. Fix op_parse for RationalNumber class

    	op_parse must be specialized for RationalNumber.
    	Change Makefile.am and rb script for generate RationalNumber's
    	tak-kits.

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Include Rational Number on the projet

    	Modified file for compile into the project.
    	Include to tak-kit

    	Do not compile cause an undifined operator>>

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Create algreba.hh file in misc/ for prime number operation.

    	Implement gcd, lcm and is_coprime

2011-03-24  David Moreira <moreira@lrde.epita.fr>

	Rational Number impletation.

    	Add Header of rational number with the following file :
    	include/vaucanson/algebra/implementation/semiring/q_number.hh
    	Implementation on the following file :
    	include/vaucanson/algebra/implementation/semiring/q_number.hxx

2011-02-22  Guillaume Fiette  <fiette@lrde.epita.fr>

	Fix the semi_reduce algorithm.

	* include/vaucanson/algorithms/reduce.hxx: Fixed semi_reduce ()
	for make check. Make check failed because semi-reduce did not
	check for the automaton to be realtime.

2011-03-03  Guillaume Fiette  <fiette@lrde.epita.fr>

	Z/2Z semiring now uses booleans instead of integers.

	* algebra/implementation/semiring/cyclic_semiring.hxx,
	algebra/implementation/semiring/cyclic_semiring.hh: Specialized
	the cyclic semiring implementation for Z/2Z (Z/nZ with n = 2)
	using booleans.
	* include/vaucanson/contexts/z2z_semiring.thh: Modified the Z/2Z
	context accordingly.

2011-03-02  Guillaume Fiette  <fiette@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-z2z.test: Tests on Z/2Z are now valid.

2011-03-02  Guillaume Fiette  <fiette@lrde.epita.fr>

	Fix the quotient algorithm.

	* algorithms/minimization_hopcroft.hxx: Fix the quotient
	algorithm so it does not add transitions labeled by zero.
	This can happenens while working on a Z/2Z semiring.
	* xml/builders.hxx: Added a FIXME in the writer.

2011-03-02  Guillaume Fiette  <fiette@lrde.epita.fr>

	Fix bugged operations in the cyclic semiring.

	* algebra/implementation/semiring/cyclic_semiring.hxx: Fixed
	some bugged operations (op_in_star and choose_non_starable).

2011-02-20  Guillaume Fiette  <fiette@lrde.epita.fr>

	Deleted useless files.

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	More tests for the Z/2Z semiring.

	* taf-kit/tests/vcsn-char-z2z.test: Test for the Z/2Z
	semiring. Does not work as said before, but don't
	know why yet.

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	Add tests for the cyclic semiring in taf-kit.

	* configure.ac
	* src/tests/test-suites/generate-all.sh
	* taf-kit/tests/Makefile.am: Add tests for the Z/nZ
	semiring. Not working yet, seems there is a problem
	with the "proper" command during tests.

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	Fix some operations of the Z/2Z semiring.

	* Makefile.am: Add some missing dependencies.
	* implementation/semiring/cyclic_semiring.hxx: Modify basic
	operations (+, *, -, ...) to make them more generic and
	exact. Negative numbers are handled, but results will
	always be positive (positive equivalent modulo n).

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	Modification of Makefiles and scripts for the Z/2Z
	automaton.

	* include/Makefile.am: Added new .hh and .hxx to dependencies.
	* lib/Makefile.am: Added the new library vcsn-z2z to
	compilation process.
	* lib/generate_libvcsn.rb: Added the new z2z context, so that
	the Makefile for the library compilation is produced.
	* taf-kit/src/Makefile.am: Added the commands needed for
	the vcsn-char-z2z executable to be produced.

	Next step is to add tests.

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	Creation of a new context for Z/2Z semirings.

	* automata/generic_contexts/z2z_automaton.hh,
	automata/generic_contexts/z2z_automaton_structures.hh,
	contexts/z2z_semiring.thh,
	z2z_automaton.hh,
	z2z_automaton_structures.hh: Creation of a new context for
	automatons using the Z/2Z semiring. This is a restricted
	use of CyclicSemiring, representing Z/nZ. It uses
	integers for now. Any new automaton based on CyclicSemiring
	can be createdin the exact same way.

2011-02-19  Guillaume Fiette  <fiette@lrde.epita.fr>

	Beginning of the implementation of the new Z/2Z semiring.

	* implementation/semiring/cyclic_semiring.hh,
	implementation/semiring/cyclic_semiring.hxx: Implementation
	of the new cyclic semiring. This is a generic semiring over Z/nZ.
	Currently, most of the operations implemented might not be valid
	in some cases. Need more documentation as well.
	* algebra/concept/cyclic_semiring.hh,
	algebra/concept/cyclic_semiring.hxx: The concept associated to
	the new cyclic semiring. Might need some more documentation.

2011-01-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-r.test: remove the power(C_1^n) test
	case for n=5, it does not pass on all processors due to rounding
	issues.

2011-01-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/reduce.hxx (semi_reduce): Rename
	the two-argument version into...
	(do_semi_reduce): ... this to avoid complaint from sanity/hhck.
	Also fixup whitespace in the whole file.

2011-01-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/contexts/r_semiring.thh: Store values as
	double for better precision.

2011-01-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-r.test: Add more tests for reduce.

2011-01-27  Sylvain Lombardy  <lombardy@univ-mlv.fr>

	* include/vaucanson/algorithms/reduce.hh,
	include/vaucanson/algorithms/reduce.cc: Rewrite.

2011-01-20  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix multiple XML errors.  All but the first one are in the test
	suite.

	* include/vaucanson/xml/contexts/rw.hxx: Add missing type=numerical.
	* include/vaucanson/xml/regexp.hh: Typo in comment.
	* src/tests/common/xmldiff.sh: Make it a bit stronger.  The previous
	implementation would only test the inclusion of the set of line
	of one file into the set of lines of the other (i.e. without doing
	the reverse check, and ignoring duplicates).
	* src/tests/xml/int_fmp_ref.xml: Fix genSort to read 'integers' and
	not 'letters'.
	* src/tests/xml/int_trans_ref.xml,
	src/tests/xml/int_z_trans_ref.xml, src/tests/xml/trans_ref.xml,
	src/tests/xml/z_trans_ref.xml: Fix some syntax errors in the XML.
	* src/tests/xml/int_z_max_plus_ref.dot,
	src/tests/xml/int_z_min_plus_ref.dot,
	src/tests/xml/z_max_plus_ref.dot,
	src/tests/xml/z_min_plus_ref.dot: Adjust output to the recent
	changes about the way zmin and zmax weights are printed.
	* src/tests/xml/xml_int_trans_tester.cc,
	src/tests/xml/xml_int_z_trans_tester.cc,
	src/tests/xml/xml_trans_tester.cc,
	src/tests/xml/xml_z_trans_tester.cc: The default series is 0, so
	don't use that as a label, use the identity instead.

2011-01-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/include/tests/automata/implementation_check/epsilon_label_representation_test.hh (epsilon_label_representation_test): Honor show_identity_value.

2011-01-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix many errors reported by clang++.

	* include/vaucanson/algebra/implementation/series/krat_exp_is_finite_app.hxx,
	include/vaucanson/algebra/implementation/series/krat_exp_pattern.hh,
	include/vaucanson/algebra/implementation/series/krat_exp_support.hxx,
	include/vaucanson/algebra/implementation/series/krat_exp_transpose.hxx,
	include/vaucanson/algorithms/aci_canonical.hxx,
	include/vaucanson/algorithms/derived_term_automaton.hxx,
	include/vaucanson/algorithms/krat_exp_constant_term.hxx,
	include/vaucanson/algorithms/krat_exp_derivation.hxx,
	include/vaucanson/algorithms/krat_exp_expand.hxx,
	include/vaucanson/algorithms/krat_exp_flatten.hxx,
	include/vaucanson/algorithms/krat_exp_linearize.hxx,
	include/vaucanson/algorithms/krat_exp_realtime.hxx,
	include/vaucanson/algorithms/standard_of.hxx,
	include/vaucanson/design_pattern/element.hxx,
	include/vaucanson/misc/deferrer.hxx: Prefix template-dependant
	method calls with this->.
	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx,
	include/vaucanson/contexts/automaton_maker.thxx: Do not repeat
	default argument at definition time.
	* include/vaucanson/algorithms/berry_sethi.hxx: Do not rely on the
	operator= for Exp, use a constructor.

2011-01-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/bin/generate-test-suite.sh (test_dirs): Exclude
	names containing '#', such as emacs temporary files.

2011-01-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Delete the concatenate algorithm.

	concat_of_standard() can be used instead.

	* include/vaucanson/algorithms/concatenate.hh,
	include/vaucanson/algorithms/concatenate.hxx,
	src/tests/include/tests/automata/algos/label_aware_graphs/concat_test.hh,
	src/tests/include/tests/automata/algos/label_aware_graphs/in_concat_test.hh:
	Delete these files.
	* include/Makefile.am, src/tests/include/Makefile.am,
	include/vaucanson/contexts/automaton_functions.thh: Adjust.

2011-01-11  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Print {0} weights in zmin and zmax contexts.

	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hh,
	include/vaucanson/algebra/implementation/semiring/tropical_semiring.hxx,
	include/vaucanson/algebra/implementation/series/krat.hh,
	include/vaucanson/algebra/implementation/series/krat.hxx
	(show_identity_value): New function to distinguish between
	semirings where the 1 must be shown and semiring where it is
	superfluous.
	* include/vaucanson/algebra/implementation/series/polynoms.hxx
	(op_rout): Call show_identity_value() to decide whether to print
	the identity or not.
	* taf-kit/tests/vcsn-char-zmin.test: Make sure {0} is printed.

2011-01-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make aut-to-exp commands for DMChooser/HChooser/DefaultChooser.

	* include/vaucanson/algorithms/aut_to_exp.hh: Add INTERFACE
	for HChooser.
	* taf-kit/src/cmd_gen (aut_to_exp_DM, aut_to_exp_SO): New functions.
	* taf-kit/tests/vcsn-int-fmp-z.test: Use aut-to-exp-DM.

2011-01-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Ask for weight when declaring initial and final states in automata
	on tropical semirings.

	* taf-kit/src/Makefile.am (vcsn_char_zmax_CPPFLAGS,
	vcsn_char_zmin_CPPFLAGS): Add -DWITH_WEIGHTS.
	* taf-kit/tests/vcsn-char-zmax.test,
	taf-kit/tests/vcsn-char-zmin.test: Adjust.

2011-01-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (namespace): Mention the monoids
	in the descroption of -a -A -P and -Q.

2011-01-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Keep enumerate and shortest for boolean automata only, until
	their implementation is generalized.

	* taf-kit/src/cmd_wt.cc (enumerate, shortest): Move ...
	* taf-kit/src/cmd_b.cc (enumerate, shortest): ... here.

2011-01-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Sort command groups as in the manual.

	* taf-kit/src/cmd_b.cc, taf-kit/src/cmd_fmp.cc,
	taf-kit/src/cmd_r.cc, taf-kit/src/cmd_gen.cc,
	taf-kit/src/cmd_io.cc, taf-kit/src/cmd_pair.cc: Number command
	groups.
	* taf-kit/src/commands.cc (command_map::list): Strip the number
	from the command groups.

2010-12-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix a segfault in reduce().

	* include/vaucanson/algorithms/reduce.hxx (left_reduce): Fix what
	seems to be misplaced resize and that was causing segfault or
	illegal reads on some machines.
	* taf-kit/tests/vcsn-char-r.test: Add a test case suggested by
	Jacques Sakarovitch.

2010-12-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Change the 'list-automata' command as a '--list-automata' option.

	* taf-kit/src/main.cc (options, parse_opt): Add an option
	--list-automata.
	* taf-kit/src/cmd_io.cc (list_automata): Undeclare as a command.
	* taf-kit/src/library_commands.hh (get_automata_path,
	list_automata_command): Do not take the useless args argument.
	* taf-kit/tests/vcsn-char-b.test: Adjust usage.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-char-b.test,
	taf-kit/tests/vcsn-char-char-z.test,
	taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-int-b.test,
	taf-kit/tests/vcsn-char-z.test, taf-kit/tests/vcsn-int-b.test,
	taf-kit/tests/vcsn-int-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-z.test,
	taf-kit/tests/vcsn-int-int-b.test,
	taf-kit/tests/vcsn-int-int-z.test, taf-kit/tests/vcsn-int-z.test:
	Grep for 'alphabet.*predefined' instead of just 'predefined',
	because the latter occur in the help message for --list-automata.

2010-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Avoid boost::lexical_cast.

	* taf-kit/src/getters.cc (get_unsigned): Use std::stringstream for
	the conversion instead of boost::lexical_cast.  This removes one
	unnecessary dependency on Boost.

2010-11-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/getters.cc (locate_file): Typo.

2010-11-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Move the partial-identity command into the weighted TAF-Kit
	instances.

	* taf-kit/src/cmd_fmp.cc (partial_identity_command): Move...
	* taf-kit/src/cmd_wt.cc [FMPI_CONTEXT] (partial_identity_command):
	... here.
	* taf-kit/src/getters.cc: Include xml/contexts/fmp.hh if
	FMPI_CONTEXT is defined.
	* taf-kit/src/pipe.hh, taf-kit/src/pipe_writers.hh,
	taf-kit/src/pipe_writers.hxx: Add machinery to store FMP automata
	in the FMPI_CONTEXT.
	* taf-kit/src/Makefile.am: Define FMPI_CONTEXT and include
	the relevant library for all weighted automata that have
	an associated FMP context.
	* taf-kit/tests/vcsn-int-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test: Adjust calls to partial-identity.

2010-11-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Move the pair-to-fmp command into the "pair" TAF-Kit instances.

	* taf-kit/src/cmd_fmp.cc (pair_to_fmp_command): Move ...
	* taf-kit/src/cmd_pair.cc [FMP_CONTEXT] (pair_to_fmp_command):
	... here.
	* taf-kit/src/getters.cc: Include xml/context fmp.hh if
	FMP_CONTEXT is set.
	* taf-kit/src/pipe.hh, taf-kit/src/pipe_writers.hh,
	taf-kit/src/pipe_writers.hxx: Add machinery to store FMP automata.
	* taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-z.test: Adjust test cases.  pair-to-fmp
	is now in the vcsn-char-char-b or vcsn-int-int-z instance.

2010-11-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Create vcsn-char-char-b and vcsn-int-int-z.

	This is so that we can still test ltl-to-pair/pair-to-fmp after
	next patch.

	* configure.ac: Output taf-kit/tests/vcsn-char-char-z and
	taf-kit/tests/vcsn-int-int-z.
	* taf-kit/src/Makefile.am (vcsn-char-char-b, vcsn-int-int-z):
	Build these.
	* taf-kit/tests/vcsn-char-char-z.test,
	taf-kit/tests/vcsn-int-int-z.test: New files.
	* taf-kit/tests/Makefile.am (TESTS): Add them.

2010-11-09  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix failing krat_exp_linearize_structure-test.

	* src/tests/include/tests/algebra/series/krat/main/krat_exp_linearize_structure_test.hh
	(krat_exp_linearize_structure_test): Filter the linearized
	expression by hand, not using a hackish redefinition of <<.

2010-11-08  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Kill an infinite loop observed with
	algebra_series_krat_bool_string/krat_exp_linearize_structure-test.

	* include/vaucanson/algebra/implementation/monoid/str_words.hh,
	include/vaucanson/algebra/implementation/monoid/str_words.hxx
	(op_rout): Add second and third template parameters to
	std::basic_string<...>, otherwise
	algebra_series_krat_bool_string/krat_exp_linearize_structure-test
	goes into an infinite loop with FreeMonoidBase's op_rout()
	calling itself because it does not find the appropriate
	specialization.

2010-11-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Refuse "edit -", and honor the search path when editing automata.

	Partly based on previous patch by Alex Hamelin.

	* taf-kit/src/edition_commands.hxx (edit_command): Refuse "-" as
	argument, and honor the search path when loading automata.
	* taf-kit/src/library_commands.hh (get_automata_path): Do not
	warn about missing directories.
	* taf-kit/src/getters.cc, taf-kit/src/getters.hh (file_exists,
	locate_file): Make these functions public.

2010-11-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make aut-to-exp work on FMP transducers.

	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx
	(DumpVisitor::DumpVisitor): Take a reference to the monoid and store
	it.
	(DumpVisitor::constant): Use the monoid's op_rout() function
	to output the term.
	* include/vaucanson/algebra/implementation/series/krat.hxx
	(op_rout): Adjust call to DumpVisitor.
	* include/vaucanson/automata/generic_contexts/boolean_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/fmp_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/int_boolean_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/int_fmp_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/int_z_fmp_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/int_z_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/z_fmp_transducer_structures.hh,
	include/vaucanson/automata/generic_contexts/z_transducer_structures.hh:
	Always include <vaucanson/contexts/generic_series.thh> instead
	of <vaucanson/contexts/polynom_series.thh>.
	* include/vaucanson/contexts/fmp_transducer_maker.thh,
	include/vaucanson/contexts/fmp_transducer_maker.thxx (aut_to_exp):
	New function.
	* include/vaucanson/contexts/transducer_maker.thxx
	(make_automaton_set): New function.
	(make_automaton): Use it.
	* include/vaucanson/xml/contexts/fmp.hh
	(create_type_writingData_node, create_monoid_node): Add
	specializations for FMP.
	* include/vaucanson/xml/contexts/fmp.hxx
	(create_type_writingData_node, create_monoid_node): Overhaul so they
	can work on automata or rational expressions.
	* lib/generate_libvcsn.rb: Enable aut_to_exp.hh in transducer
	contexts.
	* taf-kit/src/cmd_wt.cc (aut_to_exp_command): Move ...
	* taf-kit/src/cmd_gen.cc (aut_to_exp_command): ... here.
	* taf-kit/src/pipe.hh, taf-kit/src/pipe_writers.hh,
	taf-kit/src/pipe_writers.hxx: Always support rat_exp_t.
	* taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-z.test: Add simple tests for aut-to-exp.

2010-10-19  Alex Hamelin  <hamelin@lrde.epita.fr>

	Remove deprecated files.

	* include/Makefile.am,
	include/vaucanson/xml/contexts/max_plus.hh,
	include/vaucanson/xml/contexts/max_plus.hxx,
	include/vaucanson/xml/contexts/min_plus.hh,
	include/vaucanson/xml/contexts/min_plus.hxx,
	src/tests/xml/xml_automaton_tester.cc: Remove xml max_plus and min_plus
	specific contexts.

2010-10-19  Alex Hamelin  <hamelin@lrde.epita.fr>

	Fix xml issue for tropical semirings.

	* include/vaucanson/xml/builders.hxx (get_semiring_operations): Add two
	specialization on tropical semirings.

2010-10-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Let TAF-Kit warn when an edited automaton is saved without initial
	or final states.

	* taf-kit/src/edition_commands.hxx (check_common_errors): New function.
	(ask_and_treat_choice): Call check_common_errors before saving.
	Also remove all uses of the CHOICE_COMMAND macro.

2010-10-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Report an error when attempting to read an empty file, and
	homogenize exit values.

	* taf-kit/src/getters.cc (file_exists, locate_file): New functions
	that signal an error when reading an empty file.
	(get_exp, get_aut, get_boolean_aut, get_pair_aut): Use locate_file.
	(get_unsigned): exit(1) on error.
	* taf-kit/tests/vcsn-char-b.test: Add a simple test.

2010-10-08  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make sure that config.hh is always included first by including
	common.hh (which includes config.hh) first in all files.

	* taf-kit/src/commands.hh: Include common.hh and getters.hh.
	* taf-kit/src/cmd_fmp.cc, taf-kit/src/cmd_gen.cc,
	taf-kit/src/cmd_io.cc, taf-kit/src/cmd_pair.cc,
	taf-kit/src/cmd_r.cc, taf-kit/src/cmd_wt.cc,
	taf-kit/src/commands.cc: Simplify. Since these include
	commands.hh, they do not need to include common.hh and getters.hh.

2010-10-08  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Update to gnulib a1885e2dc2a8f1c79ead4e6ceca1a53827b89048.

	* build-aux/link-warning.h, gnulib/basename.c, gnulib/error.c,
	gnulib/error.h, gnulib/exitfail.c, gnulib/exitfail.h,
	gnulib/xalloc-die.c, gnulib/xalloc.h, gnulib/xmalloc.c,
	gnulib/xstrndup.c, gnulib/xstrndup.h, m4/error.m4, m4/exitfail.m4,
	m4/inline.m4, m4/wchar.m4, m4/xalloc.m4, m4/xstrndup.m4: Delete
	all these files.
	* build-aux/arg-nonnull.h, build-aux/c++defs.h,
	build-aux/warn-on-use.h, gnulib/basename-lgpl.c, gnulib/memchr.c,
	gnulib/memchr.valgrind, gnulib/stddef.in.h, gnulib/verify.h,
	m4/asm-underscore.m4, m4/memchr.m4, m4/mmap-anon.m4,
	m4/stddef_h.m4, m4/warn-on-use.m4, m4/wchar_h.m4: New files.
	* build-aux/.gitignore, gnulib/alloca.c, gnulib/alloca.in.h,
	gnulib/argp-ba.c, gnulib/argp-eexst.c, gnulib/argp-fmtstream.c,
	gnulib/argp-fmtstream.h, gnulib/argp-fs-xinl.c, gnulib/argp.h,
	gnulib/argp-help.c, gnulib/argp-namefrob.h, gnulib/argp-parse.c,
	gnulib/argp-pin.c, gnulib/argp-pv.c, gnulib/argp-pvh.c,
	gnulib/argp-xinl.c, gnulib/asnprintf.c, gnulib/dirname.h,
	gnulib/errno.in.h, gnulib/float+.h, gnulib/float.in.h,
	gnulib/getopt1.c, gnulib/getopt.c, gnulib/getopt.in.h,
	gnulib/getopt_int.h, gnulib/gettext.h, gnulib/intprops.h,
	gnulib/Makefile.am, gnulib/malloc.c, gnulib/mempcpy.c,
	gnulib/printf-args.c, gnulib/printf-args.h, gnulib/printf-parse.c,
	gnulib/printf-parse.h, gnulib/progname.c, gnulib/progname.h,
	gnulib/rawmemchr.c, gnulib/size_max.h, gnulib/sleep.c,
	gnulib/stdbool.in.h, gnulib/stdint.in.h, gnulib/stdio.in.h,
	gnulib/stdio-write.c, gnulib/stdlib.in.h, gnulib/strcasecmp.c,
	gnulib/strchrnul.c, gnulib/strerror.c, gnulib/string.in.h,
	gnulib/strings.in.h, gnulib/stripslash.c, gnulib/strncasecmp.c,
	gnulib/strndup.c, gnulib/strnlen.c, gnulib/sysexits.in.h,
	gnulib/unistd.in.h, gnulib/vasnprintf.c, gnulib/vasnprintf.h,
	gnulib/vsnprintf.c, gnulib/wchar.in.h, gnulib/xsize.h,
	m4/00gnulib.m4, m4/alloca.m4, m4/argp.m4, m4/dirname.m4,
	m4/dos.m4, m4/double-slash-root.m4, m4/errno_h.m4,
	m4/extensions.m4, m4/float_h.m4, m4/getopt.m4, m4/gnulib-cache.m4,
	m4/gnulib-common.m4, m4/gnulib-comp.m4, m4/gnulib-tool.m4,
	m4/include_next.m4, m4/intmax_t.m4, m4/inttypes_h.m4,
	m4/longlong.m4, m4/malloc.m4, m4/mempcpy.m4, m4/multiarch.m4,
	m4/printf.m4, m4/rawmemchr.m4, m4/size_max.m4, m4/sleep.m4,
	m4/stdbool.m4, m4/stdint_h.m4, m4/stdint.m4, m4/stdio_h.m4,
	m4/stdlib_h.m4, m4/strcase.m4, m4/strchrnul.m4, m4/strerror.m4,
	m4/string_h.m4, m4/strings_h.m4, m4/strndup.m4, m4/strnlen.m4,
	m4/sysexits.m4, m4/unistd_h.m4, m4/vasnprintf.m4, m4/vsnprintf.m4,
	m4/wchar_t.m4, m4/wint_t.m4, m4/xsize.m4: Update.
	* gnulib/dirname.c: Rename as ...
	* gnulib/dirname-lgpl.c: ... this.

2010-09-30  Alex Hamelin  <hamelin@lrde.epita.fr>

	Add a Boost Spirit compatibility macro to TAF-Kit.

	* taf-kit/src/Makefile.am: Add
	taf-kit/src/boost_spirit_compatibility.hh.
	* taf-kit/src/boost_spirit_compatibility.hh (VCSN_SPIRIT_CLASSIC):
	Define a new macro handling namespace changes which occurred in the
	last versions of Boost Spirit.
	* taf-kit/src/getters.cc, taf-kit/src/parser_options.hh,
	taf-kit/src/parser_options.hxx: Use VCSN_SPIRIT_CLASSIC macro.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make is-unambiguous available to all TAF-Kit instance on free
	monoids.

	* taf-kit/src/cmd_b.cc (is_unambiguous_command): Move ...
	* taf-kit/src/cmd_wt.cc (is_unambiguous_command): ... here.
	* taf-kit/tests/vcsn-char-zmin.test: Add tests
	for is-unambiguous.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	"commands_macros.hh" no longer exist.

	* taf-kit/src/Makefile.am (COMMON_SOURCES): Remove commands_macros.hh.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Use sections in -l and -L.

	* taf-kit/src/commands.cc (list): Display commands section by
	section.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Cleanup op_is_atom() declarations.  This also avoid an infinite
	loop with op_is_atom() from monoid_base.hxx possibly calling
	itself when no implementation matches.

	* include/vaucanson/algebra/concept/monoid_base.hh,
	include/vaucanson/algebra/concept/monoid_base.hxx (is_atom,
	op_is_atom): Remove from the abstract interface.  It needs only
	to be in the implementation interface.
	* include/vaucanson/algebra/implementation/monoid/pair_str_words.hh,
	include/vaucanson/algebra/implementation/monoid/pair_str_words.hxx,
	include/vaucanson/algebra/implementation/monoid/str_words.hh,
	include/vaucanson/algebra/implementation/monoid/str_words.hxx
	(op_is_atop): Use the three template parameters of basic_string,
	otherwise some call to op_is_atom() will fail to find a matching
	function.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make the hulden demo work with the new TAF-Kit commands.

	* taf-kit/demos/hulden/run.in: Adjust to the new semantics.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Declare commands on alphabets of pairs.

	* taf-kit/src/cmd_pair.cc: Fill in
	* taf-kit/src/Makefile.am (vcsn_char_char_b_SOURCES,
	vcsn_char_int_b_SOURCES, vcsn_int_int_b_SOURCES): Add cmd_pair.cc.
	* tests/vcsn-char-char-b.test, tests/vcsn-char-int-b.test,
	tests/vcsn-int-int-b.test: Adjust to new names.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Include "reduce" in vcsn-char-r so it passes its tests.

	* taf-kit/src/cmd_r.cc: Fill in.
	* taf-kit/src/Makefile.am (vcsn_char_r_SOURCES): Add cmd_r.cc.
	* taf-kit/tests/vcsn-char-r.test: Adjust to new names.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Augment the list of FMP commands and update the tests cases
	for TAF-Kit's FMP instances.

	* taf-kit/src/cmd_fmp.cc (is_normalized, normalized, to_rw):
	Add as hidden commands.
	(transpose, domain, image): New commands.
	* taf-kit/src/getters.hh [WITH_TWO_ALPHABETS] (get_pair_aut,
	get_boolean_aut): Declare these functions.
	* taf-kit/src/Makefile.am (vcsn_char_fmp_b_SOURCES,
	vcsn_char_fmp_z_SOURCES, vcsn_int_fmp_b_SOURCES,
	vcsn_int_fmp_z_SOURCES): Add cmd_fmp.cc.
	* taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-int-fmp-z.test: Adjust to new command names.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Enable cmd_gen.cc to compile for TAF-Kit's FMP instances.

	* lib/generate_libvcsn.rb (standard.hh): Instanciate it also for
	transducers.
	* include/vaucanson/contexts/transducer.thh: Define the type
	gen_automaton_t in transducer contexts too.

2010-10-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce op_is_atom() on all monoids, and use it.

	Some trivial simplification performed in krat_exp operations
	assumed words were defined over a free-monoid implemented as a
	string.  For instance the rewriting 'c{k} -> {k}c' was performed
	any time 'c' was a letter or a constant, but the concept of letter
	makes no sense if the monoid is not free.  Rewrite this code using
	op_is_atom() to be generic.

	* include/vaucanson/algebra/concept/monoid_base.hh,
	include/vaucanson/algebra/concept/monoid_base.hxx
	(monoid::is_atom, op_is_atom): New methods.
	* include/vaucanson/algebra/implementation/monoid/pair_str_words.hh,
	include/vaucanson/algebra/implementation/monoid/pair_str_words.hxx,
	include/vaucanson/algebra/implementation/monoid/str_words.hh,
	include/vaucanson/algebra/implementation/monoid/str_words.hxx
	(op_is_atom): Implement it for words and pairs of words.
	* include/vaucanson/algebra/implementation/series/krat.hxx
	(op_in_mul): Use op_is_atom() instead of checking the size of
	the node explicitly.

2010-10-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/getters.hh, taf-kit/src/getters.hxx,
	taf-kit/src/library_commands.hh: Do not include
	vaucanson/xml/contexts/fmp.hh, it is only needed in getters.cc.
	* b/taf-kit/src/cmd_fmp.cc: Add missing includes.

2010-10-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Define FMP commands.  (TAF-Kit instances for FMP do not yet
	compile, because many functions from cmd_gen.cc assume automata,
	not transducers.)

	* taf-kit/src/cmd_fmp.cc: Fill in.
	* taf-kit/src/cmd_gen.cc (aut_to_exp, expand, exp_to_aut): Move
	these...
	* taf-kit/src/cmd_io.cc (cat_E): ... and this ...
	* taf-kit/src/cmd_wt.cc: ... here, because rat_exp_t is not
	defined in FMP contexts.

2010-10-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	vcsn-char-z and vcsn-int-z pass their tests.

	* taf-kit/src/cmd_wt.cc (realtime_E_command): New command (was
	realtime-exp and former version of TAF-Kit).
	* taf-kit/tests/vcsn-int-z.test, taf-kit/tests/vcsn-int-z.test:
	Adjust the test to the new name of the commands.

2010-09-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	vcsn-char-b and vcsn-int-b pass their tests.

	* taf-kit/tests/vcsn-char-b.test, taf-kit/tests/vcsn-int-b.test:
	Adjust the test to the new name of the commands.
	* taf-kit/src/Makefile.am: Update to compile vcsn-int-b.

2010-09-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	This is an incomplete work on TAF-Kit.  Only vcsn-char-b is
	expected to compile, and the test suite should not pass because
	many TAF-Kit commands have been renamed.

	* taf-kit/src/interface.cc, taf-kit/src/interface.hh,
	taf-kit/src/b_commands.cc, taf-kit/src/b_commands.cc,
	taf-kit/src/commands_macros.hh,
	taf-kit/src/common_automaton_commands.hh,
	taf-kit/src/common_commands.hh, taf-kit/src/fmp_commands.cc,
	taf-kit/src/interface.cc, taf-kit/src/ratexp_commands.hh,
	taf-kit/src/z_commands.cc: Delete all these files.
	* cmd_io.cc, cmd_gen.cc, cmd_wt.cc, cmd_b.cc, cmd_r.cc,
	cmd_fmp.cc, cmd_pair.cc: New files to declare commands according
	to the sections of the manual.  The last three files are
	not yet filled.
	* taf-kit/src/commands.hh: Declare a new command_map interface.
	* taf-kit/src/commands.cc: New file.
	* taf-kit/src/getters.hh (write_aut, display_aut): New functions.
	* taf-kit/src/getters.hxx: Move most functions into ...
	* taf-kit/src/getters.cc: ... this new file, so they get compiled
	separately.
	* taf-kit/src/main.cc: Adjust to the new interface.
	* taf-kit/src/Makefile: Adjust only fo r

2010-06-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Get rid of all command-defining macros.

	The handwritten definitions are slightly larger, but they are more
	readable and easier to debug and hack.

	* taf-kit/src/commands_macros.hh (NAME, ARG_KIND, ALGO, ALGOS)
	(CODE, RETURNVALUE, KEEP, PRINT_RESULT, OUTPUT, OUTPUT_ON_VERBOSE)
	(DEFINE_COMMAND_, DEFINE_COMMAND, DEFINE_ONE_ARG_COMMAND_)
	(DEFINE_ONE_ARG_COMMAND_TWO_ALGOS_, DEFINE_TWO_ARGS_COMMAND_)
	(DEFINE_IS_PROPERTY_COMMAND): Remove all these macros.
	* taf-kit/src/fmp_commands.cc, taf-kit/src/b_commands.cc,
	taf-kit/src/common_automaton_commands.cc,
	taf-kit/src/common_commands.hh, taf-kit/src/r_commands.cc,
	taf-kit/src/ratexp_commands.hh: Define all commands without this
	macros.

2010-06-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename global_result as g_res to simplify handwritten code.

	* taf-kit/src/commands_macros.hh, taf-kit/src/common.hh,
	taf-kit/src/common_automaton_commands.hh, taf-kit/src/getters.hxx,
	taf-kit/src/main.cc: Rename all instances.

2010-06-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Remove init() and finalize() calls from PRINT_RESULT().

	* taf-kit/src/commands_macros.hh (PRINT_RESULT): Write directly to
	the stream.  Do not call global_result.init() and
	global_result.finalize().
	* taf-kit/src/common_automaton_commands.hh (enumerate): Likewise.
	* taf-kit/src/main.cc (main): Call global_result.finilize() after
	each command.
	* taf-kit/src/pipe.hh (init): Remove.
	* taf-kit/src/pipe.hxx (init): Remove.  Clearing the stream
	is done in finalize() if the stream has been used.
	(finalize): Check if the stream has received anything.  Dump it to
	the output if it is the case.

2010-06-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Get rid of SET_RETURN_VALUE().

	* taf-kit/src/commands_macros.hh (DEFINE_COMMAND_): Do not
	call SET_RETURN_VALUE, the status of the command is already
	set in main() using the return value of execute_command().
	(SET_RETURN_VALUE): Delete.

2010-05-31  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce is-normalized and normalized in TAF-Kit.

	* taf-kit/src/common_commands.hh: Define normalize and is-normalized.
	* taf-kit/src/common_automaton_commands.hh: List normalize.
	* taf-kit/src/b_commands.cc, taf-kit/src/r_commands.cc,
	taf-kit/src/z_commands.cc: List is-normalized.
	* taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-b.test: Add tests for is-normalized and
	normalize.

2010-05-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename "eps-removal" as "proper".

	* taf-kit/src/common_automaton_commands.hh,
	taf-kit/src/common_commands.hh, taf-kit/src/fmp_commands.cc,
	taf-kit/tests/vcsn-char-r.test, taf-kit/tests/vcsn-int-fmp-z.test:
	Do it.

2010-05-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce is_proper().

	* include/vaucanson/algorithms/eps_removal.hxx,
	include/vaucanson/algorithms/eps_removal.hh (do_is_proper,
	is_proper): New functions.
	* taf-kit/src/common_commands.hh (is_proper): New command.
	* taf-kit/src/b_commands.cc, taf-kit/src/fmp_commands.cc,
	taf-kit/src/r_commands.cc, taf-kit/src/z_commands.cc: Declare
	is-proper.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test: Test is-proper.

2010-05-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Simplify is_ltl().

	* include/vaucanson/algorithms/is_ltl.hxx (is_ltl): Simplify
	condition.

2010-05-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename edit-automaton as edit, and make it explicit how to save.

	* taf-kit/src/common_commands.hh: Rename edit-automaton as edit.
	* taf-kit/src/edition_commands.hh,
	taf-kit/src/edition_commands.hxx: Rename edit_automaton_command()
	as edit_command(), and add replace "10. Exit" by "10. Save & exit"
	and "11. Exit".  (Students used to ask how to save the automaton.)
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-char-b.test,
	taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-int-b.test,
	taf-kit/tests/vcsn-char-z.test, taf-kit/tests/vcsn-char-zmax.test,
	taf-kit/tests/vcsn-char-zmin.test, taf-kit/tests/vcsn-int-b.test,
	taf-kit/tests/vcsn-int-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-z.test,
	taf-kit/tests/vcsn-int-int-b.test, taf-kit/tests/vcsn-int-z.test:
	Rename edit-automaton as edit.

2010-05-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>
            Pierre-Yves Angrand  <pangrand@gmail.com>

	Add new rules for some trivial identities with weights.

	* include/vaucanson/algebra/implementation/series/krat.hxx: New
	Rewrite ({k'} (E {k''}) {k} as {k'} (E {k''k}),
	and  ({k'} 1) {k} as {k'k} 1.
	* taf-kit/tests/vcsn-char-z.test: Test these.

2010-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Add tests for derived-term.

2009-06-11  Alexandre Duret-Lutz  <adl@lrde.epita.fr>
            Pierre-Yves Angrand  <pangrand@gmail.com>

	Attempt to fix derived-term, at least for Boolean automata.

	* include/vaucanson/algorithms/internal/partial_rat_exp.hxx
	(PartialExp::insert): Break the left terms of leading products
	in the partial rational expressions.
	(prat_exp_list): Delete, insert does the work now.
	(prat_exp_convert): Use insert directly instead of calling
	prat_exp_list.
	* include/vaucanson/algorithms/internal/partial_rat_exp.hh
	(PartialExp::insert): Adjust prototype.

2010-05-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Integrate Sylvain Lombardy's shortest() and enumerate()
	algorithms.

	* include/vaucanson/algorithms/shortest.hh,
	include/vaucanson/algorithms/shortest.hxx: New files.
	* include/vaucanson/contexts/automaton_functions.thh: Include
	them.
	* include/vaucanson/misc/military_order.hh: New file.
	* include/Makefile.am: Distribute the above three new files.
	* taf-kit/src/common_automaton_commands.hh: Add code for shortest
	and enumerate.
	* taf-kit/src/getters.hh, taf-kit/src/getters.hxx (get_unsigned):
	New function, used by enumerate_command.
	* taf-kit/tests/vcsn-char-b.test: Test shortest and enumerate.
	* lib/generate_libvcsn.rb: Do not try to compile shortest.hh for
	FMP contexts.
	* doc/manual/taf-kit-manual.tex (Interactive Definition of
	Automata): Adjust.

2010-05-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce one_eps_closure() and rewrite standard.hh algorithms
	using it.

	* include/vaucanson/algorithms/one_eps_closure.hh,
	include/vaucanson/algorithms/one_eps_closure.hxx: New files
	originally written by Sylvain Lombardy for Vaucanson 2, and
	adapted to this code base.
	* include/vaucanson/algorithms/standard.hh,
	include/vaucanson/algorithms/standard.hxx: Rewriting of
	most algorithms by Jacques Sakarovitch for Vaucanson 2,
	and then backported to this code base.
	* include/vaucanson/algorithms/standard_of.hxx: Adjust calls,
	and use functions of standard.hh when appropriate.
	* include/vaucanson/algorithms/sum.hh,
	include/vaucanson/algorithms/sum.hxx: Delete.
	* include/Makefile.am: Remove sum.hh and sum.hxx, add
	one_eps_closure.hh and one_eps_closure.hxx.
	* include/vaucanson/algebra/implementation/series/polynoms.hh,
	include/vaucanson/algebra/implementation/series/polynoms.hxx:
	Add a op_starable() specialization that matches the test
	in the op_in_star() specialization.
	* include/vaucanson/algorithms/normalized.hxx: Call
	union_here() instead of sum_here() and adjust include.
	* include/vaucanson/contexts/automaton_functions.thh: Do not
	include sum.hh.
	* taf-kit/src/common_automaton_commands.hh: Rename sum to union_
	and union_of_standard to sum_of_standard.
	* src/tests/include/tests/automata/algos/label_aware_graphs/sum_test.hh:
	Rename as ...
	* src/tests/include/tests/automata/algos/label_aware_graphs/union_test.hh:
	... this and change calls to sum() as calls to union_().
	* src/tests/include/Makefile.am (noinst_HEADERS): Adjust.
	* taf-kit/tests/vcsn-char-z.test, taf-kit/tests/vcsn-char-r.test:
	Rename calls to union-of-standard as sum-of-standard.
	* taf-kit/tests/vcsn-char-b.test: Add a test case for standard.
	* taf-kit/tests/vcsn-char-r.test: New tests for standard and
	quotient.

2010-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Disable the 'ascii' alphabet.

	Presently we cannot parse 'a ++ b' with the ascii alphabet even if
	OP_PLUS=++.  The above is parsed as the concatenation of six
	ascii letters.

	* taf-kit/src/predefined_alphabets.hxx (predefined_alphabets):
	Remove the ascii entry.
	* doc/manual/taf-kit-manual.tex (Character alphabets): Do not
	mention the ascii alphabet.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-z.test: Disable all tests that use
	the ASCII alphabet, or rewrite them using another alphabet.

2010-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/HACKING.txt: Typo.

2010-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix code for detection of OpenFST.

	* configure.ac (fstcompile): Run it in a subshell to hide the
	error message if it is missing.

2010-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac (DISTCHECK_CONFIGURE_FLAGS): Add missing quotes.

2009-09-30  Jérôme Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo in lrde-upload.sh.

	* lrde-upload.sh: Replace why by while.

2009-09-22  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac: Bump version to 1.3.2a.
	* doc/manual/taf-kit-manual.tex: Likewise.

2009-09-22  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac: Bump version to 1.3.2.
	* doc/manual/taf-kit-manual.tex: Likewise.

2009-09-21  d-halluin  <d-halluin@lrde.epita.fr>

	Distribute CSB under GPL in Vaucanson.

	* cbs/COPYING: New license text (same as ./COPYING).
	* cbs/README: Updated to reflect the changes.
	* cbs/configure.ac: Header changed by hand.
	* cbs/Makefile.am,
	* cbs/cbs.mk,
	* cbs/demo/Makefile.am,
	* cbs/demo/bench/Makefile.am,
	* cbs/demo/bench/main.cc,
	* cbs/demo/comparison/Makefile.am,
	* cbs/demo/comparison/main.cc,
	* cbs/demo/memplot-bench/Makefile.am,
	* cbs/demo/memplot-bench/main.cc,
	* cbs/demo/memplot/Makefile.am,
	* cbs/demo/memplot/main.cc,
	* cbs/demo/timer-bench/Makefile.am,
	* cbs/demo/timer-bench/main.cc,
	* cbs/demo/timer/Makefile.am,
	* cbs/demo/timer/main.cc,
	* cbs/include/Makefile.am,
	* cbs/include/cbs/bench/bench.hh,
	* cbs/include/cbs/bench/bench_internals.hh,
	* cbs/include/cbs/bench/bench_macros.hh,
	* cbs/include/cbs/bench/internal/timer_gathering.hh,
	* cbs/include/cbs/bench/internal/timer_gathering.hxx,
	* cbs/include/cbs/bench/internal/timer_graph.hh,
	* cbs/include/cbs/bench/internal/timer_graph.hxx,
	* cbs/include/cbs/bench/memplot.hh,
	* cbs/include/cbs/bench/timer.hh,
	* cbs/include/cbs/bench/timer.hxx,
	* cbs/lib/Makefile.am,
	* cbs/lib/bench.cc,
	* cbs/lib/memplot.cc,
	* cbs/lib/timer.cc,
	* cbs/lib/timer_gathering.cc,
	* cbs/lib/timer_graph.cc: Header automatically updated.

2009-09-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/NEWS.txt: Prepare for release 1.3.2.

2009-09-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/generate_headers.sh: Also erase context files directly
	generated in vaucanson/include/vaucanson/, not only those in
	vaucanson/include/vaucanson/contexts/.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Propagate configure arguments to distcheck.

	* configure.ac (DISTCHECK_CONFIGURE_FLAGS): Substitute it from
	here, and include $ac_configure_args.
	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Remove.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/README.txt: Update instructions for building with Boost
	and Xerces in a non-standard directory.  Move the "Requirements"
	section before these instructions.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Eradicate empty variables tied to --with options.

	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Remove
	MORE_DISTCHECK_CONFIGURE_FLAGS.
	* vaucanson.mk (AM_CPPFLAGS): Remove BOOST_FLAGS.
	(AM_LDFLAGS): Remove.
	* taf-kit/src/Makefile.am (AM_LDFLAGS): Set with =, not +=.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Remove --with-xerces.

	* build-aux/vcsn-xml.m4: Rewrite using a more recent syntax, and
	without using --with.  People will set CPPFLAGS and LDFLAGS if
	they have an unusual Boost installation root.  Take the minimum
	version as argument.
	* configure.ac: Adjust call to VCSN_XML, and remove the definition
	of MORE_DISTCHECK_CONFIGURE_FLAGS.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Do not use AX_BOOST_BASE.

	* build-aux/ax_boost_base.m4: Delete.
	* build-aux/Makefile.am (dist_m4data_DATA): Remove
	ax_boost_base.m4.
	* build-aux/vcsn-boost.m4: New file.
	* configure.ac: Use VCSN_BOOST instead of AX_BOOST_BASE.  The
	latter did too much and we want people to simply set CPPFLAGS
	and LDFLAGS if they have an unusual Boost installation root.

2009-09-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/generate_headers.sh: Use the full name to erase a file.

2009-09-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/generate_headers.sh: Remove stray context files.

2009-09-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	More make portability for FreeBSD.

	* data/automata/char-z/Makefile.am (b1.xml): Do not use $< in a
	non-suffix rules.

2009-09-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix run-time computation of automata path.

	* taf-kit/src/library_commands.hh (get_automata_path): Search for
	vcsn- in program_name, do not assume it is at the beginning.  This
	was causing trouble when Taf-Kit was run as './vcsn-char-b' for
	instance, because it would then remove the first five characters
	and look for a directory named '/n-char-b'.

2009-09-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix configure-time computation of VCSN_DATA_PATH.

	* configure.ac (VCSN_DATA_PATH): Fix underquoted code in $prefix
	computation.  This was causing the wrong value of VCSN_DATA_PATH
	to be defined on my test installation on FreeBSD.

2009-09-14  d-halluin  <d-halluin@lrde.epita.fr>

	Update benchmark documentation.

	* src/bench/README,
	* src/bench/common/README_AUTOMATA: Update.
	* src/bench/common/Makefile.am: Add file.
	* src/bench/common/bench_constructs.cc: New program, generate a
	sample of the benchmark automata in dot format.

2009-09-11  d-halluin  <d-halluin@lrde.epita.fr>

	Remove seq in benchmarks.

	* src/bench/composition/Makefile.bench,
	* src/bench/derived_terms/Makefile.bench,
	* src/bench/determinization/Makefile.bench,
	* src/bench/eps_removal/Makefile.bench,
	* src/bench/eval/Makefile.bench,
	* src/bench/minimization/Makefile.bench,
	* src/bench/product/Makefile.bench,
	* src/bench/quotient/Makefile.bench: List all the values instead.

2009-09-11  d-halluin  <d-halluin@lrde.epita.fr>

	Remove --with-openfst.

	* configure.ac: Enable OpenFST benchmarks if fstcompile
	is accessible from the current PATH.

2009-09-07  d-halluin  <d-halluin@lrde.epita.fr>

	Update CBS.

	CBS version: f19d09ad8c6566888b72a87bbed5aa628da3dbf1.
	See cbs/Changelog.

2009-09-04  d-halluin  <d-halluin@lrde.epita.fr>

	Update CBS.

	CBS version: 01c2191d02af066c21e04e6247c78778155d6724.
	See cbs/Changelog.

2009-09-04  d-halluin  <d-halluin@lrde.epita.fr>

	Fix .gitignore.

	* .gitignore: Do not ignore *.in files,
	ignore Makefile.in instead.

2009-09-08  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* bootstrap: force Automake-1.11 if available.

2009-09-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/Makefile.am (.txt.tex, .tex.pdf): Rewrite as a single
	.txt.pdf rule, to please BSD Make.
	* doc/manual/Makefile.am (%.pdf: %.tex): Rewrite as a portable
	.tex.pdf rule.

2009-09-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/unit-compile.mk: Delete this unused Makefile that uses
	unportable %-rules.
	* doc/Makefile.am (dist_doc_DATA): Remove.

2009-09-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Switch to Libtool 2.2, which is more that one year old now.

	* configure.ac: Use LT_INIT instead of AC_PROG_LIBTOOL.

2009-09-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Let Automake 11.1 handle parallel and color tests.

	* configure.ac: Require Automake 1.11 and use the new
	color-tests and parallel-tests options.
	* build-aux/check.mk: Delete.
	* src/tests/check/check.mk, src/tests/xml/Makefile.am,
	taf-kit/tests/Makefile.am: Do not include build-aux/check.mk
	anymore.

2009-07-08  Alex Hamelin  <hamelin@lrde.epita.fr>

	* configure.ac: Bump version to 1.3.1a.
	* doc/manual/taf-kit-manual.tex: Likewise.

2009-07-08  Alex Hamelin  <hamelin@lrde.epita.fr>

	Release 1.3.1.

	* doc/README.txt: Add information about CBS, Remove
	information about VaucanSWIG.
	* doc/NEWS.txt: Update for 1.3.1.
	* doc/manual/taf-kit-manual.tex: Likewise.
	* configure.ac: Bump version to 1.3.1.

2009-07-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix standard_of() w.r.t. listg.

	* include/vaucanson/algorithms/standard_of.hxx
	(Standard_OfVisitor): After concatenating to automata, and before
	erasing the obsolete initial state of the RHS, do not explicitly
	erase the transition leaving that initial state.  This is useless
	because del_state() already does the work.  This was bogus because
	del_transition invalidates the delta_iterator in the listg
	implementation.
	* include/vaucanson/algorithms/standard.hxx: Typos.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make listg the default graph implementation, since we now know
	that bmig is slower.

	* configure.ac (ac_default_graph_impl): Make listg the default.
	* doc/README.txt: Adjust documentation of --default-graph-impl.

2009-08-02  Jérôme Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo in generate_bench.sh.

	* src/bench/generate_bench.sh: Remove the e letter introduced by
	commit b29a54029698aa76b7c4b4218f43e56ce8e7c739.

2009-07-29  d-halluin  <d-halluin@lrde.epita.fr>

	Tweak eval benchmark.

	* src/bench/eval/Makefile.bench: Tweak sequence for aut_b bench.
	* src/bench/eval/eval_aut_b_bench.hh: Remove debug output, fix display.

2009-07-29  d-halluin  <d-halluin@lrde.epita.fr>

	Bench: rename parameter "over" into "context".

	* src/bench/product/product_aut_b_bool_bench.hh,
	* src/bench/product/product_aut_b_z_bench.hh: Do that.

2009-07-29  d-halluin  <d-halluin@lrde.epita.fr>

	Add eval benchmark.

	* configure.ac: Add Makefile.
	* src/bench/Makefile.am,
	* src/bench/generate_bench.sh: Add directory.
	* src/bench/eval/Makefile.bench,
	* src/bench/eval/eval_aut_b_bench.hh,
	* src/bench/eval/eval_aut_ladybird_bench.hh,
	* src/bench/eval/eval_aut_ladybird_determinized_bench.hh:
	New. Implementation

2009-07-16  d-halluin  <d-halluin@lrde.epita.fr>

	Update .gitignore in benchmarks.

	* src/bench/.gitignore: Update.

2009-07-15  d-halluin  <d-halluin@lrde.epita.fr>

	Add determinize benchmark on ladybird.

	* src/bench/common/README_AUTOMATA,
	* src/bench/common/bench_constructs.hh: Add ladybird.
	* src/bench/determinization/Makefile.bench: Add case.
	* src/bench/determinization/determinization_aut_ladybird_bench.hh,
	* src/bench/determinization/determinization_aut_ladybird_openfst_bench.hh:
	New.  Implementation.

2009-07-15  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: d0cef86a72e495219ff5e3d63d081b9baefe2cf2.
	See cbs/Changelog.

2009-07-15  d-halluin  <d-halluin@lrde.epita.fr>

	Add README_AUTOMATA in EXTRA_DIST.

	* src/bench/common/Makefile.am: Do that.

2009-06-19  d-halluin  <d-halluin@lrde.epita.fr>

	Add benchmark for product.

	* configure.ac,
	* src/bench/Makefile.am,
	* src/bench/generate_bench.sh: Add new makefiles/directories.
	* src/bench/product/Makefile.bench,
	* src/bench/product/product_aut_b_bool_bench.hh,
	* src/bench/product/product_aut_b_z_bench.hh: New. Implementation.

2009-06-19  d-halluin  <d-halluin@lrde.epita.fr>

	Benchmarks: rename aut_ab into aut_b.

	* src/bench/common/bench_constructs.hh,
	* src/bench/quotient/quotient_bool_bench.hh,
	* src/bench/quotient/quotient_z_bench.hh: Do that.

2009-06-19  d-halluin  <d-halluin@lrde.epita.fr>

	Update accessible benchmark.

	* src/bench/accessible/Makefile.bench: Adjust benchmark values.
	* src/bench/accessible/accessible_bench.hh,
	* src/bench/common/bench_constructs.hh: Move automaton creation.

2009-06-19  d-halluin  <d-halluin@lrde.epita.fr>

	Benchmarks: add documentation.

	* src/bench/README,
	* src/bench/common/README_AUTOMATA: Update.

2009-06-17  d-halluin  <d-halluin@lrde.epita.fr>

	Update benchmarks.

	This is a compound patch that can hardly be divided into separate
	patches.  It includes:


	1. OpenFST integration.

	  If OpenFST is present, OpenFST benchmarks are made for some
	  algorithms.

	2. Some (incomplete) documentation.

	  Describe the benchmarking process, input automata, and results.

	3. Clean up & name consistency.

	  Move existing benchmarks into directories with consistent names
	  (the benchmarked algorithms), store results in a specific
	  directory according to input and other parameters.


	Patch details:

	1. OpenFST integration:

	* configure.ac: Add --with-openfst option.
	* src/bench/common/alpha.syms: Add missing line.
	* src/bench/common/bench.mk: Fix -DVCSN_SRC_DIR flag.
	* src/bench/common/bench_macros.hh: Add convenient macros

	* src/bench/determinization/Makefile.bench: Add OpenFST bench.
	* src/bench/determinization/determinization_aut_2n_openfst_bench.hh:
	New (OpenFST benchmark program).

	* src/bench/minimization/Makefile.bench: New (add OpenFST bench).
	* src/bench/minimization/minimization_aut_2n_openfst_bench.hh:
	New (OpenFST benchmark program).
	* src/bench/minimization/minimization_aut_debruijn_openfst_bench.hh,
	New (OpenFST benchmark program).

	2. Some (incomplete) documentation:

	* src/bench/README: New.  General information.
	* src/bench/common/README: New.
	* src/bench/common/README_AUTOMATA: New.

	3. Clean up & name consistency:

	* configure.ac: Add/remove makefiles.
	* src/bench/Makefile.am: Add/remove directories.
	* src/bench/generate_bench.sh: Add/remove directories.

	* src/bench/common/Makefile.am: Clean up.
	* src/bench/common/bench_automaton.hh: Remove (unused).
	* src/bench/common/bench_constructs.hh: Clean up, add automata.

	Move accessible to its own directory:

	* src/bench/accessible/Makefile.bench: New.
	* src/bench/iterators/accessible_bench.hh:
	Rename into src/bench/accessible/accessible_bench.hh.

	Clean up composition:

	* src/bench/composition/Makefile.bench,
	* src/bench/composition/normalized_composition_bench.hh: Consistency.
	* src/bench/composition/rw_composition_bench.hh: Rename into
	src/bench/composition/realtime_composition_bench.hh.

	Clean up derived-terms:

	* src/bench/derived_terms/Makefile.bench,
	* src/bench/derived_terms/derived_terms_bench.hh: Consistency.

	Clean up determinization:

	* src/bench/determinization/Makefile.bench: Consistency.
	* src/bench/determinization/determinization_bench.hh: Rename into
	src/bench/determinization/determinization_aut_2n_bench.hh.
	* src/bench/determinization/determinization_bench_fsm.cc:
	Remove (unused).

	Clean up eps_removal:

	* src/bench/eps_removal/Makefile.bench,
	* src/bench/eps_removal/eps_removal_bench.hh: Consistency.

	Clean up iterators:

	* src/bench/iterators/Makefile.bench,
	* src/bench/iterators/iterator_bench.hh: Consistency.

	Clean up quotient:

	* src/bench/quotient/Makefile.bench,
	* src/bench/quotient/quotient_bool_bench.hh,
	* src/bench/quotient/quotient_z_bench.hh: Consistency.

	Clean up minimization:

	* src/bench/minimization/Makefile.bench: New (merge from
	minimization_2n and minimization_debruijn).
	* src/bench/minimization_2n/Makefile.bench: Remove (unused).
	* src/bench/minimization_debruijn/Makefile.bench: Remove (unused).

	* src/bench/minimization_2n/minimization_2n_brzozowski_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_2n_brzozowski_bench.hh.
	* src/bench/minimization_2n/minimization_2n_hopcroft_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_2n_hopcroft_bench.hh.
	* src/bench/minimization_2n/minimization_2n_moore_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_2n_moore_bench.hh.
	* src/bench/minimization_debruijn/minimization_debruijn_brzozowski_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_debruijn_brzozowski_bench.hh.
	* src/bench/minimization_debruijn/minimization_debruijn_hopcroft_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_debruijn_hopcroft_bench.hh.
	* src/bench/minimization_debruijn/minimization_debruijn_moore_bench.hh:
	Rename into
	src/bench/minimization/minimization_aut_debruijn_moore_bench.hh.

2009-06-17  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: f2cc74d682bddc0da7386a5ce1017b591c2c6e47.
	See cbs/Changelog.

2009-06-14  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: 17a18a174536d6b05c5364dd5f96f420b5ca75ef.
	See cbs/Changelog.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* bootstrap: Update to mention cbs/ instead of argp/.

2009-05-05  d-halluin  <d-halluin@lrde.epita.fr>

	Fix call graph export in taf-kit.

	* taf-kit/src/main.cc: Use the correct variable.

2009-05-01  d-halluin  <d-halluin@lrde.epita.fr>

	Adjust bench to complete in a reasonable time.

	* src/bench/minimization_2n/Makefile.bench: Do not bench
	minimization_brzozowski past n=12 (already 8min on seattle).

	* src/bench/eps_removal/Makefile.bench: Bench up to 200.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Fix composition bench.

	* src/bench/composition/normalized_composition_bench.hh,
	* src/bench/composition/rw_composition_bench.hh:
	Add missing CBS parameter (n).

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Fix quotient bench automaton.

	The previous automaton made no sense to Jacques and looked like
	there has been a fishy copy/paste.

	It now is:

	A -a-> A
	A -b-> A
	A -b-> B
	B -a-> B
	B -b-> B

	* src/bench/quotient/quotient_bool_bench.hh: Do that.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Enable callgraph in benchmark dot output.

	* src/bench/common/bench_macros.hh: Fix macro.

2009-04-28  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: aef3055d95b926d6242ebbce64a128df044cbba2.
	See cbs/Changelog.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Optimize quotient on boolean automata.

	(As mentioned during the meeting on April 10th)

	* include/vaucanson/algorithms/minimization_hopcroft.hxx: Do that.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Fix quotient bench automaton.

	The previous automaton made no sense to Jacques and looked like
	there has been a fishy copy/paste.

	It now is:

	A -a-> A
	A -b-> A
	A -b-> B
	B -a-> B
	B -b-> B

	* src/bench/quotient/quotient_bool_bench.hh: Do that.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Enable callgraph in benchmark dot output.

	* src/bench/common/bench_macros.hh: Fix macro.

2009-04-28  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: aef3055d95b926d6242ebbce64a128df044cbba2.
	See cbs/Changelog.

2009-04-16  d-halluin  <d-halluin@lrde.epita.fr>

	Fix make check.

	Use CBS in demos, disable CBS in tests (for faster
	compilation/link), disable CBS in vaucanswig.

	* src/demos/algorithms/Makefile.am,
	* src/demos/one_rule_rewriting/Makefile.am,
	* src/demos/vgrep/Makefile.am:
	Add cbs include dir, link with libbench.la.

	* src/tests/xml/Makefile.am,
	* src/tests/check/check-flags.mk,
	* src/tests/sanity/Makefile.am:
	Add cbs include dir. Disable bench (-DBENCH_DISABLED).

	* vaucanswig/expand.sh,
	* vaucanswig/meta/Makefile.am:
	Add cbs include dir. Disable bench (-DBENCH_DISABLED).

2009-04-09  d-halluin  <d-halluin@lrde.epita.fr>

	Update cbs.

	CBS version: e97a404a44e5b5d19d4a869aa1f43524386c5b09.
	See cbs/Changelog.

2009-04-10  d-halluin  <d-halluin@lrde.epita.fr>

	Link taf-kit, libs and benches with $(benchlib).

	* vaucanson.mk: Define benchlib.
	* lib/generate_libvcsn.rb,
	* taf-kit/src/Makefile.am,
	* src/bench/generate_bench.sh: Use it.

2009-04-10  d-halluin  <d-halluin@lrde.epita.fr>

	Replace timer and global_timer with cbs.

	Note: bencher and global_bencher remain.

	4 steps:
	1) Remove the timer system.
	2) Fix taf-kit.
	3) Disable bench in data/automata.
	4) Use cbs in algorithms/*.hxx and tools/*.hxx.

	Most modifications were only macro renaming.

	Tests:
	/!\ make check should be done on this patch.
	Taf-kit was quickly tested.
	make bench was quickly tested as well.

	Files patched:

	1) Remove the timer system:

	* include/vaucanson/misc/global_bencher.hh: New.
	Gather bencher-related macros.  Bench using the timer from cbs.
	* include/vaucanson/misc/global_timer.hh: Removed.
	Remove timer-related macros, put the rest in global_bencher.hh.
	* include/vaucanson/misc/usual_macros.hh: Include the proper files.
	* include/Makefile.am: Add/remove files.
	* include/vaucanson/misc/global_timer.hh,
	* include/vaucanson/misc/timer.cc,
	* include/vaucanson/misc/timer.hh,
	* include/vaucanson/misc/timer.hxx,
	* include/vaucanson/misc/timer_internal_gathering.cc,
	* include/vaucanson/misc/timer_internal_gathering.hh,
	* include/vaucanson/misc/timer_internal_gathering.hxx,
	* include/vaucanson/misc/timer_internal_graph.cc,
	* include/vaucanson/misc/timer_internal_graph.hh,
	* include/vaucanson/misc/timer_internal_graph.hxx: Removed.

	2) Fix taf-kit:

	* taf-kit/src/common.hh,
	* taf-kit/src/main.cc: Remove global_timer. Fix macros.

	3) Disable bench in data/automata:

	* data/automata/char-b/Makefile.am,
	* data/automata/char-fmp-b/Makefile.am,
	* data/automata/char-z/Makefile.am:
	Set -DBENCH_DISABLED in AM_CPPFLAGS.

	4) Use cbs in algorithms/*.hxx and tools/*.hxx:

	* include/vaucanson/algorithms/accessible.hxx,
	* include/vaucanson/algorithms/aci_canonical.hxx,
	* include/vaucanson/algorithms/aut_projection.hxx,
	* include/vaucanson/algorithms/aut_to_exp.hxx,
	* include/vaucanson/algorithms/berry_sethi.hxx,
	* include/vaucanson/algorithms/brzozowski.hxx,
	* include/vaucanson/algorithms/complement.hxx,
	* include/vaucanson/algorithms/complete.hxx,
	* include/vaucanson/algorithms/composition_cover.hxx,
	* include/vaucanson/algorithms/concatenate.hxx,
	* include/vaucanson/algorithms/cut_up.hxx,
	* include/vaucanson/algorithms/derived_term_automaton.hxx,
	* include/vaucanson/algorithms/determinize.hxx,
	* include/vaucanson/algorithms/domain.hxx,
	* include/vaucanson/algorithms/eps_removal.hxx,
	* include/vaucanson/algorithms/eps_removal_sp.hxx,
	* include/vaucanson/algorithms/eval.hxx,
	* include/vaucanson/algorithms/evaluation_fmp.hxx,
	* include/vaucanson/algorithms/extension.hxx,
	* include/vaucanson/algorithms/finite_support_conversion.hxx,
	* include/vaucanson/algorithms/fmp_to_rw.hxx,
	* include/vaucanson/algorithms/image.hxx,
	* include/vaucanson/algorithms/invert.hxx,
	* include/vaucanson/algorithms/is_ambiguous.hxx,
	* include/vaucanson/algorithms/is_deterministic.hxx,
	* include/vaucanson/algorithms/is_ltl.hxx,
	* include/vaucanson/algorithms/is_normalized.hxx,
	* include/vaucanson/algorithms/isomorph.hxx,
	* include/vaucanson/algorithms/letter_to_letter_composition.h,
	* include/vaucanson/algorithms/ltl_to_pair.hxx,
	* include/vaucanson/algorithms/minimization_hopcroft.hxx,
	* include/vaucanson/algorithms/minimization_moore.hxx,
	* include/vaucanson/algorithms/normalized.hxx,
	* include/vaucanson/algorithms/pair_to_fmp.hxx,
	* include/vaucanson/algorithms/product.hxx,
	* include/vaucanson/algorithms/projection.hxx,
	* include/vaucanson/algorithms/realtime.hxx,
	* include/vaucanson/algorithms/rw_composition.hxx,
	* include/vaucanson/algorithms/search.hxx,
	* include/vaucanson/algorithms/standard.hxx,
	* include/vaucanson/algorithms/sub_automaton.hxx,
	* include/vaucanson/algorithms/sub_normalize.hxx,
	* include/vaucanson/algorithms/transpose.hxx,
	* include/vaucanson/algorithms/trim.hxx,
	* include/vaucanson/tools/io.hxx: Replace TIMER_SCOPED with
	BENCH_TASK_SCOPED.

2009-04-11  d-halluin  <d-halluin@lrde.epita.fr>

	Equip bench with CBS

	Note: Squash previous related patches with this one.

	3 Steps:

	1) Use CBS files.
	2) Remove obsolete tools.
	3) Equip all benches.

	1) Use CBS files:

	* src/bench/common/bench_macros.hh: New.
	Include cbs/bench/bench.hh, define handy macros.
	* src/bench/common/Makefile.am: Add file.
	* src/bench/generate_bench.sh: Include common/bench_macros.hh in
	generated Makefiles.

	2) Remove obsolete tools:

	* include/vaucanson/tools/bencher.hh,
	* include/vaucanson/tools/bencher.hxx: Deleted.
	Served the same purpose as the cbs timer, with less flexibility.

	3) Equip all benches:

	Replace macros VCSN_BENCH_XXX with the CBS equivalent.
	Add parameters and results when applicable (all the info
	previously printed on cout/cerr are now parameters and results).

	3 files are generated for each bench.  There are between 5 and 10
	benches per file below.  See common/bench_macros.hh to change that.

	* src/bench/composition/normalized_composition_bench.hh,
	* src/bench/composition/rw_composition_bench.hh,
	* src/bench/derived_terms/derived_terms_bench.hh,
	* src/bench/determinization/determinization_bench.hh,
	* src/bench/eps_removal/eps_removal_bench.hh,
	* src/bench/iterators/accessible_bench.hh,
	* src/bench/iterators/iterator_bench.hh,
	* src/bench/minimization_2n/minimization_2n_brzozowski_bench.h,
	* src/bench/minimization_2n/minimization_2n_hopcroft_bench.hh,
	* src/bench/minimization_2n/minimization_2n_moore_bench.hh,
	* src/bench/minimization_debruijn/minimization_debruijn_brzozo,
	* src/bench/minimization_debruijn/minimization_debruijn_hopcro,
	* src/bench/minimization_debruijn/minimization_debruijn_moore_,
	* src/bench/quotient/quotient_bool_bench.hh,
	* src/bench/quotient/quotient_z_bench.hh: Do that.

2009-04-06  d-halluin  <d-halluin@lrde.epita.fr>

	Add cbs (libbench).

	* cbs: Add directory.
	* configure.ac: Add AC_CONFIG_SUBDIRS for cbs.
	* Makefile.am: Add cbs subdir.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Update to gnulib 567f85cfcdb0a63cf96730d0858581b013765d59.

	* gnulib/Makefile.am, gnulib/argp-fmtstream.c, gnulib/getopt1.c,
	gnulib/gettext.h, gnulib/progname.c, gnulib/stdint.in.h,
	gnulib/stdio.in.h, gnulib/stdlib.in.h, gnulib/strerror.c,
	gnulib/unistd.in.h, gnulib/vasnprintf.c, gnulib/wchar.in.h,
	gnulib/xmalloc.c, m4/alloca.m4, m4/argp.m4,
	m4/double-slash-root.m4, m4/errno_h.m4, m4/extensions.m4,
	m4/gnulib-cache.m4, m4/gnulib-common.m4, m4/gnulib-comp.m4,
	m4/include_next.m4, m4/inline.m4, m4/intmax_t.m4,
	m4/inttypes_h.m4, m4/longlong.m4, m4/malloc.m4, m4/mempcpy.m4,
	m4/printf.m4, m4/size_max.m4, m4/stdbool.m4, m4/stdint.m4,
	m4/stdint_h.m4, m4/stdio_h.m4, m4/stdlib_h.m4, m4/strcase.m4,
	m4/strchrnul.m4, m4/strndup.m4, m4/strnlen.m4, m4/unistd_h.m4,
	m4/vasnprintf.m4, m4/wchar.m4, m4/wchar_t.m4, m4/wint_t.m4,
	m4/xsize.m4: Update.
	m4/00gnulib.m4, m4/multiarch.m4: New files.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Add the pair-to-fmp command to TAF-Kit.

	* taf-kit/src/Makefile.am (vcsn_char_fmp_b_LDADD,
	vcsn_char_fmp_z_LDADD, vcsn_int_fmp_b_LDADD,
	vcsn_int_fmp_z_LDADD): Add the corresponding pair automaton
	library.
	* taf-kit/src/fmp_commands.cc (pair_to_fmp): New command.
	* taf-kit/src/getters.hxx (get_pair_aut): New function.
	* taf-kit/src/pipe_getters.hh, taf-kit/src/pipe_getters.hxx
	(pair_automaton_getter): New class.
	* taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-int-fmp-z.test: Add more tests for ltl-to-pair
	and pair-to-fmp.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make pair_to_fmp() available in FMP contexts.

	* include/vaucanson/contexts/fmp_transducer_functions.thh:
	include pair_to_fmp.hh.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make mute_ltl_to_pair<S,T>::make_automaton available.

	* include/vaucanson/algorithms/ltl_to_pair.hxx (make_automaton):
	Move the code...
	* include/vaucanson/algorithms/ltl_to_pair.hh (make_automaton):
	... here, so it is available even if VCSN_USE_INTERFACE_ONLY
	is defined.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce contexts for char-char-z and int-int-z automata.

	* include/vaucanson/automata/generic_contexts/char_char_z_automaton.hh,
	include/vaucanson/automata/generic_contexts/char_char_z_automaton_structures.hh,
	include/vaucanson/automata/generic_contexts/int_int_z_automaton.hh,
	include/vaucanson/automata/generic_contexts/int_int_z_automaton_structures.hh:
	New files.
	* include/Makefile.am (nobase_include_HEADERS): Add them.
	* lib/generate_libvcsn.rb: Adjust to build int-int-z and
	char-char-z contexts.
	* lib/Makefile.am: Include the new libraries' makefiles.

2009-03-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Remove Vaucanswig.

	* vaucanswig/: Delete.
	* Makefile.am (SUBDIRS): Adjust.
	* build-aux/vcsn-internal.m4: Delete.
	* build-aux/Makefile.am (EXTRA_DIST): Adjust.
	* configure.ac: Remove Python and Swig checks.
	* vaucanson.spec, debian/rules: Remove --disable-vaucanswig and
	--disable-build-demos.
	* bootstrap: Do not call vaucanswig/expand.sh.

2009-06-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	BOOST_CPPFLAGS were ignored while compiling lib/.

	* lib/src/libcommon.mk: Do not overwrite AM_CPPFLAGS with a list
	of include directories that is less complete than the one in
	vaucanson.mk, use...
	(libvcsn_common_la_CPPFLAGS, libvcsn_common_ex_la_CPPFLAGS):
	... these variable to augmant AM_CPPFLAGS instead.

2009-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac: Bump version to 1.3.0a.
	* doc/manual/taf-kit-manual.tex: Likewise.

2009-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Release 1.3.

	* configure.ac: Bump version to 1.3.
	* doc/manual/taf-kit-manual.tex: Likewise.
	* doc/NEWS.txt: Update for 1.3.

2009-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/README.txt: Typo.

2009-05-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Typo in src/tests/check/Makefile.am.

	* src/tests/check/Makefile.am (libcheck_a_LIBADD): Rename as ...
	(libcheck_la_LIBADD): ... this.

2009-05-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Use libvcsn-common.la for all demos.

	* src/demos/demo.mk (LDADD): Define globally.
	* src/demos/algorithms/Makefile.am (aut_are_equivalent_LDADD,
	exp_are_equivalent_LDADD): Remove.
	* src/demos/one_rule_rewriting/Makefile.am (LDADD): Likewise.
	* src/demos/vgrep/Makefile.am (LDADD): Likewise.

2009-05-06  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/NEWS.txt: Make clearer that the documentation is incomplete.
	Suggested by Jacques Sakarovitch.

2009-05-06  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename d2.xml as d1.xml.

	* data/automata/char-z/d2.cc: Rename as...
	* data/automata/char-z/d1.cc: ... this.
	* data/automata/char-z/Makefile.am: Adjust to build d1 and create
	d1.xml
	* taf-kit/tests/vcsn-char-z.test: Adjust to use d1.xml.
	* doc/manual/taf-kit-manual.tex: Rename d2.xml as d1.xml.

2009-05-06  Alexandre Duret-Lutz  <adl@lrde.epita.fr>


	Document left and right weight multiplications.

	* doc/manual/taf-kit-manual.tex (Writing Rational Expressions):
	Rename as ...
	(Writing (Weighted) Rational Expressions): ... this.
	(Rational operators): Show the result of the are-equivalent
	example.
	(Weights): Document left and right weights using text from
	Jacques Sakarovitch.
	(Trivial Identities): Write "weighted rational expression"
	instead of "rational expression" to avoid ambiguities.

2009-05-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/README.txt: Update references to the Taf-Kit manual.

2009-05-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* AUTHORS: Update Sylvain's email.

2009-05-13  Alexandre Duret-Lutz  <adl@va-et-vient.net>

	abs() no longer works with g++ 4.4., we must write std::abs().

	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx,
	include/vaucanson/misc/random.hxx: Use std::abs() instead of abs().
	* include/vaucanson/algebra/implementation/semiring/rational_number.hxx:
	Likewise, and also include <cstdlib> for abs(int).

2009-05-13  Alexandre Duret-Lutz  <adl@va-et-vient.net>

	Introduce libvcsn-common-ex.la in addition to libvcsn-common.la
	to decide whether exceptions should be used in preconditions.

	This fixes errors in taf-kit's test-suite when compiled with GCC
	4.4.  The code was making the bogus assumption that the inline
	function trap() was not inlined in the context libraries (compiled
	without exceptions) and could therefore be overwritten as a weak
	symbol in TAF-Kit (to use exceptions).

	* include/vaucanson/misc/contract.hh (vcsn::misc::contract::trap):
	Leave only a declaration and move the definition...
	* src/misc/contract.cc: ... in this new file.
	* lib/src/libcommon.mk: Adjust for contract.cc and build two
	libraries: libvcsn-common.la (with abort()) and
	libvcsn-common-ex.la (with exceptions).
	* data/automata/char-b/Makefile.am,
	data/automata/char-fmp-b/Makefile.am,
	data/automata/char-z/Makefile.am, taf-kit/src/Makefile.am,
	vaucanswig/meta/Makefile.am, src/tests/sanity/Makefile.am,
	src/tests/xml/Makefile.am: Link with libvcsn-common.la or
	libvcsn-common-ex.la.
	* taf-kit/src/common.hh (EXCEPTION_TRAPS): Remove #define.
	* src/bench/common/bench.mk (AM_CPPFLAGS): Remove useless
	-DEXCEPTION_TRAPS.
	* vaucanswig/expand.sh: Likewise.
	* src/tests/check/Makefile.am: Build libcheck.la instead
	of libcheck.a, so we can depend on libvcsn-common-ex.la
	* src/tests/check/check.mk: Use libcheck.la and
	libvcsn-common-ex.la.
	* src/tests/test-suites/test-suite.mk: Don't define
	EXCEPTION_TRAPS and don't add libvcsn-common-ex.la to LDADD
	(check.mk already does it).

2009-05-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename libkrat_exp.la as libvcsn_common.la, and move lib/krat_exp/
	to lib/src/krat_exp/, so that we can later integrate more code
	into libvcsn_common.la.

	* bootstrap: Don't run bison, the Makefile will do it.
	* lib/krat_exp/krat_exp_bison.yy: Move ...
	* lib/src/krat_exp/krat_exp_bison.yy: ... here.
	* lib/krat_exp/libkrat_exp.mk: Rename as ...
	* lib/src/libcommon.mk: ... this, and adjust to the new names.
	* src/demos/algorithms/Makefile.am,
	src/demos/one_rule_rewriting/Makefile.am,
	src/demos/vgrep/Makefile.am, src/tests/xml/Makefile.am,
	taf-kit/src/Makefile.am, lib/Makefile.am: Change all references to
	libkrat_exp.la into libvcsn-common.la.

2009-05-12  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix errors reported by g++ 4.4.0.

	* include/vaucanson/algebra/implementation/series/transpose.hh:
	Do not name a argument T when T is also a template parameter.

2009-05-11  Jérôme Galtier  <jerome.galtier@lrde.epita.fr>

	Remove the vcs directory.

	* vcs/vaucanson.rb: Remove.

2009-05-11  Jérôme Galtier  <jerome.galtier@lrde.epita.fr>

	Fix out of tree building for the TAF-Kit manual.

	* doc/manual/Makefile.am: Correct the path to taf-kit-manual.tex by
	prefixing the old path with $(srcdir).

2009-05-10  Jérôme Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for boost multi-index >= 1.36.

	* include/vaucanson/automata/implementation/bmig/bmig_handlers.hh
	(operator==, operator!=, operator<, operator>, operator<=)
	(operator>=): Remove the last template parameter.
	* include/vaucanson/automata/implementation/bmig/bmig_handlers_op.hxx:
	Update the macro HOPERATOR for <, >, <=, >= and the one for ==, !=.

2009-05-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac: Bump to 1.2.96a.
	* doc/manual/taf-kit-manual.tex: Likewise.

2009-05-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Release 1.2.96.

	* configure.ac: Bump to 1.2.96.
	* doc/manual/taf-kit-manual.tex: Likewise.
	* doc/NEWS.txt: Document 1.2.96.

2009-04-30  d-halluin  <d-halluin@lrde.epita.fr>

	Optimize quotient on boolean automata.

	(As mentioned during the meeting on April 10th)

	* include/vaucanson/algorithms/minimization_hopcroft.hxx: Do that.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* data/automata/char-z/d2.cc: Really add this file.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce d2.xml.

	* data/automata/char-z/d2.cc: New file.
	* data/automata/char-z/Makefile.am: Build d2.xml.
	* taf-kit/tests/vcsn-char-z.test: Test d2.xml.
	* doc/manual/taf-kit-manual.tex (d2.xml): New section.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Remove dev3base10.xml: it is not a pertinent example of Z automaton.

	* data/automata/char-z/divkbaseb.cc: Delete.
	* data/automata/char-z/Makefile.am,
	taf-kit/tests/vcsn-char-z.test: Adjust.
	* doc/manual/taf-kit-manual.tex (div3base10.xml): Remove.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Use alphabet {0,1} for c1.xml.

	* data/automata/char-z/c1.cc: Rewrite using alphabet {0,1} instead
	of {a,b}.
	* taf-kit/tests/vcsn-char-z.test: Adjust test.
	* doc/manual/taf-kit-manual.tex (c1.xml): Adjust and document
	the figure.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/manual/taf-kit-manual.tex: Minor corrections from Jacques
	Sakarovitch.

2009-04-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Turn the Vaucanson User's manual into a Taf-Kit documentation.

	* doc/manual/vaucanson-manual.tex: Rename as ...
	* doc/manual/taf-kit-manual.tex: ... this.  And change
	the title to "Taf-Kit Documentation"
	* doc/manual/Makefile.am, lrde-upload.sh: Adjust.

2009-04-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/test-suites/algebra_numerical_semiring_int.defs: Add a
	newline at EOF to kill a GCC warning.

2009-04-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/HACKING.txt: Use *this* for italics, not `this`.

2009-04-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix spurious calls to find_tests.sh and potential race conditions.

	* build-aux/find_tests.sh: Use $$ in temporary files to prevent
	races if this script is run more than once.
	* Makefile.am (build-aux/tests.m4): Always touch the output.

2009-04-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/manual/vaucanson-manual.tex (Trivial Identities): New section.

2009-04-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/manual/vaucanson-manual.tex: Fix some typos and reword some
	phrases.

2009-04-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	More documentation.

	* doc/manual/vaucanson-manual.tex: Fill the automaton repository.
	Add some words about weights.  Kill the old examples from the doc
	except the part about Z-automata.

2009-04-15  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* lrde-upload.sh: Do not use git to compute the name of the
	branch.  Buildbot will now pass the branch name as first argument.

2009-04-14  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algebra/implementation/series/krat_exp_parser_private.hh:
	Add header guards.

2009-04-14  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* lib/krat_exp/krat_exp_bison.yy: Use "%name-prefix=" instead
	of "%name-prefix " to please Bison < 2.4.

2009-04-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename the yy:: namespace into vcsnyy:: to prevent potential
	conflicts with a user defined parser.

	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx,
	include/vaucanson/algebra/implementation/series/krat_exp_parser_private.hh,
	lib/krat_exp/krat_exp_bison.yy: Rename yy as vcsnyy.

2009-04-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Factor the two definitions of yy::krat_exp_parser in a single place.

	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx
	(yy::krat_exp_parser): Move to...
	* include/vaucanson/algebra/implementation/series/krat_exp_parser_private.hh:
	This new file.
	* include/Makefile.am: Distribute and install the new file.
	* lib/krat_exp/krat_exp_bison.yy (yy::krat_exp_parser): Delete
	and include krat_exp_parser_private.hh instead.

2009-04-08  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix spurious "the token ' ' is already defined as a word" messages.

	* include/vaucanson/algebra/implementation/letter/int_letter.hxx
	(literal_to_letter): Do not skip spaces when translating numbers.
	* taf-kit/tests/vcsn-int-b.test: Add a test case.
	Thanks to Jérôme for the help.

2009-04-10  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make a new section of rational expressions.

	* doc/manual/vaucanson-manual.tex (Writing Rational Expression):
	New section.
	(Empty word and null series): Move into the previous section.
	(Interactive Definition of Automata): Create a new section out of...
	(Boolean automata): ... some text from here, and delete the rest.
	(Automaton Repository): Complete.

2009-04-09  Alexandre Duret-Lutz  <adl@va-et-vient.net>

	* doc/manual/vaucanson-manual.tex (\tafkit) More text.

2009-04-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rework the TAF-Kit introduction.

	* doc/manual/vaucanson-manual.tex (The \Vauc toolkit): Rename
	as...
	(\tafkit): ... this and add more text.

2009-04-07  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	More administrativia.

	* doc/manual/vaucanson-manual.tex (Installation): Rename as...
	(Administrativia): ... this, and add more text.

2009-04-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Manual: some work on the title page and the introduction.

	* doc/manual/vaucanson-manual.tex (\TFK,\TFKv): Remove these
	unused macros.
	(\title,\author): Remove and replace by a custom titlepage.
	Also change the title from "The Vaucanson TAF-Kit 1.2.95"
	to "Vaucanson User's Manual".
	(Introduction): Rewrite to introduce the library, TAF-Kit, and
	the automata repository.
	(Automaton Library): Rename as ...
	(Automaton Repository): ... to avoid ambiguities with Vaucanson
	being an Automaton Library too.

2009-04-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* lrde-upload.sh: Update to take Git branches into account.

2009-04-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Replace check_doc.py by a call to grep.

	* doc/manual/Makefile.am (maintainer-check): Replace the
	call to check_doc.py by a simple call to grep.
	(CLEANFILES, check_doc.py): Do not build check_doc.py anymore.
	* doc/manual/check_doc.py.in: Delete.

2009-04-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/FAQ.txt: Really delete it, as intended on 2009-01-23.

2009-04-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Copy some sections from developer.tex into HACKING.txt

	* doc/HACKING.txt (Tools): New section.

2009-04-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/README.txt: python-docutils is not needed by end-users.

2009-04-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* Makefile.am (maintainer-check): Call maintainer-check in
	doc/manual.

2009-04-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Remove some unused Makefile rules.

	* Makefile.am (install-epita): Remove.
	* doc/manual/Makefile.am (install-epita, deep-clean,
	vcsndldir_data): Remove.
	(EXTRA_DIST): Do not distribute the manual a second time, it
	is already in dist_pdf_DATA.

2009-04-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/manual/Makefile.am (check_doc.py): Add missing $(srcdir)/
	on dependency.

2009-04-02  Alexandre Duret-Lutz  <adl@va-et-vient.net>

	More developer documentation.

	* doc/HACKING.txt (Version control): New section to discuss Git
	and how to work with Git.
	(Parallel make): Remove Fixme and simplify command.
	(distcc, ccache): More text
	(Improve the build system): Remove.

2009-04-02  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Move the user manual check from check to maintainer-check.

	* configure.ac: Only check for python when building vaucanswig.
	* doc/.gitignore: Remove check_doc.py.
	* doc/manual/Makefile.am: Do not distribute check_doc.py and
	check_doc.py.in. Only run check_doc.py when invoking the
	maintainer-check target.
	* doc/HACKING.txt: Add a step when making a release.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup command display in the user manual.

	* doc/manual/vaucanson-manual.tex: Use $ as prompt in the shell
	environments. Convert all verbatim environments to shell ones.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update the automaton TikZ style in the user manual.

	* doc/manual/vaucanson-manual.tex: Make states bolder, and loops
	larger (code by Alexandre Duret-Lutz).

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Remove share dependencies.

	* doc/manual/developer.tex, doc/README.txt, doc/HACKING.txt: Remove
	references to share.
	* doc/Makefile.am: Remove the share-up target. Use texi2pdf.
	* doc/manual/Makefile.am: Remove the variables share_dir,
	share_bin_dir, share_style_dir and share_bib_dir. Do not use the
	--dvipdf flag (TikZ is used instead of Vaucanson-G so plain DVI
	compilation is no more required).
	* doc/manual/vaucanson-manual.tex: Convert all Vaucanson-G pictures to
	TikZ ones. Use babel, hyperref, tikz instead of mybabel, myhyperref,
	Vaucanon-G respectively. Do not include myacronym, texi and misc.
	Include xspace. Many tweaks.
	* doc/share/README, doc/share/bib/vaucanson.bib,
	doc/share/bin/texi2dvi, doc/share/styles/VCpatch-pstricks-1-10.tex,
	doc/share/styles/Vaucanson-G.tex, doc/share/styles/hevea.sty,
	doc/share/styles/ldf/stl.sty, doc/share/styles/ldf/vaucanson.sty,
	doc/share/styles/misc.hva, doc/share/styles/misc.sty,
	doc/share/styles/myacronym.hva, doc/share/styles/myacronym.sty,
	doc/share/styles/mybabel.hva, doc/share/styles/mybabel.sty,
	doc/share/styles/mycxx.sty, doc/share/styles/myhyperref.hva,
	doc/share/styles/myhyperref.sty, doc/share/styles/myifthen.hva,
	doc/share/styles/myifthen.sty, doc/share/styles/myindex.hva,
	doc/share/styles/myindex.sty, doc/share/styles/texi.hva,
	doc/share/styles/texi.sty, doc/share/styles/vaucanson-g.sty: Remove.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update .gitignore.

	* .gitignore: Add NEWS and README.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Do not depend on version.tex in the user manual.

	* configure.ac: Always check for python.
	* doc/.gitignore: Remove version.tex, add check_doc.py.
	* doc/manual/Makefile.am: Do not generate version.tex at build
	time. Use a script (check_doc.py.in) to check the user manual.
	* doc/manual/vaucanson-manual.tex: Add the VcsnVersion tag. Let
	\maketitle build the date.
	* doc/manual/check_doc.py.in: New.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup the user manual further.

	* doc/manual/vaucanson-manual.tex: Remove sections from the old
	developer manual.

2009-04-01  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Only use one tex file for the user manual.

	* doc/manual/Makefile.am: Remove introduction.tex, installation.tex,
	taf-kit.tex, theory.tex, automata.tex, xml.tex, specification.tex from
	the distribution.
	* doc/manual/automata.tex, doc/manual/installation.tex,
	doc/manual/introduction.tex, doc/manual/specification.tex,
	doc/manual/taf-kit.tex, doc/manual/theory.tex, doc/manual/xml.tex:
	Remove.
	* doc/manual/vaucanson-manual.tex: Merge the previously named files
	into this one.

2009-03-30  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Streamline the user manual.

	* doc/manual/Makefile.am: Remove the minidist target. Remove
	library.tex from the sources.
	* doc/manual/extex.pl, doc/manual/extex.mk, doc/manual/library.tex,
	doc/manual/generate-automata.sh: Remove.
	* doc/manual/vaucanson-manual.tex: Do not include library.tex.

2009-03-30  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Remove make dist dependency on make (Close #140).

	* doc/.gitignore: Remove automata.tex and manual.ext as they are no
	more generated.
	* doc/manual/Makefile.am: Disable the extraction of commands in
	taf-kit.tex, and the generation of automata.tex.
	* doc/manual/automata.tex: New.
	* doc/manual/taf-kit.tex: Replace each occurrence of execcaption by a
	verbatim environment. Remove each occurrence of includegenerateddot.
	* doc/manual/vaucanson-manual.tex: Remove the commands
	includegenerated, includegenerateddot, execcaption and execdisplay. Do
	not use vaucanswig.tex and developer.tex.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix a distcheck failure.

	* src/tests/test-suites/Makefile.am ($(srcdir)/subdirs.mk): Do
	not run am--refresh in the srcdir, the makefile is in the buildir.
	Also touch the destination file.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rename has_succ_comp() to is_useless() and reverse its result.

	* include/vaucanson/algorithms/has_succ_comp.hh,
	include/vaucanson/algorithms/has_succ_comp.hxx (has_succ_comp):
	Rename as...
	* include/vaucanson/algorithms/is_useless.hh,
	include/vaucanson/algorithms/is_useless.hxx (is_useless): ... this.
	* include/Makefile.am, include/vaucanson/standard_algorithms.hh,
	taf-kit/src/b_commands.cc, taf-kit/src/common_commands.hh,
	taf-kit/src/fmp_commands.cc, taf-kit/src/r_commands.cc,
	taf-kit/src/z_commands.cc, taf-kit/tests/vcsn-char-b.test: Adjust
	all uses.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/common_automaton_commands.hh: Rename co-accessible
	as coaccessible.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>


	Hide minimize-moore and eps-removal-sp from --list-commands.  Show
	them only with the new --list-all-commands option.

	* taf-kit/src/common_automaton_commands.hh (eps_removal_sp):
	Declare as EXPERT.
	* taf-kit/src/b_commands.cc (minimize-moore): Declare as EXPERT.
	* taf-kit/src/commands.hh (command_t::expert): New field.
	* taf-kit/src/commands_macros.hh (COMMAND_ENTRY_CN_,
	COMMAND_ENTRY_CN, COMMAND_ENTRY, COMMAND_GROUP): Fill the expert
	field with 0.
	(COMMAND_ENTRY_EXPERT, COMMAND_ENTRY_EXPERT_CN): New entries.
	* taf-kit/src/interface.hh, taf-kit/src/interface.cc
	(list_commands): Take a boolean as an argument to decide whether
	to show expert functions.
	* taf-kit/src/main.cc (options): Add a --list-all-commands
	option.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Typo.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make it possible to override the writing data of an XML rat_exp.

	* taf-kit/src/getters.hxx (get_exp): Overwrite the writing data
	with any data supplied on the command line after reading the
	rat_exp_t.
	* taf-kit/src/getters.hh, taf-kit/src/getters.hxx
	(set_writing_data): New function for rat_exp_t.
	* taf-kit/tests/vcsn-char-b.test: Add more tests.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Make it possible to read a XML rat_exp from a Unix pipe.

	* taf-kit/src/getters.hxx (get_exp): Pass the input format
	to the rat_exp_getter.
	* taf-kit/src/pipe_getters.hh, taf-kit/src/pipe_getters.hxx
	(rat_exp_getter::f, rat_exp_getter::rat_exp_getter) Store the
	input format.
	(rat_exp_getter::operator): Add support for reading XML from
	string or pipe, depending on the input format.
	* taf-kit/tests/vcsn-char-b.test: Test the external pipe.

2009-03-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Do not force --alphabet to be used with rat_exps on internal pipe.

	* taf-kit/src/getters.hxx (get_exp): Do not force calls
	to get_alphabet when reading from "-".
	* taf-kit/tests/vcsn-char-b.test: Add a test case.

2009-03-17  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Preserve the representations in standard_of and thompson_of.

	* include/vaucanson/contexts/automaton_maker.thxx (do_standard_of,
	do_thompson_of): Preserve the representations.
	* taf-kit/src/ratexp_commands.hh (standard_of, thompson_of,
	derived_term_automaton): Do not call set_writing_data, we simply
	keep the writing data of the rational expression.

2009-03-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/pipe_command_sequence.hh: Remove useless includes.

2009-03-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Merge KEEP_AUTOMATON with KEEP in Taf-Kit.

	* taf-kit/src/commands_macros.hh (KEEP_AUTOMATON): Remove.
	* taf-kit/src/commands_macros.hh, common_automaton_commands.hh,
	taf-kit/src/common_commands.hh, taf-kit/src/fmp_commands.cc,
	taf-kit/src/ratexp_commands.hh: Replace all uses of KEEP_AUTOMATON
	by uses of KEEP.

2009-03-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/getters.hxx, taf-kit/src/commands_macros.hh,
	taf-kit/src/common.hh, taf-kit/src/main.cc: replace the
	GLOBAL_RESULT macro and the associated variable
	last_command_output, by the variable global_result.

2009-03-16  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/commands_macros.hh, taf-kit/src/getters.hxx: Get rid
	of all GLOBAL_RESULT "#ifdef"s.

2009-03-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Add more tests for rational
	expressions and writing data.

2009-03-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Do not read the alphabet from the command line with a rational
	expression has just been read.  Use the alphabet from the
	expression instead.

	* taf-kit/src/getters.hh, taf-kit/src/getters.hxx (get_alphabet):
	New overload to retrieve the alphabet of a rat_exp_t.
	* taf-kit/src/ratexp_commands.hh (standard_of, thompson_of):
	Do not call make_automaton and get_alphabet.
	(derived_term_automaton): retrieve the alphabet of the expression
	that has been read, do not request it from the command line.

2009-03-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Replace <typedRegExp><label>...</label></typedRegExp> by
	<typedRegExp>...</typedRegExp> in the XML output of rational
	expressions.

	* include/vaucanson/xml/builders.hh,
	include/vaucanson/xml/builders.hxx (create_regexp_node): Take
	a root_name argument, and use it to replace the	<label> tag.
	* include/vaucanson/xml/printers.hxx (RegExpPrinter<RE>::print):
	Do not create the <typedRegExp> tag, instead call create_regexp_node()
	with "typedRegExp" as root_name.

2009-03-11  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* configure.ac (Swig check): Do not mention SVN in the warning.

2009-03-11  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Do not use the SCM revision in the version of Vaucanson.
	Let's keep the source code as independent of the SCM as we can.

	* configure.ac (VCSN_PRE_RELEASE): Don't call.
	(VCSN_PRE_RELEASE, VCSN_DETECT_SVN_REVISION): Remove.

2009-03-11  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* AUTHORS: Add Maurice.

2009-03-10  Alex Hamelin  <hamelin@lrde.epita.fr>

	Fix tests of Standard and Thompson.
	* src/tests/include/tests/automata/algos/labeled_graphs/thompson_test.hh:
	Modify Thompson Tests for product to respect the right behavior. Add
	a test of equivalence between "ab" and "a.b".
	* src/tests/include/tests/automata/algos/label_aware_graphs/standard_of_regression_test.hh:
	Fix a bug using two times the same automaton to be filled without it
	being emptied before.
	* src/tests/include/tests/context_headers/automata/global_consistency_test.hh:
	Same fix as above.

2009-03-10  Alex Hamelin  <hamelin@lrde.epita.fr>

	Optimization of Standard visitor.
	* include/vaucanson/algorithms/standard_of.hh: Add information
	about the function's behavior.
	* include/vaucanson/algorithms/standard_of.hxx: Improve Standard
	visitor by preventing creation of several useless automata.

2009-03-10  Alex Hamelin  <hamelin@lrde.epita.fr>

	Factorize and document Standard algorithm.
	* include/vaucanson/algorithms/standard.hh: Add link to Trac's page
	speaking about standard automata.
	* include/vaucanson/algorithms/standard.hxx: Factorize functions' body
	for standard_of modifications.

2009-03-08  Alex Hamelin  <hamelin@lrde.epita.fr>

	Thompson Optimization.
	* include/vaucanson/algorithms/thompson.hxx: Improve Thompson
	Visitor by preventing creation of multiple useless automata.
	Correct a bug in product construction by adding a spontaneous
	transition.
	* include/vaucanson/algorithms/thompson.hh: Add documentation about
	thompson_of behavior.

2009-02-18  Maurice Audin  <audin@lrde.epita.fr>

	Add two new TAF-Kits, char-zmin and char-zmax, with basic tests.
	* configure.ac: Add new files and wrappers.
	* taf-kit/src/Makefile.am: Add two new contexts.
	* taf-kit/tests/Makefile.am: Add tests for the new contexts.
	* taf-kit/tests/vcsn-char-zmax.test,
	* taf-kit/tests/vcsn-char-zmin.test: Add two basic tests (non-determinist automata include).

2009-02-13  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/aci_canonical.hh (canonical):
	Document it.

2009-02-18  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update HACKING.txt.
	* doc/HACKING.txt: Remove the example as it does not improve the
	  build time further.

2009-02-11  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Add XML support for rational expressions in TAF-Kit.
	Now, it is possible to execute things like:
	./vcsn-char-b -o XML --alphabet=ab identity-exp "(a+b)*.a.(a+b)*"
	./vcsn-char-b -i XML identity-exp exp1.xml
	./vcsn-char-b -i XML -o XML identity-exp exp1.xml

	* taf-kit/src/common.hh: Split input_type into input_exp_type and
	    input_aut_type (Allow XML by default for aut and EXP for regexp).
	* taf-kit/src/getters.hxx: Add XML input for rat_exp.
	* taf-kit/src/main.cc: input_exp_type/input_aut_type.
	* taf-kit/src/pipe.hh: input_exp_type/input_aut_type.
	* taf-kit/src/pipe.hxx: input_exp_type/input_aut_type.
	* taf-kit/src/pipe_writers.hxx: Add XML output for rat exp.

2009-02-11  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Fix XML support of rational expressions.
	* xml/handlers.hxx: Here.
	* xml/regexp.hh: Here.
	* xml/regexp.hxx: Here.

2009-02-10  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Add XML support for rational expressions.
	We can now load and save rational expressions following the same
	syntax used for automata, using regexp_loader and regexp_saver
	instead of automaton_loader and automaton_saver.

	The code added might definitely be optimized:
	  - Some parts of the code could definitely be merged.
	  - It might not be necessary to have TransitionConverter and
	    Format in regexp_loader, since we (currently) have only this
	    way to print rational expressions.
	  - The names were arbitrarily chosen. (Especially: It now exists
	    a RegExpHandler and a RegexpHandler [-> typedRegExpHandler ?])

	Not yet done: an exhaustive list of tests.

	* include/vaucanson/algebra/concept/series_base.hh,
	* include/vaucanson/algebra/concept/series_base.hxx: Added some typedefs
	  and some functions so that Series could have a behavior closer to
	  automata (it allows to factorize the code when printing the rational
	  expression).
	* include/vaucanson/tools/io.hh: Add regexp_saver mechanism.
	* include/vaucanson/tools/io.hxx: Add regexp_saver mechanism.
	* include/vaucanson/xml/XML.hh: Specialize operator() with the provided
	  loader/saver.
	* include/vaucanson/xml/XML.hxx: Specialize operator() with the
	  provided loader/saver.
	* include/vaucanson/xml/builders.hxx: Simplified.
	* include/vaucanson/xml/contexts/fmp.hxx: Simplified.
	* include/vaucanson/xml/contexts/rw.hxx: Simplified.
	* include/vaucanson/xml/handlers.hh: Add DocAutHandler,
	  DocRegExpHandler, RegExpHandler.
	* include/vaucanson/xml/handlers.hxx: Add DocAutHandler,
	  DocRegExpHandler, RegExpHandler.
	* include/vaucanson/xml/parsers.hh: Add RegExpParser.
	* include/vaucanson/xml/parsers.hxx: Add RegExpParser.
	* include/vaucanson/xml/printers.hh: Add RegExpPrinter.
	* include/vaucanson/xml/printers.hxx: AddRegExpPrinter.

2009-02-10  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Fix bug in XML support.
	A counter was not initialized which could make it impossible
	to read XML files with <star> tokens...
	* include/vaucanson/xml/regexp.hxx: Initialize a value...

2009-01-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/Makefile.am (TEXI2DVI_FLAGS): Do not hardcode the build
	directory to prevent race conditions during parallel builds of
	several PDF files.
	(mostlyclean-local): Delete all *.t2d directories.

2009-01-26  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix NEWS.txt.
	* doc/NEWS.txt: Be more precise about the new features.

2009-01-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/NEWS.txt: Mention realtime-exp and fix a typo.

2009-01-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/FAQ.txt: Delete.  Of the three entries that was in this
	FAQ two are obsolete (NAN and getopt), and one is not really a
	FAQ.
	(VCSN_DEFAULT_GRAPH_IMPL): Move this documentation ...
	* doc/HACKING.txt: ... here.
	* doc/README.txt: Do not mention de FAQ.
	* doc/Makefile.am (EXTRA_DIST, dist_pdf_DATA): Update.

2009-01-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/README.txt: Remove the date as it hasn't been updated since
	2006.
	(Overview): Mention weighted finite automata.
	(Additional features): Mention --default-graph-impl=listg
	(Layout of the tarball): Update to reflect recent changes.
	(Requirements): Make it clearer that Xerces and Graphviz are
	not optional.
	(See Also): Delete obsolete items.
	(Contacts): Fix contact addresses.


2009-01-22  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Set the correct rights in lrde-upload.sh.
	* lrde-upload.sh: Add read permissions for everyone on
	  `vaucanson-manual.pdf'.

2009-01-22  Alex Hamelin  <hamelin@lrde.epita.fr>

	Release 1.2.95.
	* AUTHORS: Add new author.
	* configure.ac: Change version number.
	* doc/NEWS.txt: Update for release.
	* doc/share/styles/myacronym.sty,
	* doc/share/styles/misc.hva: make share-up.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/predefined_alphabets.hh: More doc.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/predefined_alphabets.hxx (ALPHABET_ASCII,
	ALPHABET_AZ, ALPHABET_AZAZ, ALPHABET_DIGITS): Get rid of these
	macros.
	(predefined_alphabets): Define the alphabets directly inside
	the structure.
	(shortdef): Add a readable definition of the alphabet so that we
	can ...
	(build_predefined_string): ... loop over the predefined_alphabets
	to create the help string.
	* taf-kit/tests/vcsn-char-b.test, taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-z.test: Adjust the test to the slightly
	different output.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/predefined_alphabets.hh,
	taf-kit/src/predefined_alphabets.hxx (alphabet_lookup): New function.
	* taf-kit/src/main.cc (parse_opt): Use alphabet_lookup()
	to simplify the detection of predefined alphabet.
	(alphabet): Move this structure...
	* taf-kit/src/predefined_alphabets.hxx (alphabet): ... here.
	* taf-kit/src/predefined_alphabets.hh (ALPHABET_ASCII,
	ALPHABET_AZ, ALPHABET_AZAZ, ALPHABET_DIGITS): Move these
	definitions...
	* taf-kit/src/predefined_alphabets.hxx: ... here.

2009-01-21  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add preconditions and remove debug code.
	* include/vaucanson/algorithms/reduce.hh,
	* include/vaucanson/algorithms/reduce.hxx: Add preconditions and
	  remove debug code.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Remove dead code.
	* include/Makefile.am: Remove file from the distribution.
	* include/vaucanson/design_pattern/factory.hh: Remove.

2009-01-21  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Comment and add directions for reduce algorithm..
	* include/vaucanson/algorithms/reduce.hh: Add comments about reduce
	  algorithm.
	* include/vaucanson/algorithms/reduce.hxx: replace backward by
	  right_left and forward by left_right.
	* include/vaucanson/misc/direction.hh: add left_right and right_left
	  directions.

2009-01-21  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Use std::abs instead of fabs / fabsf ...
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx:
	  std::abs does the dispatch.

2009-01-21  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Use fabs / fabsf instead of abs.
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx:
	  Replace abs by fabs and fabsf in op_eq for float and double.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo in the ChangeLog.
	* ChangeLog: Fix an email address.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/predefined_alphabets.hxx (build_predefined_string):
	Write "empty word" not "epsilon".
	* taf-kit/tests/vcsn-char-b.test, taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test, taf-kit/tests/vcsn-char-z.test,
	taf-kit/tests/vcsn-int-b.test: Likewise.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (predefined_string): Compute it at startup...
	(main) ... not here.
	* taf-kit/src/predefined_alphabets.hxx,
	taf-kit/src/predefined_alphabets.hh (build_predefined_string):
	Return a pointer to a static string.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* build-aux/vcsn-xml.m4, include/vaucanson/xml/internal/ios.hh,
	include/vaucanson/xml/internal/ios.hxx: Change the Xerces version
	check not to print "Bad version" (the fact we do not support a
	version does not mean that version is bad) and not disallow future
	versions.

2009-01-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Augment the test for two spaces
	to make sure we can really use two spaces.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	rw_composition: Fix a bug for transitions with a polynomial in R.
	Reported by Sylvain Lombardy.
	* include/vaucanson/algorithms/internal/evaluation.hh: Improve
	  documentation. Cosmetic changes.
	* include/vaucanson/algorithms/internal/evaluation.hxx
	  (do_partial_evaluation): Be more precise when receiving dispatch
	  by requiring the first argument to be a `Series'. Call
	  `standard_of' on the whole input expression instead of just the
	  first element in the support. (partial_evaluation): Update
	  according to the new dispatch of `do_partial_evaluation'.
	* include/vaucanson/algorithms/rw_composition.hh: Update the
	  documentation.
	* include/vaucanson/algorithms/rw_composition.hxx: Include the
	  header file `realtime.hh' required by `is_realtime'.
	  (do_rw_composition): Add a precondition on `S'. Improve comments
	  and cosmetic changes. Update the algorithm according to the change
	  to `partial_evaluation'.
	* src/tests/include/Makefile.am: Add a new test to the distribution.
	* src/tests/include/tests/automata/algos/boolean_rw_transducers/rw_composition_test.hh:
	  New regression test.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	rw_composition: Fix a bug in partial_evaluation.
	* include/vaucanson/algorithms/internal/evaluation.hxx
	  (do_partial_evaluation): Iterate through all the states in `Sp'
	  instead of only the initial ones.
	* src/tests/include/Makefile.am: Add new file to the distribution.
	* src/tests/include/tests/automata/algos/boolean_rw_transducers/partial_evaluation_test.hh:
	  New regression test.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Demos: Factor more code in ORR_iterate, fix typos.
	* src/demos/one_rule_rewriting/ORR_iterate.cc: Remove all the
	  references to the macro `DEBUG'. Do not include
	  `tools/dot_display.hh' anymore. Include the header
	  `one_rule_rewriting.hh', and subsequently remove all the redundant
	  function definitions (prefsuf, alpha_convert, alpha_map,
	  replace_left and replace_right). Sanitize namespace usages.
	  (usage): Remove the help about the argument `name'. (main): Do not
	  use argv[4]. Simplify the code by removing the use of the
	  auxiliary function `string_to_int'. Add more comments, and
	  cosmetic changes. Fix the initialization of the loop. Add some
	  code to dump the `iter_ima' variable. When printing informations
	  about automaton: use the already defined `operator<<'.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Demos: Cleanup shortest.hh to be more in line with vcsn.
	* src/demos/one_rule_rewriting/shortest.hh: Add the Copyright
	  notice. Add guards. Cosmetic changes.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Demos: Fix a typo in ORR_demo.
	* src/demos/one_rule_rewriting/ORR_demo.cc (main): Call
	  `realtime_here' on `right_auto' as it is passed as the second
	  argument of `rw_composition', and there is a `is_realtime'
	  precondition on this argument.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	rw_composition: New evaluation_rw algorithm.
	* include/Makefile.am: Add new files to the distribution.
	* include/vaucanson/algorithms/evaluation_rw.hh: New.
	* include/vaucanson/algorithms/evaluation_rw.hxx: New.
	* include/vaucanson/algorithms/internal/evaluation.hxx: Move the
	  functions `evaluation' and `do_evaluation' to `evaluation_rw' and
	  `do_evaluation_rw' respectively (see `evaluation_rw.hh'). Cleanup
	  included headers.
	* include/vaucanson/algorithms/rw_composition.hxx: Include the header
	  file `internal/evaluation.hh'.
	* include/vaucanson/contexts/transducer_functions.thh,
	* include/vaucanson/contexts/transducer_maker.thxx: Include
	  `evaluation_rw.hh' instead of `internal/evaluation.hh'. Call
	  `evaluation_rw' instead of `evaluation'.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix the epsilon of predefined alphabets in --help.
	* taf-kit/src/Makefile.am: Add new file to the distribution.
	* taf-kit/src/main.cc: Only include the `predefined_alphabets.hh'
	  header if relevant. Remove any reference to the `DEFAULT_EPSILON'
	  macro. New variable `predefined_string', to hold the dynamically
	  calculated string displayed when using --help.
	  (main) [!NO_PREDEF_ALPHABETS]: Call the new
	  `build_predefined_string' to populate `predefined_string'.
	* taf-kit/src/predefined_alphabets.hh: Include the
	  `parser_options.hh' header file. Remove the definition of
	  `DEFAULT_EPSILON'. Declare new function `build_predefined_string'.
	* taf-kit/src/predefined_alphabets.hxx: New: Add the implementation
	  of the `build_predefined_string'.
	* taf-kit/tests/vcsn-char-b.test,
	* taf-kit/tests/vcsn-char-fmp-b.test,
	* taf-kit/tests/vcsn-char-fmp-z.test,
	* taf-kit/tests/vcsn-char-z.test: Add the regression test.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Disable predefined alphabets for pair contexts.
	* taf-kit/src/Makefile.am: Define `NO_PREDEF_ALPHABETS' for the
	  `vcsn-char-char-b', `vcsn-char-int-b' and `vcsn-int-int-b'
	  executables.
	* taf-kit/tests/vcsn-char-b.test,
	* taf-kit/tests/vcsn-char-char-b.test,
	* taf-kit/tests/vcsn-char-fmp-b.test,
	* taf-kit/tests/vcsn-char-fmp-z.test,
	* taf-kit/tests/vcsn-char-int-b.test,
	* taf-kit/tests/vcsn-char-z.test,
	* taf-kit/tests/vcsn-int-b.test,
	* taf-kit/tests/vcsn-int-fmp-b.test,
	* taf-kit/tests/vcsn-int-fmp-z.test,
	* taf-kit/tests/vcsn-int-int-b.test,
	* taf-kit/tests/vcsn-int-z.test: Check whether or not a predefined
	  alphabet is defined.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Add support for xerces-c 3.0 (Close #193).
	* build-aux/vcsn-xml.m4: Update the macro `_VCSN_CHECK_XML' to check
	  for xerces-c version x such as 2.3 <= x <= 3. Update the C++ ABI
	  check with code from `internal/ios.hh'.
	* include/Makefile.am: Update distributed files.
	* include/vaucanson/xml/parsers.hxx: Include `xml/internal/ios.hh'
	  instead of `xml/ios.hh'.
	* include/vaucanson/xml/printers.hxx (AutPrinter::print): Use the
	  new `print_xml' function declared in `internal/ios.hh'.
	* include/vaucanson/xml/ios.hh,
	* include/vaucanson/xml/ios.hxx,
	* include/vaucanson/xml/xml_xerces_stream.hh,
	* include/vaucanson/xml/xml_xerces_stream.hxx: Merge these files in
	  the new internal `ios.hh' and `ios.hxx'.
	* include/vaucanson/xml/internal/ios.hh,
	* include/vaucanson/xml/internal/ios.hxx: These files declare all
	  the low level stream handling of Vaucanson, and xerces-c major
	  version dependent code: New `print_xml' function to hide from user
	  level code the XERCES_VERSION_MAJOR macro.
	  (BinCxxInputStream::curPos, BinCxxInputStream::readBytes,
	  XMLXercesStream::writeChars): Update prototype to use `XMLSize_t'
	  and `XERCES_FILEPOS'.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Factor more code with create_element.
	* include/vaucanson/xml/xml_exp_visitor.hxx: Replace each call of
	  `createElement' by a corresponding call of `create_element'.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Use createElementNS when creating DOM nodes.
	* include/vaucanson/xml/tools.hxx (create_element): Use the proper
	  name-space aware function `createElementNS' as Vaucanson has its
	  own name-space.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup dead code.
	* include/Makefile.am: Remove files from the distribution.
	* include/vaucanson/algebra/implementation/series/rat/xml_exp_visitor.hh: Remove.
	* include/vaucanson/algebra/implementation/series/rat/xml_exp_visitor.hxx: Remove.

2009-01-21  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a segfault when handling more than one space (Close #180).
	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx
	  (Lexer::Lexer): Reserve seven elements only for `token_tab_'.
	  Rewrite a loop using an STL idiom.
	* taf-kit/tests/vcsn-char-b.test: Add the regression test for this
	  bug.

2009-01-16  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Prevent vaucanswig from compiling reduce algorithm.
	* vaucanswig/expand.sh: Prevent vaucanswig from compiling reduce
	  algorithm.

2009-01-15  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Merge of the reduction branch.
	* ChangeLog: .
	* configure.ac: .
	* include/Makefile.am: .
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh: .
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx: .
	* include/vaucanson/algorithms/reduce.hh: New.
	* include/vaucanson/algorithms/reduce.hxx: New.
	* include/vaucanson/contexts/automaton_functions.thh: .
	* include/vaucanson/design_pattern/element_ops.hxx: .
	* lib/generate_libvcsn.rb: .
	* taf-kit/src/Makefile.am: .
	* taf-kit/src/r_commands.cc: New.
	* taf-kit/tests/Makefile.am: .
	* taf-kit/tests/vcsn-char-r.test: New.

2008-12-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/ratexp_commands.hh (realtime_exp): New command.
	* taf-kit/tests/vcsn-char-z.test: Add some tests.

2008-12-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/derived_term_automaton.hxx
	(DERIVATES_TRACE_DEBUG): Send traces to cerr, not cout.

2008-12-30  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix the << operator for PartialExp.  Since 2008-10-22 we cannot
	output rational expressions without knowing their structural
	element.

	* include/vaucanson/algorithms/internal/partial_rat_exp.hxx
	(operator<<): Build a rational expression with a structural
	element, for printing.

2008-12-16  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add a wrapper for vcsn-char-r and a first test for reduce.
	* configure.ac: Generate vcsn-char-r wrapper.
	* taf-kit/tests/Makefile.am,
	* taf-kit/tests/vcsn-char-r.test: Add test on the equivalence of two
	  R-automata using reduce.

2008-12-12  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	End of reduce algorithm implementation.
	* include/vaucanson/algorithms/reduce.hh,
	* include/vaucanson/algorithms/reduce.hxx: Add building of the new
	  automaton from the matrix version

2008-12-12  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add a new taf-kit for r_automaton and add reduce to libvcsn-r.
	* lib/generate_libvcsn.rb: Add reduce to libvcsn-r.
	* include/vaucanson/contexts/automaton_functions.thh: Add reduce.
	* taf-kit/src/Makefile.am,
	* taf-kit/src/r_commands.cc,
	* taf-kit/tests/Makefile.am: Generate tafkit for Real semiring.

2008-12-12  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Revert part of r2578.
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx,
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh:
	  revert.

2008-12-11  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo in normalized and subnormalized composition tests.
	* src/tests/include/tests/automata/algos/fmp_transducers/normalized_composition_test.hh,
	* src/tests/include/tests/automata/algos/fmp_transducers/subnormalized_composition_test.hh:
	  Replace `y' by `v'.

2008-12-11  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix make_rat_exp function calls in the test-suite.
	* src/tests/include/tests/automata/algos/boolean_rw_transducers/invert_test.hh,
	* src/tests/include/tests/automata/algos/fmp_transducers/evaluation_fmp_test.hh,
	* src/tests/include/tests/automata/algos/fmp_transducers/normalized_composition_test.hh,
	* src/tests/include/tests/automata/algos/fmp_transducers/subnormalized_composition_test.hh:
	  Use the proper representations while building the ratexp.

2008-12-11  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix invert-test for boolean_rw_transducers.
	* src/tests/include/tests/automata/algos/boolean_rw_transducers/invert_test.hh:
	  Do not generate invalid alphabets.

2008-12-10  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add reduce algorithm.
	* include/Makefile.am: Add reduce.h{h,xx}.
	* include/vaucanson/algorithms/reduce.hh: New.
	* include/vaucanson/algorithms/reduce.hxx: New.

2008-12-10  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add a specialisation of std::swap to help gcc.
	* include/vaucanson/design_pattern/element_ops.hxx: The other
	  specialisation with a template T1 for the first element and a
	  template T2 for the second was ambigous for gcc.

2008-12-10  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add op_neg and op_div to real semirings.
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hh,
	* include/vaucanson/algebra/implementation/semiring/numerical_semiring.hxx:
	  Add op_neg and op_div functions to real semirings.

2008-12-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix some algorithms interfaces.
	* include/vaucanson/algorithms/krat_exp_derivation.hh: Disable
	  the remaining interface as it do not work with Vaucanswig.
	* include/vaucanson/algorithms/eval.hh: Enable the interfaces as the
	  `Word' pseudo-type is handled correctly by Vaucanswig.
	* include/vaucanson/algorithms/krat_exp_constant_term.hh,
	* include/vaucanson/algorithms/krat_exp_derivation.hh,
	* include/vaucanson/algorithms/krat_exp_flatten.hh,
	* include/vaucanson/algorithms/krat_exp_linearize.hh: Replace
	  `*e' by `e' as rat exp need not be dereferenced.
	* include/vaucanson/algorithms/extension.hh: Disable the interfaces
	  as the `Transducer' pseudo-type cannot be handled by Vaucanswig
	  (Vaucanswig do not work for transducers).
	* vaucanswig/expand.sh: Add support for the `Letter' pseudo
	  type.

2008-12-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix constant for rat::exp (Close #196).
	* include/vaucanson/algebra/implementation/series/krat.hxx
	  (op_assign): Name the first argument, so that it is used
	  subsequently. (op_series_set): Use `op_convert' instead of
	  manually calling `constant' (factor more code). Pass the series to
	  various `op_convert' calls. Cosmetic changes.
	* src/tests/include/tests/algebra/series/misc/series_test.hh: Add
	  regression test.

2008-12-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix global_consistency test.
	* src/tests/include/tests/context_headers/automata/global_consistency_test.hh:
	  Be more generic with respect to series representations.

2008-12-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix op_convert for string based monoid (Close #198).
	* include/vaucanson/algebra/implementation/monoid/str_words.hh,
	* include/vaucanson/algebra/implementation/monoid/str_words.hxx:
	  Remove `op_convert' as its meaning may be ambiguous when the word
	  implementation is the same as the literal implementation.
	* src/tests/include/tests/algebra/free_monoid/free_monoid_test.hh:
	  New regression test. Fix a typo.
	* src/tests/include/tests/algebra/series/misc/series_test.hh: Fix
	  some typos so that errors are more meaningful.
	* src/tests/xml/xml_int_trans_tester.cc,
	* src/tests/xml/xml_int_z_trans_tester.cc,
	* src/tests/include/tests/automata/algos/pair_automata/pair_to_fmp_test.hh:
	  Adjust by calling `parse_word'.

2008-12-08  Reuben Thomas  <rrt@sc3d.org>

	Use type abbreviations for delta_iterators.
	AUTOMATION_TYPES defines types for delta_iterator
	and rdelta_iterator, so use them.
	* include/vaucanson/algorithms/accessible.hxx,
	* include/vaucanson/algorithms/aut_to_exp.hxx,
	* include/vaucanson/algorithms/complete.hxx,
	* include/vaucanson/algorithms/determinize.hxx,
	* include/vaucanson/algorithms/eps_removal.hxx,
	* include/vaucanson/algorithms/eps_removal_sp.hxx,
	* include/vaucanson/algorithms/eval.hxx,
	* include/vaucanson/algorithms/internal/evaluation.hxx,
	* include/vaucanson/algorithms/internal/has_neighbour.hxx,
	* include/vaucanson/algorithms/internal/outsplitting.hxx,
	* include/vaucanson/algorithms/is_deterministic.hxx,
	* include/vaucanson/algorithms/letter_to_letter_composition.hxx,
	* include/vaucanson/algorithms/minimization_hopcroft.hxx,
	* include/vaucanson/algorithms/minimization_moore.hxx,
	* include/vaucanson/algorithms/normalized_composition.hxx,
	* include/vaucanson/algorithms/product.hxx,
	* include/vaucanson/algorithms/rw_composition.hxx,
	* include/vaucanson/algorithms/search.hxx,
	* include/vaucanson/algorithms/standard.hxx,
	* include/vaucanson/algorithms/sum.hxx,
	* include/vaucanson/automata/concept/automata_base.hh,
	* include/vaucanson/tools/fsm_dump.hxx,
	* include/vaucanson/tools/gen_random.hxx: Here.

2008-12-08  Reuben Thomas  <rrt@sc3d.org>

	Add INTERFACEs and some new pseudo-types.
	The uses of the new pseudo-types are disabled, as they would
	presumably not work with vaucanswig.
	* include/vaucanson/algorithms/cut_up.hh: Add interfaces.
	* include/vaucanson/algorithms/eval.hh: Add disabled interfaces.
	* include/vaucanson/algorithms/extension.hh: Add interfaces.
	* include/vaucanson/algorithms/krat_exp_constant_term.hh: Add
	  interfaces.
	* include/vaucanson/algorithms/krat_exp_derivation.hh: Add an
	  interface and a disabled interface.
	* include/vaucanson/algorithms/krat_exp_flatten.hh: Add interface.
	* include/vaucanson/algorithms/krat_exp_linearize.hh: Add a disabled
	  interface.
	* include/vaucanson/algorithms/krat_exp_realtime.hh: Add an interface.
	* lib/generate_libvcsn.rb: Add the LinExp and Word pseudo-types. Their
	  uses are currently disabled.

2008-12-08  Reuben Thomas  <rrt@sc3d.org>

	Whitespace correction.
	* include/vaucanson/misc/usual_macros.hh: Make new iterator
	  types line up with everything else.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix typo.
	* ChangeLog: Fix ChangeLog entry of r2565.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Fix
	  English typo. Rephrase the sentence about `adaptive behavior'.

2008-12-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Do not build two
	empty automata in the same file.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add comments about r2553.
	* taf-kit/src/ratexp_commands.hh: Here.
	* taf-kit/tests/vcsn-char-b.test: New regression test.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix a bug.
	* taf-kit/src/parser_options.hh (definition): New attribute
	  `first_space_'.
	* taf-kit/src/parser_options.hxx (push_space): Do not use a static
	  flag as more than one parser_options are used for FMP.
	* taf-kit/tests/automata/char-fmp-b/wd-full.xml: New.
	* taf-kit/tests/defs.in: New XML file.
	* taf-kit/tests/vcsn-char-fmp-b.test: New regression test.
	* taf-kit/tests/Makefile.am: Add new file to the distribution.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add tests for writing data and fix a bug.
	* taf-kit/tests/vcsn-char-b.test,
	* taf-kit/tests/vcsn-char-char-b.test,
	* taf-kit/tests/vcsn-char-fmp-b.test,
	* taf-kit/tests/vcsn-char-fmp-z.test,
	* taf-kit/tests/vcsn-char-int-b.test,
	* taf-kit/tests/vcsn-char-z.test,
	* taf-kit/tests/vcsn-int-b.test,
	* taf-kit/tests/vcsn-int-fmp-b.test,
	* taf-kit/tests/vcsn-int-fmp-z.test,
	* taf-kit/tests/vcsn-int-int-b.test,
	* taf-kit/tests/vcsn-int-z.test: Test handling of writing data.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Fix
	  a bug: New `split_monoid_()', update FMP constructors. Add
	  more comments.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Homogenize XML output.
	* taf-kit/src/edition_commands.hxx: Do not append an `std::endl'
	  after calling `automaton_saver'.
	* taf-kit/tests/vcsn-char-b.test: Regression test.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix ChangeLog for [2543].
	* ChangeLog: Be more precise about what has been done.

2008-12-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Update a test about quot3base2.xml.
	* taf-kit/tests/vcsn-char-fmp-b.test: Check that `div3base2.xml' and
	  the domain of `quot3base2.xml' are equivalent (suggested by
	  Alexandre Duret-Lutz).

2008-12-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Finish Florian's change.

	* include/vaucanson/xml/builders.hxx (create_type_writingData_node):
	Use weightOpening and weightClosing.
	* include/vaucanson/xml/contexts/fmp.hxx
	(create_type_writingData_node): Likewise.

2008-11-28  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Simplify the code in XML system.
	Replace all code similar to:
	  if (ptr)
	    delete ptr;
	By:
	  delete ptr;
	Since delete of null pointer is correct.
	* include/vaucanson/xml/builders.hxx: Here.
	* include/vaucanson/xml/handlers.hxx: Here.
	* include/vaucanson/xml/regexp.hxx: Here.

2008-11-28  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Use "weightOpening" instead of "openWeight".
	Since we never "open" a weight, we just use a symbol to say where is
	the weight: it's a "weight opening symbol".
	Same for weightClosing.
	* data/vaucanson.xsd: Here.
	* include/vaucanson/xml/xmleq.hxx: Here.

2008-11-28  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/vcsn-char-b.test: Use ':' instead of 'echo -n ""'.

2008-11-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/complete.hxx: Do not add the
	state in the for_all_const_states loop, it is wrong when using
	listg and an automata in which a state was removed.
	* src/tests/include/tests/automata/algos/boolean_automata/complete_test.hh:
	Test this.

2008-11-27  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	State the dependences on find_tests.sh explicitly.
	Suggested by Reuben Thomas.

	* Makefile.am ($(top_srcdir)/build-aux/tests.m4): Rebuild
	if find_tests.sh changes.
	* src/tests/test-suites/Makefile.am ($(srcdir)/subdirs.mk):
	Likewise.
	* build-aux/find_tests.sh: Mention that these files are
	automatically generated.
2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix sanity check.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep_base.hh,
	* include/vaucanson/algebra/implementation/series/series_rep_base.hh:
	  Include missing header `concept/letter.hh'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix an outdated test.
	* taf-kit/tests/vcsn-char-b.test: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Overhaul representation handling w.r.t. alphabets.
	* taf-kit/src/fmp_commands.cc: More comments.
	* taf-kit/src/getters.hh: New `set_monoid_writing_data_',
	  `set_series_writing_data_', `set_writing_data'.
	  [WITH_TWO_ALPHABETS]: New `set_boolean_writing_data'.
	* taf-kit/src/getters.hxx: Update getters implementation to have the
	  desired behavior.
	* taf-kit/src/main.cc: Disable collision check thanks to the
	  adaptative behavior.
	* taf-kit/src/ratexp_commands.hh: Rework some commands
	  implementation to correctly handle user provided tokens.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: New structure to overwrite writing data.
	* taf-kit/src/common.hh: New `cmd_flags_t'. (arguments_t): New
	  attributes `cf'. [WITH_TWO_ALPHABETS] (arguments_t): New
	  attributes `cf1' and `cf2'.
	* taf-kit/src/edition_commands.hxx: More comments. Use
	  `set_writing_data' to set the writing data.
	* taf-kit/src/getters.hxx: New function `set_writing_data'.
	* taf-kit/src/main.cc: Update the implementation according to the
	  previous changes.
	* taf-kit/src/parser_options.hh: New method `get_cmd_flags'.
	* taf-kit/src/parser_options.hxx: Update implementation according to
	  the previous changes. Set flags to true when pushing data.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a bug for int based series representations.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hxx:
	  Clear the `spaces' vector, same as `maybe_zero'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Tweak collision checks.
	* taf-kit/src/parser_options.hxx: Fix a typo by renaming the macro
	  `CHECK_COLISION' to `CHECK_COLLISION'. Do not check if `CONCAT'
	  has collisions with letters if it is the empty string.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Overhaul representation handling.
	* include/vaucanson/xml/builders.hh (monGenAction): New attribute
	  `user_rep'. Add more type helpers. (Series flavor)
	* include/vaucanson/xml/builders.hxx (monGenAction::operator()):
	  Rework implementation to use `parse_letter' instead of `parse_word'.
	  (FreeMonoidHandler::end()): Update the implementation according to
	  the previous changes.
	* include/vaucanson/xml/handlers.hxx: Do not use the CTOR with
	  user specified representation if none is provided by the user.
	* include/vaucanson/xml/handlers_base.hh,
	* include/vaucanson/xml/handlers_base.hxx (error): New error
	  reporting function `notletter'.
	* include/vaucanson/xml/contexts/fmp.hxx (ProdMonElmtHandler::start):
	  Use `parse_letter' instead of `parse_word'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add a public parse_letter.
	* include/vaucanson/algebra/concept/alphabets_base.hh: New public
	  interface `parse_letter' to parse a literal as a letter_t.
	* include/vaucanson/algebra/concept/alphabets_base.hxx: Add the
	  implementation of the previous mentioned function.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Revert parts of [2433].
	* include/vaucanson/xml/builders.hxx,
	* include/vaucanson/xml/contexts/fmp.hxx: Ignore representation as
	  the XML representation is not dependent on them when parsing.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Fix a bug when there is no series representation.
	* include/vaucanson/xml/handlers.hxx: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo when reading concat.
	* include/vaucanson/xml/contexts/fmp.hxx: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add CONCAT to change the concatenation operator.
	* taf-kit/src/parser_options.hh: Update the grammar definition.
	  (definition): New `concat_cb' attribute. New `push_concat' method.
	* taf-kit/src/parser_options.hxx (check_collision): Check for
	  collisions with the concat symbol. Add the implementation of
	  `push_concat'. (definition): Update implementation according to
	  the previous changes.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup default_eps_eps and representation_traits.
	* include/vaucanson/algebra/concept/freemonoid_product.hh,
	* include/vaucanson/algebra/concept/freemonoid_product_base.hh,
	* include/vaucanson/algebra/concept/freemonoid_product_base.hxx,
	* include/vaucanson/design_pattern/predecls.hh: Remove the structure
	  `representation_traits'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add tests for quot3base2.xml.
	* taf-kit/tests/vcsn-char-fmp-b.test: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Improve support for SeriesRep.
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/fmp_commands.cc: Use the correct series representation
	  in `make_automaton' and `make_rat_exp' function calls.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add operator== for MonoidRep.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hh,
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx:
	  Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Fix uninitialized attributes in TypeHandler.
	* include/vaucanson/xml/handlers.hxx: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Static polymorphism for SeriesRep via CRTP.
	Rename `series_rep' to `SeriesRep' to be more consistent with the
	other Vaucanson structures. Introduce `SeriesRepBase' to factor more
	code. Rename `series_rep_default' to `SeriesRepDefault'.
	* include/Makefile.am: Add new files to the distribution.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (SeriesRep): Remove useless attributes. New method `disambiguate'.
	  Cosmetic changes.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Add the
	  implementation of the new `disambiguate' for series
	  representations. Simplify `operator=='.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hh,
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hxx:
	  Improve specialization for int based free monoid.
	* include/vaucanson/algebra/implementation/series/series.hh
	  (Series): Remove the const qualifier of `rep_'.
	* include/vaucanson/algebra/implementation/series/series.hxx
	  (Series): Use `disambiguate' when building a series without user
	  provided series representation.
	* include/vaucanson/algebra/implementation/series/series_rep.hh,
	* include/vaucanson/algebra/implementation/series/series_rep.hxx:
	  Streamline `SeriesRep'.
	* include/vaucanson/algebra/implementation/series/series_rep_base.hh: New.
	* include/vaucanson/algebra/implementation/series/series_rep_base.hxx: New.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx,
	* include/vaucanson/contexts/automaton_maker.thh,
	* include/vaucanson/contexts/automaton_maker.thxx,
	* include/vaucanson/xml/contexts/fmp.hh: Only refactoring.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Rename inappropriate type names.
	* include/vaucanson/xml/builders.hh,
	* include/vaucanson/xml/builders.hxx: Rename `self_t' to `monoid_t'
	  and `series_t'.
	* include/vaucanson/xml/contexts/fmp.hh: Rename `self_t' to `srep_t'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Static polymorphism for MonoidRep via CRTP.
	Rename `monoid_rep' to `MonoidRep' to be more consistent with the
	other Vaucanson structures. Introduce `MonoidRepBase' to factor more
	code. Rename `monoid_rep_default' to `MonoidRepDefault'.
	* include/Makefile.am: Add new files to the distribution.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (MonoidRep): Remove useless attributes `empty', `concat' and
	  maybe_epsilon.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx:
	  Streamline the default constructor. Use static polymorphism for
	  `operator=='. Compare the monoid representation when comparing two
	  FMP via `operator=='.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Remove the logic to handle smart epsilon representation selection.
	  Use `disambiguate' instead.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hh:
	  Introduce the `EXACT_TYPE' macro. (MonoidRep): Remove useless
	  attributes according to the previous changes.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hxx:
	  Add more comments. Cosmetic changes.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hh: Use
	  CRTP idiom.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx:
	  Remove factored implementation.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep_base.hh: New.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep_base.hxx: New.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx,
	* include/vaucanson/contexts/automaton_maker.thh,
	* include/vaucanson/contexts/automaton_maker.thxx,
	* include/vaucanson/xml/builders.hxx,
	* include/vaucanson/xml/contexts/fmp.hxx,
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	  Only refactoring.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Overhaul support for series representations.
	* data/vaucanson.xsd: New complexType `seriesWritingData'. Rework
	  the `writingData' element in `valueType'.
	* include/vaucanson/xml/builders.hh: New
	  `SeriesRepresentationHandler'. New `create_series_representation'
	  and `create_series_representationh'. Add an argument to
	  `create_monoid' and `check_monoid_consistency'.
	* include/vaucanson/xml/builders.hxx: Add the implementation of
	  `SeriesRepresentationHandler', mostly of based on
	  `FreeMonoidHandler'. (create_monoid): Update implementation to
	  reflect the new prototype. Add the implementation of
	  `create_series_representation' and
	  `create_series_representationh'. (check_monoid_consistency):
	  Update implementation to reflect the new prototype with some
	  overhauls. (create_type_writingData_node): Rename `weightOpening'
	  to `openWeight' and `weightClosing' to `closeWeight'.
	* include/vaucanson/xml/contexts/fmp.hh: New macro `FMPsreptype' to
	  make code tighter. Add a specialization for
	  `SeriesRepresentationHandler' for FMP. Add one argument to
	  `create_monoid' and `check_monoid_consistency'. New
	  `create_type_writingData_node' specialization to better support
	  series representations for FMP.
	* include/vaucanson/xml/contexts/fmp.hxx: Add the implementation of
	  the new specialization mostly based on the `FreeMonoidProduct'
	  one. Add the implementation of `create_type_writingData_node'.
	* include/vaucanson/xml/handlers.hh (TypeHandler): Cosmetic changes.
	  New `reph_' and `rep_' attributes.
	* include/vaucanson/xml/handlers.hxx: Use the new
	  `create_series_representation' to mimic the handling of monoid.
	* include/vaucanson/xml/xmleq.hh: Cosmetic changes. Does the
	  following renaming: `plus' -> `plusSym', `times' -> `timesSym',
	  `spaces' -> `spacesSym'. New `starSym', `type' and `free'
	  attributes.
	* include/vaucanson/xml/xmleq.hxx: Update the implementation
	  according to the previous changes.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Move int based FreeMonoid related specialization.
	* include/Makefile.am: Add new files to the distribution.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	  Remove include of `alphabet_set.hh'. Remove `monoid_rep'
	  specialization for int based alphabet_set based FreeMonoid.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Remove implementation according to the previous change.
	* include/vaucanson/algebra/implementation/series/series.hh: Remove
	  include of `free_monoid.hh'. Remove `series_rep' specialization for
	  int based alphabet_set based FreeMonoid.
	* include/vaucanson/algebra/implementation/series/series.hxx: Remove
	  implementation according to the previous change.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hh: New.
	* include/vaucanson/algebra/implementation/monoid/free_monoid_int.hxx:
	  New.
	* include/vaucanson/automata/generic_contexts/int_boolean_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_boolean_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_fmp_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_fmp_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_max_plus_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_min_plus_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/char_int_boolean_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_int_boolean_automaton_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_transducer_structures.hh:
	  Include required specializations.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Simplify specialization of monoid and series representation for FMP.
	* include/vaucanson/algebra/concept/freemonoid_product.hh: Remove
	  inheritance, and update accordingly. New `operator==' for series
	  representations (FMP flavor).
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Update
	  the implementation according to the previous change.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Simplify specialization for int based Series representation.
	* include/vaucanson/algebra/implementation/series/series.hh: Remove
	  inheritance. Update the structure according to this change.
	* include/vaucanson/algebra/implementation/series/series.hxx
	  (series_rep): Do not call parent CTOR.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Simplify specialization for int based FreeMonoid representations.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	  Remove inheritance. Update the structure according to this change.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx
	  (monoid_rep): Do not not call parent CTOR.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Rework monoid and series representations for FMP.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (monoid_rep): Remove method declarations of `first_projection' and
	  `second_projection'. (series_rep): Add new type helpers. Rename
	  `first_projection' to `first_representation' and
	  `second_projection' to `second_representation'. Remove the `const'
	  qualifier from `first_representation' and `second_representation'.
	  Change return types to references. Add const versions.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Remove
	  implementations of `first_projection' and `second_projection' for
	  `monoid_rep'. Rework implementation of `first_representation' and
	  `second_representation'.
	* include/vaucanson/contexts/fmp_transducer_maker.thh
	  (make_automaton): Remove the last two arguments.
	* include/vaucanson/contexts/fmp_transducer_maker.thxx
	  (make_automaton): Remove a `FIXME'. Update implementation
	  according to the modified prototypes.
	* taf-kit/src/common.hh (arguments_t): Remove the two attributes
	  `srep1' and `srep2'.
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/fmp_commands.cc,
	* taf-kit/src/getters.hxx: Update calls to `make_automaton'.
	* taf-kit/src/main.cc: Use `p_opts1' and `p_opts2' to setup the
	  first and second series representation respectively.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Typo in comments.
	* include/vaucanson/algorithms/is_ltl.hh: Here.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Overhaul divkbaseb, new quotkbaseb.
	* data/automata/char-b/divkbaseb.cc: Include <vector>. Add more
	  comments. Use an `std::vector' to map integers to letters. Use
	  closed form of `d' in the loop.
	* data/automata/char-fmp-b/Makefile.am: Build new executable
	  `quotkbaseb'. New automaton `quot3base2.xml'.
	* data/automata/char-fmp-b/quotkbaseb.cc: New.
	* data/automata/char-z/Makefile.am: Build new executable
	  `divkbaseb'. New automaton `div3base2.xml'
	* data/automata/char-z/divkbaseb.cc: New.
	* taf-kit/tests/vcsn-char-z.test: New test for the `Z' flavor of
	  `div3base2.xml'.

2008-11-27  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add a test for div3base2.
	* taf-kit/tests/vcsn-char-b.test: Here.

2008-11-27  Reuben Thomas  <rrt@sc3d.org>

	cderivate is not built into libs, so don't guard it.
	* include/vaucanson/algorithms/krat_exp_cderivation.hh: This file is
	  never included in libs, so comment out the VCSN_USE_LIB guard and
	  add a FIXME.

2008-11-27  Reuben Thomas  <rrt@sc3d.org>

	Flag a problem with FIXME.
	* src/tests/bin/generate-test-suite.sh: .

2008-11-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* build-aux/find_tests.sh: Correct typo in EXTRA_DIST definition.

2008-11-25  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/test-suites/context_headers_int_boolean_transducer.defs,
	src/tests/test-suites/context_headers_int_fmp_transducer.defs,
	src/tests/test-suites/context_headers_int_z_fmp_transducer.defs,
	src/tests/test-suites/context_headers_int_z_transducer.defs,
	src/tests/test-suites/int_boolean_transducer.defs,
	src/tests/test-suites/int_fmp_transducer.defs,
	src/tests/test-suites/int_z_fmp_transducer.defs,
	src/tests/test-suites/int_z_transducer.defs: New files.
	* src/tests/test-suites/generate-all.sh: Adjust to generate test
	suites for all the above.
	* src/tests/test-suites/boolean_transducer.defs: Equip with
	automaton and rw_transducer namespaces.

2008-11-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Rewrite some tests so they can be used with int letters.

	* src/tests/include/tests/automata/algos/boolean_rw_transducers/invert_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/evaluation_fmp_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/is_ltl_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/is_subnormalized_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/normalized_composition_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/sub_normalize_test.hh,
	src/tests/include/tests/automata/algos/fmp_transducers/subnormalized_composition_test.hh,
	src/tests/include/tests/context_headers/fmp_transducers/global_consistency_test.hh:
	Rewrite without hardcoding the use of characters as letters.

2008-11-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>


	Fix make_automaton() to support int letters.

	* include/vaucanson/contexts/fmp_transducer_maker.thh,
	include/vaucanson/contexts/fmp_transducer_maker.thxx
	(make_automaton): Take first_monoid_elt_value_t and
	second_monoid_elt_value_t as arguments, do not hardcode
	std::string.

2008-11-26  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/check/check-flags.mk (AM_CPPFLAGS): Search $(srcdir)/..
	* src/tests/bin/generate-test-suite.sh (all_failcomp): Do not
	"cat" the defs file, include it. This way we get dependency
	tracking on this file for free an we can change a defs files
	without having to regenerate the whole test suite.
	* build-aux/find_tests.sh: EXTRA_DIST the defs files.
	* src/tests/test-suites/Makefile.am (EXTRA_DIST): Append to this
	variable which is now defined in subdirs.mk.

2008-11-25  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/test-suites/generate-all.sh: Factor the two loops,
	effectively reverting r2410.

2008-11-25  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/test-suites/generate-all.sh: Enable context headers
	tests for char_char_boolean and int_int_boolean automata.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/test-suites/subdirs.mk: Remove from the repository as
	it is generated by bootstrap.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/include/tests/context_headers/automata/global_consistency_test.hh:
	Rewrite to work regardless of the alphabet.  It now works also for
	alphabets of pairs.  Thanks to Jerome Galtier for the help.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx
	(lex, insert_word): Rewrite to first recognize the largest word
	possible, and then match other token.  This is the reverse of was
	was done before, and it was a hindrance: 21#34 would not be
	parsed if 1 was the empty word, '(a,b)' would not be recognized as
	a letter in an alphabet of pairs because the parser would first
	strip the parenthesis and then try to parse 'a,b' as a word.
	* taf-kit/tests/vcsn-int-b.test: Adjust a test.
	* taf-kit/tests/vcsn-char-char-b.test: Add some tests.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algebra/implementation/monoid/str_words.hxx
	(op_parse): Rewrite and comment.
	* taf-kit/tests/vcsn-int-b.test: Add some tests.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algebra/implementation/letter/int_letter.hxx
	(literal_to_letter): Disallow leading '+' in numbers.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* b/include/vaucanson/algebra/concept/freemonoid_base.hh,
	b/include/vaucanson/algebra/concept/freemonoid_base.hxx,
	include/vaucanson/algebra/implementation/monoid/str_words.hh,
	include/vaucanson/algebra/implementation/monoid/str_words.hxx
	(op_parse, parse_word): Return a pair instead of a bool.  The
	integer returned along with the bool indicates how many characters
	of the input string were read.
	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx
	(insert_word): Adjust call site.
	* include/vaucanson/xml/contexts/fmp.hxx
	(ProdMonElmtHandler<T>::start): Likewise.
	* taf-kit/src/getters.hexx (get_word): Likewise.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hxx:
	Fix handling of empty containers.  The change I made on 2008-11-12
	was wrong and caused many failures with "make check" was run on
	the listg implementation.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Introduce --with-default-graph-impl=... to replace
	CPPFLAGS=-DWITH_DEFAULT_GRAPH_IMPL=... that do not work anymore
	bcause TAF-Kit includes config.h which hardcodes
	WITH_DEFAULT_GRAPH_IMPL.

	* configure.ac (--with-default-graph-impl): Support this new option.
	* doc/FAQ.txt: Document it.

2008-11-24  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/misc/usual_macros.hh (remove_in, XML_FAIL):
	Remove these unused macros.

2008-11-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/sum.hxx,
	include/vaucanson/algorithms/thompson.hxx,
	include/vaucanson/xml/printers.hxx: Call AUTOMATON_TYPES before
	calling for_all_const_states, for_all_const_initial_states,
	for_all_const_final_states, for_all_states, for_all_transitions,
	for_all_initial_states, or for_all_final_states.

2008-11-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hh,
	include/vaucanson/automata/implementation/listg/listg_sparse_interval.hxx,
	include/vaucanson/misc/sparse_interval.hh,
	include/vaucanson/misc/sparse_interval.hxx (operator==, operator!=):
	Declare as const methods.

2008-11-23  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/bench/common/bench.mk: Include $(top_srcdir)/vaucanson.mk so
	that we get Boost's flags.

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Try to fix things after r2485, but I'm not sure what I'm doing.

	* src/demos/algorithms/universal.cc (universal): Correct the code
	from the removal of delta_tmp by inserting into delta_ret
	directly, remove illegal typenames, use delta_iterator instead of
	delta_transition_iterator.  Now the program compiles fine but it
	makes an assertion failure.
	(union_structure): Remove, it is not used anymore.
	* src/demos/one_rule_rewriting/shortest.hh (shortest): Remove
	illegal typenames, fix some typos in variable names, use
	delta_iterator instead of delta_transition_iterator

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Change all occurences of benchs and benches to either bench (in
	filenames and targets) or benchmarks (in text).

	* Makefile.am, bootstrap, configure.ac, doc/manual/developer.tex,
	src/Makefile.am: Adjust to the following renamings.
	* src/benchs/Makefile.am: Rename to src/bench/Makefile.am
	* src/benchs/common/Makefile.am: Rename to src/bench/common/Makefile.am
	* src/benchs/common/alpha.syms: Rename to src/bench/common/alpha.syms
	* src/benchs/common/bench.mk: Rename to src/bench/common/bench.mk
	* src/benchs/common/bench_automaton.hh: Rename to
	src/bench/common/bench_automaton.hh
	* src/benchs/common/bench_constructs.hh: Rename to
	src/bench/common/bench_constructs.hh
	* src/benchs/composition/Makefile.bench: Rename to
	src/bench/composition/Makefile.bench
	* src/benchs/composition/normalized_composition_bench.hh: Rename to
	src/bench/composition/normalized_composition_bench.hh
	* src/benchs/composition/rw_composition_bench.hh: Rename to
	src/bench/composition/rw_composition_bench.hh
	* src/benchs/derived_terms/Makefile.bench: Rename to
	src/bench/derived_terms/Makefile.bench
	* src/benchs/derived_terms/derived_terms_bench.hh: Rename to
	src/bench/derived_terms/derived_terms_bench.hh
	* src/benchs/determinization/Makefile.bench: Rename to
	src/bench/determinization/Makefile.bench
	* src/benchs/determinization/determinization_bench.hh: Rename to
	src/bench/determinization/determinization_bench.hh
	* src/benchs/determinization/determinization_bench_fsm.cc: Rename to
	src/bench/determinization/determinization_bench_fsm.cc
	* src/benchs/eps_removal/Makefile.bench: Rename to
	src/bench/eps_removal/Makefile.bench
	* src/benchs/eps_removal/eps_removal_bench.hh: Rename to
	src/bench/eps_removal/eps_removal_bench.hh
	* src/benchs/generate_benchs.sh: Rename to src/bench/generate_bench.sh
	Also to not EXTRA_DIST Makefile.bench files, Automake will already
	distribute them since they are included by a Makefile.am
	* src/benchs/iterators/Makefile.bench: Rename to
	src/bench/iterators/Makefile.bench
	* src/benchs/iterators/accessible_bench.hh: Rename to
	src/bench/iterators/accessible_bench.hh
	* src/benchs/iterators/iterator_bench.hh: Rename to
	src/bench/iterators/iterator_bench.hh
	* src/benchs/minimization_2n/Makefile.bench: Rename to
	src/bench/minimization_2n/Makefile.bench
	* src/benchs/minimization_2n/minimization_2n_brzozowski_bench.hh:
	Rename to src/bench/minimization_2n/minimization_2n_brzozowski_bench.hh
	* src/benchs/minimization_2n/minimization_2n_hopcroft_bench.hh: Rename
	to src/bench/minimization_2n/minimization_2n_hopcroft_bench.hh
	* src/benchs/minimization_2n/minimization_2n_moore_bench.hh: Rename to
	src/bench/minimization_2n/minimization_2n_moore_bench.hh
	* src/benchs/minimization_debruijn/Makefile.bench: Rename to
	src/bench/minimization_debruijn/Makefile.bench
	* src/benchs/minimization_debruijn/minimization_debruijn_brzozowski_bench.hh:
	Rename to
	src/bench/minimization_debruijn/minimization_debruijn_brzozowski_bench.hh
	* src/benchs/minimization_debruijn/minimization_debruijn_hopcroft_bench.hh:
	Rename to
	src/bench/minimization_debruijn/minimization_debruijn_hopcroft_bench.hh
	* src/benchs/minimization_debruijn/minimization_debruijn_moore_bench.hh:
	Rename to
	src/bench/minimization_debruijn/minimization_debruijn_moore_bench.hh
	* src/benchs/quotient/Makefile.bench: Rename to
	src/bench/quotient/Makefile.bench
	* src/benchs/quotient/quotient_bool_bench.hh: Rename to
	src/bench/quotient/quotient_bool_bench.hh
	* src/benchs/quotient/quotient_z_bench.hh: Rename to
	src/bench/quotient/quotient_z_bench.hh

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Only build benchmarks during distcheck, in the same way we do for
	demos.  (#138)

	* configure.ac: Recognize --enable-benchs and define the
	ENABLE_BENCHS conditional.
	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Use --enable-benchs during
	distcheck.
	* src/Makefile.am (SUBDIRS): Recurse in benchs/ conditionally.

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/benchs/generate_benchs.sh: Declare benchmarks
	noinst_PROGRAMS, not EXTRA_PROGRAMS.  This way they will be
	compiled even when they are not run and we can ensure they are
	updated if the interface of the library changes.
	* src/benchs/composition/Makefile.bench,
	src/benchs/derived_terms/Makefile.bench,
	src/benchs/determinization/Makefile.bench,
	src/benchs/eps_removal/Makefile.bench,
	src/benchs/iterators/Makefile.bench,
	src/benchs/minimization_2n/Makefile.bench,
	src/benchs/minimization_debruijn/Makefile.bench,
	src/benchs/quotient/Makefile.bench: Adjust.

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Add missing bits so that "make benchs" works in iterators/.

	* src/benchs/iterators/Makefile.bench: New file.
	* src/benchs/iterators/accessible_bench.hh: Add a context.
	* src/benchs/iterators/iterator_bench.hh: Add a context and remove
	any reference to deltaf, deltac, and state iterators.

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Add missing bits so that "make benchs" works in eps_removal/.

	* src/benchs/eps_removal/Makefile.bench: New file.
	* src/benchs/eps_removal/eps_removal_bench.hh: Define a CONTEXT.
	* src/benchs/eps_removal/Makefile.am,
	src/benchs/eps_removal/eps_removal-bench.cc: Remove from the
	repository, they are automatically generated.

2008-11-21  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Re-enable Vaucanswig
	during distcheck.  Because we use bmig by default, compiling
	vaucanswig (which uses listg) is a way to ensure that listg still
	compiles.

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Reinstate listg (too hasty!).
	Reinstate over-hasty removal of listg (r2489).
	* include/Makefile.am: .
	* include/vaucanson/automata/implementation/listg/iterator.hh: New.
	* include/vaucanson/automata/implementation/listg/iterator.hxx: New.
	* include/vaucanson/automata/implementation/listg/listg_handlers.hh: New.
	* include/vaucanson/automata/implementation/listg/listg_handlers.hxx: New.
	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hh: New.
	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hxx: New.
	* include/vaucanson/automata/implementation/listg: New.
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: New.
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: New.

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Disable vaucanswig in make distcheck.
	Vaucanswig won't compile any more owing to the lack of listg. Since it
	is broken anyway, it seems a small extra benefit to compile it during
	make distcheck.
	* Makefile.am: .

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Remove FIXME about proposed additional iterator.
	Entia non sunt multiplicanda praeter necessitatem.
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh: .

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Remove the listg graph implementation.
	To simplify ongoing work, remove the listg graph implementation.
	The framework for multiple implementations is retained for ease of
	adding or changing the graph implementation in future.
	* include/Makefile.am: .
	* include/vaucanson/automata/implementation/listg/iterator.hh: Remove.
	* include/vaucanson/automata/implementation/listg/iterator.hxx: Remove.
	* include/vaucanson/automata/implementation/listg/listg_handlers.hh: Remove.
	* include/vaucanson/automata/implementation/listg/listg_handlers.hxx: Remove.
	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hh: Remove.
	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hxx: Remove.
	* include/vaucanson/automata/implementation/listg: Remove.
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: Remove.
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: Remove.

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Add a FIXME tag to a fixme.
	* src/tests/sanity/Makefile.am: .

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Remove [r]delta_state_iterator.
	[r]delta_state_iterator was poorly designed (the name was
	used to express a type), and not needed	(it was only used
	twice, and dst_of and src_of are convenient
	to use instead).

	Since that only leaves one flavour, [r]delta_transition_iterator,
	it is now called [r]delta_iterator.
	* include/vaucanson/algorithms/accessible.hxx: .
	* include/vaucanson/algorithms/aut_to_exp.hxx: .
	* include/vaucanson/algorithms/complete.hxx: .
	* include/vaucanson/algorithms/determinize.hxx: .
	* include/vaucanson/algorithms/eps_removal.hxx: .
	* include/vaucanson/algorithms/eps_removal_sp.hxx: .
	* include/vaucanson/algorithms/eval.hxx: .
	* include/vaucanson/algorithms/internal/evaluation.hxx: .
	* include/vaucanson/algorithms/internal/has_neighbour.hxx: .
	* include/vaucanson/algorithms/internal/outsplitting.hxx: .
	* include/vaucanson/algorithms/is_deterministic.hxx: .
	* include/vaucanson/algorithms/letter_to_letter_composition.hxx: .
	* include/vaucanson/algorithms/minimization_hopcroft.hxx: .
	* include/vaucanson/algorithms/minimization_moore.hxx: .
	* include/vaucanson/algorithms/normalized_composition.hxx: .
	* include/vaucanson/algorithms/product.hxx: .
	* include/vaucanson/algorithms/rw_composition.hxx: .
	* include/vaucanson/algorithms/search.hxx: .
	* include/vaucanson/algorithms/standard.hxx: .
	* include/vaucanson/algorithms/standard_of.hxx: .
	* include/vaucanson/algorithms/sum.hxx: .
	* include/vaucanson/automata/concept/automata_base.hh: .
	* include/vaucanson/automata/implementation/bmig/iterator.hh: .
	* include/vaucanson/automata/implementation/bmig/iterator.hxx: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/listg/iterator.hh: .
	* include/vaucanson/automata/implementation/listg/iterator.hxx: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: .
	* include/vaucanson/automata/implementation/transpose_view.hh: .
	* include/vaucanson/misc/usual_macros.hh: .
	* include/vaucanson/tools/fsm_dump.hxx: .
	* include/vaucanson/tools/gen_random.hxx: .
	* src/tests/include/tests/automata/implementation_check/iterator_test.hh: .
	* taf-kit/src/edition_commands.hxx: .

2008-11-21  Reuben Thomas  <rrt@sc3d.org>

	Speed up product test by reducing size of automata.
	* src/tests/include/tests/automata/algos/letter_combination_labeled_graphs/product_test.hh:
	  This test was taking far too long. Reduce size drastically from (10, 20) to (2, 4).

2008-11-20  Reuben Thomas  <rrt@sc3d.org>

	Remove deltac iterators.
	The delta_transition_iterator's and delta_state_iterator's are used
	instead.
	* include/vaucanson/algorithms/accessible.hxx: .
	* include/vaucanson/algorithms/aut_to_exp.hxx: .
	* include/vaucanson/algorithms/complete.hxx: .
	* include/vaucanson/algorithms/determinize.hxx: .
	* include/vaucanson/algorithms/eps_removal.hxx: .
	* include/vaucanson/algorithms/eps_removal_sp.hxx: .
	* include/vaucanson/algorithms/eval.hxx: .
	* include/vaucanson/algorithms/internal/evaluation.hxx: .
	* include/vaucanson/algorithms/internal/outsplitting.hxx: .
	* include/vaucanson/algorithms/is_deterministic.hxx: .
	* include/vaucanson/algorithms/letter_to_letter_composition.hxx: .
	* include/vaucanson/algorithms/minimization_hopcroft.hxx: .
	* include/vaucanson/algorithms/minimization_moore.hxx: .
	* include/vaucanson/algorithms/normalized_composition.hxx: .
	* include/vaucanson/algorithms/product.hxx: .
	* include/vaucanson/algorithms/rw_composition.hxx: .
	* include/vaucanson/algorithms/search.hxx: .
	* include/vaucanson/algorithms/standard.hxx: .
	* include/vaucanson/algorithms/standard_of.hxx: .
	* include/vaucanson/algorithms/sum.hxx: .
	* include/vaucanson/automata/concept/automata_base.hh: .
	* include/vaucanson/automata/concept/automata_base.hxx: .
	* include/vaucanson/automata/concept/automata_ops.hh: .
	* include/vaucanson/automata/concept/automata_ops.hxx: .
	* include/vaucanson/automata/concept/kinds.hh: .
	* include/vaucanson/automata/concept/kinds.hxx: .
	* include/vaucanson/automata/implementation/automaton_view.hh: .
	* include/vaucanson/automata/implementation/automaton_view.hxx: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/transpose_view.hh: .
	* include/vaucanson/automata/implementation/transpose_view.hxx: .
	* include/vaucanson/tools/fsm_dump.hxx: .
	* include/vaucanson/tools/gen_random.hxx: .
	* src/benchs/iterators/iterator_bench.hh: .
	* src/demos/algorithms/universal.cc: .
	* src/demos/one_rule_rewriting/shortest.hh: .
	* src/tests/include/Makefile.am: .
	* src/tests/include/tests/automata/algos/boolean_rw_transducers/invert_test.hh: .
	* src/tests/include/tests/automata/algos/letter_combination_labeled_graphs/transition_container_test.hh: .
	* src/tests/include/tests/automata/implementation_check/rdelta_test.hh: Remove.
	* taf-kit/src/edition_commands.hxx: .

2008-11-20  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/automata/concept/automata.hxx,
	include/vaucanson/algebra/implementation/alphabets/alphabet_set.hxx,
	include/vaucanson/algebra/implementation/monoid/str_words.hxx: Add
	missing semicolons after static assertions.  There absence
	prevented the compilation of src/benchs/minimization_2n/.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* data/automata/char-z/Makefile.am,
	data/automata/char-b/Makefile.am,
	data/automata/fmp-char-b/Makefile.am (EXTRA_PROGRAMS): Rename as
	noinst_PROGRAMS so that these programs get built directly and
	especially cleaned.  Not cleaning these files caused distcheck
	errors now that they are rebuilt as a side effect of rebuilding
	the XML files...

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/manual/taf-kit.tex: Do not output and read a1.xml at
	the same time, use eval-nodep when reading a1.xml.
	* doc/manual/extex.mk (%.tex: %.cmd): Remove superfluous
	definition of VCSN_DATA_PATH.
	* doc/manual/extex.pl: Remove useless definition of
	VCSN_DATA_PATH, introduce eval-nodep.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/wrapper.in (VCSN_DATA_PATH): Add missing directory
	component, fixing today's earlier change.

2008-11-19  Reuben Thomas  <rrt@sc3d.org>

	Fix English.
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh:
	  "adresse" -> "address" and "guaranties" -> "guarantees".

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/is_empty.hh: Remove duplicate
	comment.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/xml/handlers.hh (DocHandler): Escape
	<fsmxml> in Doxygen comment to kill a Doxygen warning.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/is_ltl.hxx,
	include/vaucanson/algorithms/realtime.hxx: Typo in comments.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/is_ltl.hh: Use @f$...@f$ around
	math formulae in Doxygen comments.  Reword the description of
	ltl transducer a bit.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>


	* data/automata/char-b/Makefile.am,
	data/automata/char-z/Makefile.am,
	data/automata/char-fmp-b/Makefile.am: Rename MAINTAINERCLEANFILES
	as CLEANFILES now that these XML files are no longer distributed.
	Adjust all rules to build XML files in the build directory and to
	depend on the binary generating them.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/library_commands.hh (get_automata_path): Support
	colons in VCSN_DATA_PATH, return a list of directories.
	(list_automata_command): List all directories of the path.
	* taf-kit/src/getters.hxx (get_aut): Lookup filenames in all
	directories of the search path.
	* taf-kit/tests/wrapper.in (VCSN_DATA_PATH): Use the build
	directory as well as the source directory.
	* include/vaucanson/xml/parsers.hh,
	include/vaucanson/xml/parsers.hxx (get_xsd_path): Support colons
	in VCSN_DATA_PATH, return a const reference to the directory
	holding "vaucanson.xsd", and compute this directory only once.

2008-11-19  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/HACKING.txt (Faster builds): Reformat as rST, and
	add instructions for using distcc.

2008-11-19  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Rework automaton maker interfaces.
	* include/vaucanson/contexts/automaton_maker.thh,
	* include/vaucanson/contexts/automaton_maker.thxx,
	* include/vaucanson/contexts/fmp_transducer_maker.thh,
	* include/vaucanson/contexts/fmp_transducer_maker.thxx: Remove
	  default arguments. Add a function that do not need
	  representations.

2008-11-19  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Do not distribute build xml files in data.
	* data/automata/char-fmp-b/Makefile.am,
	* data/automata/char-b/Makefile.am,
	* data/automata/char-z/Makefile.am: Change `dist' prefix to `nodist'.
	* data/automata/char-b/Makefile.am,
	* data/automata/char-fmp-b/Makefile.am: Remove useless `EXTRA_DIST'
	  variable.

2008-11-19  Reuben Thomas  <rrt@sc3d.org>

	Add hints for quick building.
	* doc/HACKING.txt: Document some hints for a rapid build.
	  Some are annotated with FIXMEs. Thanks very much to Jerome
	  (sorry, J, but svn-commit.sh won't let me type the accents
	  in your name) for suggesting a LARGE ccache, which helps
	  enormously when making small changes. There is no excuse not
	  to use all these techniques with the exception of distcc, and,
	  if you're interested in performance, non-optimization.

2008-11-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc: Include "common.hh" first.  This should
	hopefully fix a compilation failure on OS X.

2008-11-18  Reuben Thomas  <rrt@sc3d.org>

	Set indent-tabs-mode in vaucanson c-style.
	* data/emacs/vaucanson.el: Vaucanson requires tabs (at least,
	  looking at vaucansonize-buffer), so make the c-style also
	  enforce this.

2008-11-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* gnulib/stdint.in.h: Typo in previous patch.  This one was only
	seen on OS X.

2008-11-18  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* gnulib/stdint.in.h: Make sure all types defined with a macro are
	mapped to a typedef, not to a compiler type.  This fixes a
	compilation failure were boost/cstdint.hpp would use "::int8_t"
	and the compiler will see "::signed char".

2008-11-17  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Release 1.2.94.
	* configure.ac: Change version number.
	* doc/NEWS.txt: Update for release.
	* doc/share/styles/myacronym.sty: make share-up.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Overhaul monoid representations and alphabets support.
	* taf-kit/src/common.hh [WITH_TWO_ALPHABETS] (arguments_t): Add a
	  new attribute `alphabet1'. New `add_parser1_option'.
	* taf-kit/src/edition_commands.hxx [WITH_TWO_ALPHABETS]
	  (edit_automaton_command): Use the new `alphabet1' instead of
	  `alphabet'.
	* taf-kit/src/main.cc [WITH_TWO_ALPHABETS] (parse_opts): Use
	  `alphabet1' and `parser1' instead of `alphabet' and `parser'.
	  [WITH_TWO_ALPHABETS] (main): Cleanup parser declarations.
	* taf-kit/src/parser_options.hh,
	* taf-kit/src/parser_options.hxx: Make `parser_options' a
	  parametrized type by templating it with the monoid representation
	  and the series representation types.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Revert [2439].
	* src/tests/xml/int_fmp_ref.dot,
	* src/tests/xml/int_z_fmp_ref.dot: Revert the new default to `1'.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Extend support of writingData to FMP.
	* include/vaucanson/xml/contexts/fmp.hxx: Here.
	* include/vaucanson/xml/xmleq.hxx (XMLEq): Rename `concatSym' to
	  `timesSym'.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update gen_random according to previous changes.
	* include/vaucanson/tools/gen_random.hxx: Do not test against
	  epsilon representation anymore.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add a simple monoid heuristic when not given a representation.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (monoid_rep): Add missing `using' declarations.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx,
	* include/vaucanson/algebra/concept/freemonoid_product.hxx
	  (monoid_rep::monoid_rep): Build a list of realistic epsilon values.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh
	  (monoid_rep): Add missing `using' declaration. Update comments on
	  constructors to reflect the new mechanism.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx
	  (FreeMonoid): Add a simple heuristic to choose an epsilon wisely,
	  when not given a user representation.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hh:
	  Include `vector'. (monoid_rep): Add a new attribute.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx:
	  Include missing `monoid_rep.hh'. Build a default epsilon list.

2008-11-17  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add set_representation for free monoid products.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (FreeMonoidProduct): Add a public method `set_representation'.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Add the
	  implementation of the aforementioned function.

2008-11-14  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a bug in TransposeView.
	* include/vaucanson/automata/implementation/transpose_view.hh
	  (automaton_traits): Reverse the direction of iterators on the
	  transposed automaton.
	* src/tests/include/tests/automata/implementation_check/iterator_test.hh:
	  Improve the test by adding a regression check for this bug.

2008-11-14  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup op_geometry for transpose_view.
	* include/vaucanson/automata/implementation/transpose_view.hh: Add
	  missing `op_geometry' declarations.
	* include/vaucanson/automata/implementation/transpose_view.hxx
	  (op_get_geometry): Rename to `op_geometry'.

2008-11-14  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup minimization-test.
	* src/tests/include/tests/automata/algos/boolean_automata/minimization_test.hh:
	  Remove useless std::ends to be more coherent with other tests.

2008-11-12  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* src/tests/misc/char_traits.cc, src/tests/misc/limits.cc: Include
	<typeinfo> to kill a G++-4.3 warning.

2008-11-12  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/aut_to_exp.hxx (DMChooser::operator()):
	Use misc::limits<int>::max() instead of INT_MAX.
	(HChooser::operator()): Use misc::limits<unsigned int>::max() instead
	of UINT_MAX.

2008-11-12  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/automata/implementation/listg/listg_sparse_interval.hxx
	(SparseInterval::SparseInterval): Ensure that the size is positive.
	(SparseInterval::size): Do not use UINT_MAX.

2008-11-12  Jimmy Ma  <jimmy.ma@lrde.epita.fr>

	Fix compilation with g++-4.3.
	* bmig_graph_letters_spec.hh: here.

2008-11-12  Jimmy Ma  <jimmy.ma@lrde.epita.fr>

	Fix compilation errors with g++-4.3.
	* misc/bitset.hxx:
	  Include <cstring> instead of <cstdlib> for memcpy.
	  Use memset instead of bzero which is now deprecated.

2008-11-12  Jimmy Ma  <jimmy.ma@lrde.epita.fr>

	Fix include dependencies.
	* algorithms/minimization_hopcroft.hxx: cleanup unused include.

2008-11-12  Jimmy Ma  <jimmy.ma@lrde.epita.fr>

	Fix compilation failure with bison.
	* krat_exp_bison.yy: Add missing semicolon.

2008-11-12  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add missing file to the distribution.
	* src/demos/one_rule_rewriting/Makefile.am: Here.

2008-11-12  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add a regression test for #179.
	* taf-kit/tests/vcsn-char-b.test: Here.

2008-11-12  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup delta and rdelta from vaucanswig.
	* vaucanswig/meta/automaton.hh,
	* vaucanswig/meta/vaucanswig_automaton.i,
	* vaucanswig/meta/vauto.hh: Here.

2008-11-12  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Rename a test automaton.
	* taf-kit/tests/automata/char-b/initialseries.xml: Rename from
	  taf-kit/tests/automata/char-b/initseries.xml.

2008-11-11  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix a test for vcsn-int-z.
	* taf-kit/tests/vcsn-int-z.test: Add missing weight input. Add a
	  regression test.

2008-11-11  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Fix a bug with the spaces representation.
	* include/vaucanson/xml/handlers.hxx (TypeHandler<T>::start): Fix
	  typo by changing `plus' to `spaces'.
	* taf-kit/tests/vcsn-int-z.test: Add a regression test.

2008-11-10  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Add support of writingData for typeValue and monoid:
	- plusSym
	- timesSym
	- ...

	* data/vaucanson.xsd: Here.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	Since we need to create the monoid before parsing its content, we need
	to update the representation after its creation. So set_representation
	should be public (or friendly)
	* include/vaucanson/xml/builders.hh: Here.
	* include/vaucanson/xml/builders.hxx: Here.
	* include/vaucanson/xml/handlers.hh: Here.
	* include/vaucanson/xml/handlers.hxx: Here.
	* include/vaucanson/xml/printers.hxx: Here.
	* include/vaucanson/xml/xmleq.hh: Here.
	* include/vaucanson/xml/xmleq.hxx: Here.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add an operator== for series_rep (uniqueness constraints).
	* include/vaucanson/algebra/implementation/series/series_rep.hh:
	  Declare a new `operator==' for comparing two series_rep.
	* include/vaucanson/algebra/implementation/series/series_rep.hxx:
	  Add the implementation of the previously mentioned function.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Update two test to match new defaults.
	* src/tests/xml/int_fmp_ref.dot,
	* src/tests/xml/int_z_fmp_ref.dot: Change `1' to `e' the new empty
	  word representation for int based FMP.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix tests which should have failed in the past.
	* taf-kit/tests/vcsn-char-fmp-b.test: Fix test and test more
	  thoroughly.
	* taf-kit/tests/vcsn-int-b.test: This test was wrong.
	* taf-kit/tests/vcsn-int-fmp-b.test: Fix wrong test. Add one more
	  test case.
	* taf-kit/tests/vcsn-int-z.test: This test was wrong.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Change get_boolean_aut() to take arguments_t as first argument.
	* taf-kit/src/fmp_commands.cc (evaluation_fmp, intersection): Use
	  two arguments.
	* taf-kit/src/getters.hxx (get_boolean_aut): Change type of the first
	  argument from `std::string' to `arguments_t'. Add a second argument
	  of type `int'.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add support for representations structures at various places.
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/fmp_commands.cc,
	* taf-kit/src/getters.hxx,
	* taf-kit/src/ratexp_commands.hh: Add whenever necessary arguments
	  when callings the `make_automaton' function to allow the user
	  changing default with command line arguments.
	* taf-kit/src/pipe_getters.hxx: Add comments.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Fix wrong type when declaring some attributes.
	* taf-kit/src/common.hh: Change type of `mrep1' from `monoid_rep_t'
	  to `first_monoid_rep_t'. Same with `mrep2' to `second_monoid_rep_t'

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	TAF-Kit: Add missing attributes initialization.
	* taf-kit/src/main.cc: Affect the `mrep1', `mrep2', `srep1' and
	  `srep2' attributes with values taken from the command line.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	XML: Preserve representation structures on initialization.

	For backward compatibility and minimum necessary support of the new
	`monoid_rep' and `series_rep', preserve the value passed to the
	automaton loader. These value may be overwritten if the parser
	decides so.
	* include/vaucanson/xml/contexts/fmp.hxx,
	* include/vaucanson/xml/builders.hxx (create_monoid): Use the
	  required structures when constructing the monoid.
	* include/vaucanson/xml/handlers.hh: Add a comment.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Improve support representation in automaton makers.
	* include/vaucanson/contexts/automaton_maker.thh,
	* include/vaucanson/contexts/automaton_maker.thxx,
	* include/vaucanson/contexts/fmp_transducer_maker.thh,
	* include/vaucanson/contexts/fmp_transducer_maker.thxx: Add whenever
	  necessary arguments to `make_automaton' for passing `monoid_rep_t'
	  and `series_rep_t' structures (and their corresponding default
	  arguments).

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add the specialization for int based monoid representations.
	* include/vaucanson/algebra/implementation/series/series.hh: Include
	  `free_monoid.hh'. Add a predeclaration of the `Series' structure.
	  Add a specialization of `series_rep' for int based monoids.
	* include/vaucanson/algebra/implementation/series/series.hxx:
	  Cosmetic changes. Add the implementation of the default
	  constructor for int based series representations.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add new FMP related representation specializations.
	* include/vaucanson/algebra/concept/freemonoid_product.hh: Include
	  `series_rep.hh'. (monoid_rep): Add new methods `first_projection'
	  and `second_projection'. Add `series_rep' specialization for FMP
	  monoids.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Cosmetic
	  changes. Do not set empty to the "1" string. Add implementations
	  of the two previously mentioned methods. Add implementation of the
	  `series_rep' representation.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Use the concat representation in the DumpVisitor.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx
	  (constant): Mimic `op_rout' for monoid elements. (one, zero):
	  update comments.

2008-11-10  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add more type helpers for FMP generic contexts.
	* include/vaucanson/automata/generic_contexts/fmp_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_fmp_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/int_z_fmp_transducer_structures.hh,
	* include/vaucanson/automata/generic_contexts/z_fmp_transducer_structures.hh:
	  New `first_monoid_rep_t', `second_monoid_rep_t',
	  `first_series_rep_t' and `second_series_rep_t' types.

2008-11-09  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Replace "src" by "source" in XML, #189.
	W.r.t the specifications, we should use "source" and not "src"
	in the transitions. (Ticket #189)

	* data/automata/char-rw-b/add1-rw.xml: .
	* data/automata/char-rw-b/quot-3-rw.xml: .
	* data/vaucanson.xsd: .
	* doc/manual/xml.tex: .
	* include/vaucanson/xml/printers.hxx: .
	* include/vaucanson/xml/xmleq.hxx: .
	* src/tests/xml/Makefile.am: Remove useless session test.
	* src/tests/xml/b_ref.xml: .
	* src/tests/xml/fmp_ref.xml: .
	* src/tests/xml/geometry_ref.xml: .
	* src/tests/xml/int_b_ref.xml: .
	* src/tests/xml/int_fmp_ref.xml: .
	* src/tests/xml/int_trans_ref.xml: .
	* src/tests/xml/int_z_fmp_ref.xml: .
	* src/tests/xml/int_z_max_plus_ref.xml: .
	* src/tests/xml/int_z_min_plus_ref.xml: .
	* src/tests/xml/int_z_ref.xml: .
	* src/tests/xml/int_z_trans_ref.xml: .
	* src/tests/xml/label_node_ref.xml: .
	* src/tests/xml/r_ref.xml: .
	* src/tests/xml/session_ref.dot: Remove. Not used anymore.
	* src/tests/xml/session_ref.xml: Remove. Not used anymore.
	* src/tests/xml/trans_ref.xml: .
	* src/tests/xml/xml_session_tester.cc: Remove. Not used anymore.
	* src/tests/xml/z_fmp_ref.xml: .
	* src/tests/xml/z_max_plus_ref.xml: .
	* src/tests/xml/z_min_plus_ref.xml: .
	* src/tests/xml/z_ref.xml: .
	* src/tests/xml/z_trans_ref.xml: .
	* taf-kit/tests/automata/char-b/ambiguous1.xml: .
	* taf-kit/tests/automata/char-b/ambiguous2.xml: .
	* taf-kit/tests/automata/char-b/b_to_transpose.xml: .
	* taf-kit/tests/automata/char-b/b_transposed.xml: .
	* taf-kit/tests/automata/char-b/finalword.xml: .
	* taf-kit/tests/automata/char-b/initialword.xml: .
	* taf-kit/tests/automata/char-b/initseries.xml: .
	* taf-kit/tests/automata/char-b/non_ambiguous1.xml: .
	* taf-kit/tests/automata/char-b/realtime_test.xml: .
	* taf-kit/tests/automata/char-fmp-b/inverted_t1.xml: .
	* taf-kit/tests/automata/char-fmp-b/t1_compose_u1.xml: .
	* taf-kit/tests/automata/char-fmp-b/t2.xml: .
	* taf-kit/tests/automata/char-fmp-b/t2_u-compose_u2.xml: .
	* taf-kit/tests/automata/char-fmp-b/u2.xml: .
	* taf-kit/tests/automata/char-z/standard_c1.xml: .
	* taf-kit/tests/automata/int-b/int-b.xml: .
	* taf-kit/tests/automata/int-z/int-z.xml: .

2008-11-09  Florian Lesaint  <florian.lesaint@lrde.epita.fr>

	Enable the use of xmleq (structure that avoid costly conversion
	of commonly used token from XMLCh* to std::string) for attributes.

	* include/vaucanson/xml/builders.hxx: here.
	* include/vaucanson/xml/handlers.hxx: here.
	* include/vaucanson/xml/tools.hh: here.
	* include/vaucanson/xml/tools.hxx: here.
	* include/vaucanson/xml/xmleq.hh: Add new tokens.
	* include/vaucanson/xml/xmleq.hxx: Add new tokens.

2008-11-09  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Add a set_representation function to the monoid.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh,
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Add a setter for the monoid representation because the xml parser
	  doesn't know the monoid_representation when it contructs the
	  monoid.

2008-11-09  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix sanity check.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hh:
	  Include missing `usual_macros.hh' (reported by Reuben Thomas).
	  Replace include of `ostream' by `iostream'.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx:
	  Remvove include of `iostream'.

2008-11-09  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix documentation manual building.
	* doc/manual/extex.mk: Add definition of `VCSN_DATA_PATH'.
	* doc/manual/extex.pl: Update `wrapping'. Use `identity-nodep' as a
	  filter keyword to prevent makefile dependencies generation. Add
	  filters on `command' (dependencies and path shadowing prevention).
	  Add the generation of the `VCSN_DATA_PATH' environment variable.
	* doc/manual/generate-automata.sh: Rename `dump-automaton' to
	  `identity-nodep'. Update the sed expression to strip the `.xml'
	  suffix before generating the latex code.
	* doc/manual/taf-kit.tex: Refactor `dot-dump' to `--output-type=dot
	  identity', `dump-automaton' to `identity'. Use `identity-nodep'
	  when dependency generation is not welcomed.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Overhaul dot dumper.
	* include/vaucanson/tools/dot_format.hxx (operator()): Be more
	  generic w.r.t. series implementation type.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a bug when printing words.
	* include/vaucanson/algebra/implementation/monoid/str_words.hxx
	  (op_rout): Cosmetic changes. Cleanup. Do not print the first
	  letter twice (this bug is already catched by most tests dealing
	  with dot files).

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup alphabet related files.
	* include/vaucanson/algebra/concept/alphabets_base.hxx: Cosmetic
	  changes. (op_rout): Use internal `letter_to_literal' instead of
	  public `operator<<'.
	* include/vaucanson/algebra/implementation/alphabets/alphabet_set.hxx:
	  Cosmetic changes.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup dump_visitor.hxx.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx
	  (constant): Only use letter printer. Add more FIXMEs.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup the krat_exp_linearize_structure test.
	* src/tests/include/tests/algebra/series/krat/main/krat_exp_linearize_structure_test.hh:
	  Remove the `operator<<' for printing words. Change `operator<<'
	  from namespace `vcsn::misc' to namespace `std'.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Overhaul the couple letter implementation.
	* include/vaucanson/algebra/implementation/letter/couple_letter.hh:
	  Cosmetic changes. Remove useless includes. Remove the `operator<<'
	  definitions for printing couple words, and the weak `operator>>'
	  parser.
	* include/vaucanson/algebra/implementation/letter/couple_letter.hxx:
	  Cosmetic changes. Include `string', `climits' and `vector'.
	  Overhaul the couple letter parser `literal_to_letter'.
	  (letter_to_literal): does the former job of `operator<<'. Remove
	  the implementations of `operator>>' and `operator<<' for letters
	  and words respectively. Rewrite the public `operator<<' to print
	  letters by using `letter_to_literal'.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup int letter implementation.
	* include/vaucanson/algebra/implementation/letter/int_letter.hh:
	  Cosmetic changes. Remove useless includes. Remove the `operator<<'
	  definition.
	* include/vaucanson/algebra/implementation/letter/int_letter.hxx:
	  Cosmetic changes. Include `string' and `climits'.
	  (literal_to_letter): Rewrite the test to be more alile other
	  parser implementations. Remove the `operator<<' implementation.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup char letter implementation.
	* include/vaucanson/algebra/implementation/letter/char_letter.hh:
	  Remove useless includes.
	* include/vaucanson/algebra/implementation/letter/char_letter.hxx
	  (literal_to_letter): Rewrite the test to be more alike other
	  parser implementations.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix the pair_to_fmp test.
	* src/tests/include/tests/automata/algos/pair_automata/pair_to_fmp_test.hh:
	  Update according to changes to `is_realtime' and `is_ltl' in previous
	  patches.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix the is_ltl algorithm.
	* include/vaucanson/algorithms/is_ltl.hxx (do_is_ltl): Remove the
	  `CHECK_LTL_CONDITION' macro. Change the check performed on initial
	  and final transitions.
	* src/tests/include/tests/automata/algos/fmp_transducers/is_ltl_test.hh:
	  Update the test to correspond to the fixed ltl semantic.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix compilation of extension_test.
	* src/tests/include/tests/automata/algos/series_multiplicity_transducers/extension_test.hh:
	  Add missing argument `kind_t'.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix random alphabets generation for transducers.
	* include/vaucanson/tools/gen_random.hh: Include missing
	  `monoid_rep.hh' (reported by Reuben Thomas).
	* include/vaucanson/tools/gen_random.hxx (GenRansomAutomataSet): Do
	  not insert letters whose representation is the same as the
	  representation of the empty word (transducer version).

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Disable consistency check for pair automaton.
	* src/tests/test-suites/generate-all.sh: Split the loop to handle
	  context_header separately. Remove `char_char_boolean' and
	  `int_int_boolean' from the context header loop.
	* src/tests/test-suites/subdirs.mk: Remove test subdirs.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a bug when generating random alphabets.
	* include/vaucanson/tools/gen_random.hxx (GenRandomAutomataSet): Do
	  not insert a letter whose representation is the same as the
	  representation of the empty word.

2008-11-08  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Make sure that tools::generate generates a realtime automaton.
	* include/vaucanson/tools/gen_random.hxx (realtime_test): Fix a typo.
	* src/tests/include/tests/automata/algos/freemonoid_labeled_graphs/realtime_test.hh:
	  Fix a bug when generating random automata.

2008-11-07  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a typo in str_words.
	* include/vaucanson/algebra/implementation/monoid/str_words.hxx
	  (op_rout): Remove parenthesis to the `concat' attribute to fix
	  compilation.

2008-11-07  Vivien Delmon  <vivien.delmon@lrde.epita.fr>

	Redesign op_parse system for monoid.
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/getters.hxx,
	* include/vaucanson/tools/fsm_load.hxx,
	* include/vaucanson/xml/contexts/fmp.hxx,
	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx,
	* include/vaucanson/algebra/concept/freemonoid_base.hh,
	* include/vaucanson/algebra/concept/freemonoid_base.hxx: Remove two
	  function parameters in parse_word.
	* include/vaucanson/automata/concept/automata_base.hxx,
	* include/vaucanson/algebra/concept/alphabets_base.hxx,
	* include/vaucanson/algebra/implementation/alphabets/alphabet_set.hxx,
	* include/vaucanson/algebra/concept/letter.hh,
	* include/vaucanson/algebra/concept/letter.hxx: Make
	  literal_to_letter return a std::pair<bool, letter_t> to handle
	  parsing errors and fix functions that use it.
	* include/vaucanson/algebra/implementation/letter/char_letter.hh,
	* include/vaucanson/algebra/implementation/letter/char_letter.hxx,
	* include/vaucanson/algebra/implementation/letter/couple_letter.hh,
	* include/vaucanson/algebra/implementation/letter/couple_letter.hxx,
	* include/vaucanson/algebra/implementation/letter/int_letter.hh,
	* include/vaucanson/algebra/implementation/letter/int_letter.hxx:
	  Make literal_to_letter return a std::pair<bool, letter_t> to
	  handle parsing errors, fix functions that use it and remove
	  old implementation of op_parse.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hh,
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx,
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh,
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Add concat to monoid_rep.
	* include/vaucanson/algebra/implementation/monoid/str_words.hh,
	* include/vaucanson/algebra/implementation/monoid/str_words.hxx: Add
	* the new implementation of op_parse.
	* src/tests/include/tests/automata/implementation_check/epsilon_label_representation_test.hh:
	  Fix test.

2008-11-06  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add op_parse operator for AlphabetSet.
	* include/vaucanson/algebra/concept/alphabets_base.hh: Cosmetic
	  changes. Add `op_parse' for `AlphabetSetBase'.
	* include/vaucanson/algebra/concept/alphabets_base.hxx: Cosmetic
	  changes. Add implementation of `op_parse'.
	* include/vaucanson/algebra/implementation/alphabets/alphabet_set.hh,
	* include/vaucanson/algebra/implementation/alphabets/alphabet_set.hxx:
	  Add a greedy letter parser for `AlphabetSet'.
	* include/vaucanson/algebra/implementation/alphabets/alphabets.hh:
	  Cosmetic changes. Include `utility'.

2008-11-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* doc/NEWS.txt: Summarize recent TAF-Kit changes.

2008-11-03  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (main): Use strcmp() to compare two char*,
	not std::string::compare().

2008-11-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (parse_opt) [-o, -i]: Ignore the case
	of the argument.
	* taf-kit/tests/vcsn-int-b.test: Use "-o dOt" instead of "-o DOT"
	as a test.

2008-11-02  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/common_commands.hh (dot-dump): Remove.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-fmp-b.test, taf-kit/tests/vcsn-int-b.test,
	taf-kit/tests/vcsn-int-z.test: Use identity -o DOT instead.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (options): Typo in the description of -o.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/common_commands.hh (define_automaton): Remove.
	(edit_automaton): Adjust description.
	* taf-kit/src/edition_commands.hh,
	taf-kit/src/edition_commands.hxx (define_automaton): Remove.
	* taf-kit/tests/vcsn-char-b.test,
	taf-kit/tests/vcsn-char-fmp-b.test,
	taf-kit/tests/vcsn-char-fmp-z.test,
	taf-kit/tests/vcsn-char-z.test,
	taf-kit/tests/vcsn-int-b.test, taf-kit/tests/vcsn-int-fmp-z.test
	taf-kit/tests/vcsn-int-z.test: Use edit-automaton instead
	of define-automaton.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/edition_commands.hxx (edit_automaton_command):
	Start from an empty automaton if the file does not exist.
	Also complain if the file cannot be open for output.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/tests/defs.in (automata_dir, a1, b1, c1, t1, u1):
	Remove these variables, we don't need these explicit paths anymore.
	* taf-kit/tests/vcsn-char-b.test, taf-kit/tests/vcsn-char-z.test,
	taf-kit/tests/vcsn-char-fmp-b.test: Adjust these test to
	refer to a1.xml, b1.xml, etc. directly.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Get rid of dump-automaton. The command "dump-automaton file.xml"
	can now be replaced by "identity file.xml" if there is no
	"file.xml" in the current directory.

	* taf-kit/src/library_commands.hh (dump_automaton_command): Remove.
	* taf-kit/src/common_commands.hh (USE_IO_COMMAND_GROUP): Remove dump.
	* taf-kit/tests/vcsn-char-b.test: Adjust.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/getters.hxx (get_aut): Try to load the file
	from VCSN_DATA_PATH if it is not in the current directory.

2008-11-01  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Change get_aut() and get_exp() to take arguments_t as first
	argument.  For get_exp() this is a simplification, for
	get_aut() this prepares the following patch.

	* taf-kit/src/getters.hh (get_exp): Remove.
	(get_exp_complete): Rename as get_exp() and use two arguments.
	(get_aut): Use two arguments.
	* taf-kit/src/getters.hxx (get_exp, get_aut): Adjust.
	* taf-kit/src/commands_macros.hh (DEFINE_ONE_ARG_COMMAND_,
	DEFINE_ONE_ARG_COMMAND_TWO_ALGOS_, DEFINE_TWO_ARGS_COMMAND_,
	DEFINE_IS_PROPERTY_COMMAND): Adjust to call get_aut() and
	get_exp() using two arguments.
	* taf-kit/src/common_automaton_commands.hh,
	taf-kit/src/common_commands.hh, taf-kit/src/fmp_commands.cc,
	taf-kit/src/ratexp_commands.hh, taf-kit/src/b_commands.cc:
	Adjust all calls to get_aut() or get_exp().

2008-10-31  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Use the .xml suffix with list-automata and dump-automaton.

	* taf-kit/src/library_commands.hh (list_automata_command):
	Do not strip the ".xml" suffix from the display.
	(dump_automaton_command): Do not append the ".xml" suffix
	the the user's input.
	* taf-kit/tests/vcsn-char-b.test: Adjust.

2008-10-31  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/commands_macros.hh (DEFINE_IS_PROPERTY_COMMAND):
	s/Entry/Input/.
	* taf-kit/src/common_commands.hh (has_succ_comp): Likewise.
	(empty): Use DEFINE_IS_PROPERTY_COMMAND.

2008-11-06  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix Taf-Kit build.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx
	  (monoid_rep): Add `inline' keyword.

2008-11-06  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Change default empty word representation for FMP.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx
	  (monoid_rep): Affect the "1" string to the `empty' attribute.

2008-11-06  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add specialization of monoid_rep for int letters.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	  Inlude `alphabet_set.hh'. Add predeclaration of `FreeMonoid'. Add
	  specialization of monoid_rep for int based free monoids.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Add the implementation of the monoid_rep constructor for int based
	  free monoids.

2008-11-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Fix is_empty() to take care of initial and final transitions.

	* include/vaucanson/algorithms/realtime.hxx (do_is_realtime):
	Ensure that the initial and final transition are labeled by a
	scalar.
	* include/vaucanson/algorithms/realtime.hh: Document that initial
	and final arrows of realtime automata should be labeled by the
	empty word (and maybe a weight).
	* taf-kit/tests/automata/char-b/initseries.xml: New file.
	* taf-kit/tests/Makefile.am (EXTRA_DIST): Distribute it.
	* taf-kit/tests/defs.in (initialseries): New variable.
	* taf-kit/tests/vcsn-char-b.test: Add more tests.

2008-11-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/main.cc (main): Make sure program_name, as computed
	by set_program_name(), is used to report errors.
	* taf-kit/src/library_commands.hh (get_automata_path): Use
	program_name to simplify the computation of the directory name.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for monoid_rep in the DumpVisitor.
	* include/vaucanson/algebra/implementation/series/krat.hxx: Update
	  call to DumpVisitor CTOR.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hh:
	  Remove duplicate CTOR. (DumpVisitor): Add new `monoid_rep_'
	  attribute. Include `monoid_rep.hh'.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx
	  (DumpVisitor): Cosmetic changes. Cleanup constructors. Fix `setid'
	  for the empty word representation.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix default arguments for make_rat_exp.
	* include/vaucanson/contexts/automaton_maker.thh,
	* include/vaucanson/contexts/automaton_maker.thxx (make_rat_exp):
	  Use `operator*' to dereference the boost pointers.

2008-11-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* m4/errno_h.m4: Add missing file from previous changes.
	Reported by Reuben.

2008-11-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* taf-kit/src/Makefile.am (LDADD):  Link with gnulib/gnulib.la.
	(AM_CPPFLAGS): Use headers from gnulib/.
	* taf-kit/src/main.cc (main): Call set_program_name() so that
	gnulib's error reporting system print the right program name in
	the output.

2008-11-05  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	Update gnulib and include module "progname".

	* m4/eoverflow.m4: Delete.
	* gnulib/float.in.h, gnulib/Makefile.am, gnulib/stdint.in.h,
	gnulib/stdio.in.h, gnulib/stdlib.in.h, gnulib/strerror.c,
	gnulib/string.in.h, gnulib/strings.in.h, gnulib/sysexits.in.h,
	gnulib/unistd.in.h, gnulib/vasnprintf.c, gnulib/wchar.in.h,
	m4/gnulib-cache.m4, m4/gnulib-common.m4, m4/gnulib-comp.m4,
	m4/include_next.m4, m4/sleep.m4, m4/stdio_h.m4, m4/stdlib_h.m4,
	m4/strerror.m4, m4/string_h.m4, m4/unistd_h.m4, m4/wchar.m4:
	Upgrade from gnulib.
	* gnulib/errno.in.h, gnulib/progname.c, gnulib/progname.h,
	gnulib/stdio-write.c, gnulib/.gitignore: New files.


2008-11-05  Reuben Thomas  <rrt@sc3d.org>

	Remove deltaf iterators.
	* include/vaucanson/algorithms/determinize.hxx: .
	* include/vaucanson/algorithms/eps_removal.hxx: .
	* include/vaucanson/algorithms/eval.hxx: .
	* include/vaucanson/algorithms/internal/has_neighbour.hxx: .
	* include/vaucanson/algorithms/minimization_hopcroft.hxx: .
	* include/vaucanson/automata/concept/automata_base.hh: .
	* include/vaucanson/automata/concept/automata_base.hxx: .
	* include/vaucanson/automata/concept/automata_ops.hxx: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/bmig_graph_letters_spec.hh: .
	* include/vaucanson/automata/implementation/bmig_graph_letters_spec.hxx: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: .
	* src/benchs/iterators/iterator_bench.hh: .

2008-11-05  Reuben Thomas  <rrt@sc3d.org>

	Add label Kind type parameter to Automata and Transducer templates.

	Where before we had Automata<Series> we now have
	Automata<Series, Kind>, where Kind is a label kind.
	The same applies to Transducer.

	For now, labels_are_series remains the default, but
	there is a new list of (mostly unimplemented) kinds:
	labels_are_letters, labels_are_atoms, labels_are_words,
	labels_are_series. This means that labels_are_couples
	is now defunct.

	The kind is given by kind_t in virtual_types of Automata and
	Transducer.
	* include/vaucanson/algorithms/extension.hh: .
	* include/vaucanson/algorithms/extension.hxx: .
	* include/vaucanson/algorithms/invert.hxx: .
	* include/vaucanson/algorithms/ltl_to_pair.hh: .
	* include/vaucanson/algorithms/ltl_to_pair.hxx: .
	* include/vaucanson/algorithms/normalized_composition.hxx: .
	* include/vaucanson/algorithms/pair_to_fmp.hh: .
	* include/vaucanson/algorithms/pair_to_fmp.hxx: .
	* include/vaucanson/algorithms/search.hh: .
	* include/vaucanson/algorithms/search.hxx: .
	* include/vaucanson/algorithms/thompson.hh: .
	* include/vaucanson/algorithms/thompson.hxx: .
	* include/vaucanson/automata/concept/automata.hh: .
	* include/vaucanson/automata/concept/automata.hxx: .
	* include/vaucanson/automata/concept/automata_base.hh: .
	* include/vaucanson/automata/concept/automata_kind.hh: .
	* include/vaucanson/automata/concept/transducer.hh: .
	* include/vaucanson/automata/concept/transducer.hxx: .
	* include/vaucanson/automata/concept/transducer_base.hh: .
	* include/vaucanson/contexts/automaton.thh: .
	* include/vaucanson/contexts/transducer.thh: .
	* include/vaucanson/misc/usual_macros.hh: .
	* include/vaucanson/xml/contexts/fmp.hh: .
	* include/vaucanson/xml/contexts/rw.hh: .
	* include/vaucanson/xml/contexts/rw.hxx: .

2008-11-05  Reuben Thomas  <rrt@sc3d.org>

	Remove test of delta's.
	* src/benchs/iterators/iterator_bench.hh: Remove
	  plain "delta" tests, which no longer compile, as
	  the plain delta iterators have been removed.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for monoid_rep in Taf-Kit.
	* taf-kit/src/common.hh (arguments_t): Cosmetic changes. Add more
	  comments. Reorder some attributes. Add new attribute `mrep'.
	  [WITH_TWO_ALPHABETS] (arguments_t): Add new attributes `mrep1' and
	  `mrep2'.
	* taf-kit/src/getters.hh [!WITH_TWO_ALPHABETS] (get_exp_complete):
	  Add a new argument. Update the `get_exp' macro accordingly.
	* taf-kit/src/getters.hxx,
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/fmp_commands.cc,
	* taf-kit/src/main.cc,
	* taf-kit/src/pipe_getters.hh,
	* taf-kit/src/pipe_getters.hxx: Update calls to `make_rat_exp'.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update make_rat_exp to use monoid_rep.
	* include/vaucanson/contexts/automaton_maker.thh (make_rat_exp): Add
	  new argument `mrep' to allow monoid representation overriding.
	* include/vaucanson/contexts/automaton_maker.thxx (make_rat_exp):
	  Update declaration according to the header file.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup series.
	* include/vaucanson/algebra/implementation/series/series.hh: Update
	  copyright notices. Cosmetic changes.
	* include/vaucanson/algebra/implementation/series/series.hxx: Update
	  copyright notices.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Update the test-suite to use the new representation system.
	* src/tests/include/tests/algebra/series/krat/main/krat_exp_linearize_structure_test.hh,
	* src/tests/include/tests/automata/implementation_check/epsilon_label_representation_test.hh:
	  Here.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add operator== for monoid representation.
	* include/vaucanson/algebra/concept/freemonoid_product.hh: New
	  `operator=='.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Add
	  implementation of `operator==' for FMP monoid_rep.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  Update implementation of `operator==' to use the monoid
	  representation.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hh: New
	  `oprator=='.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx:
	  Add implementation of `operator==' for monoid_rep.

2008-11-05  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix attributes ordering in FreeMonoid.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh
	  (FreeMonoid): Move `alph_' declaration after `rep_' one.

2008-11-04  Reuben Thomas  <rrt@sc3d.org>

	Fix English.
	* include/vaucanson/algebra/concept/semiring_base.hh:
	   "therefor" -> "therefore"; "choosen" -> "chosen".

2008-11-04  Alexandre Duret-Lutz  <adl@lrde.epita.fr>

	* include/vaucanson/algorithms/realtime.hxx (realtime_words_here):
	Fix handling of initial and final arrows introduced on 2008-10-09.
	* taf-kit/tests/automata/char-b/initialword.xml,
	taf-kit/tests/automata/char-b/finalword.xml: New files.
	* taf-kit/tests/Makefile.am (EXTRA_DIST): Distribute them.
	* taf-kit/tests/defs.in (initialword, finalword): New variables.
	* taf-kit/tests/vcsn-char-b.test: Add more tests using these
	new automata.

2008-11-04  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix FMP series representations in Taf-Kit.
	* taf-kit/src/common.hh (arguments_t): Add more comments. Use the
	  `IOAUT_CONTEXT' macro as token representation types depends on
	  context now.
	* taf-kit/src/fmp_commands.cc: Cosmetic changes. Use new attribute
	  `srep1'.

2008-11-04  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add typedefs to FreeMonoidProduct to support representations.
	* include/vaucanson/algebra/concept/freemonoid_product.hh
	  (FreeMonoidProduct): Cosmetic changes. Add `monoid_rep_t' and
	  `shared_monoid_rep_t' to factor some type definitions. Update
	  `representation' prototype and `rep_' attribute declaration to
	  use the new aliases.

2008-11-04  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix attributes visibility in FreeMonoid.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh
	  (FreeMonoid): Move `rep_' attribute from `public' to `protected'.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for the new representation system to parser_options.
	* taf-kit/src/parser_options.hh (options_grammar): Refactor
	  `tok_rep' to `srep', add new `mrep' to support monoid
	  representations. Update comments.
	* taf-kit/src/parser_options.hxx: New functions `get_mrep' and
	  rename `get_tok_rep' to `get_srep'. (rec_check_collision): Update
	  collision check for `ONE'. Update the `push_one' function.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix a bug in Taf-Kit's print_automaton.
	* taf-kit/src/edition_commands.hxx (print_automaton): Use
	  `series_of' instead of `series_value_of'.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Refactor token_representation_t.
	* taf-kit/src/common.hh,
	* taf-kit/src/edition_commands.hxx,
	* taf-kit/src/fmp_commands.cc,
	* taf-kit/src/getters.hh,
	* taf-kit/src/getters.hxx,
	* taf-kit/src/main.cc,
	* taf-kit/src/pipe_getters.hh,
	* taf-kit/src/pipe_getters.hxx: Rename `token_representation_t' to
	  `series_rep_t' and `tok_rep' to `srep'.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Remove useless code in some macros.
	* taf-kit/src/commands_macros.hh (LETTER_CONTEXT): Remove use of the
	  `SET_DEFAULT' macro and `DEFAULT_FROM_TRAITS'. Remove the
	  `SET_DEFAULT' and `DEFAULT_FROM_TRAITS' macro definitions.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix rat::exp dumper.
	* include/vaucanson/algebra/implementation/series/rat/dump_visitor.hxx:
	  (one, zero): Restore use of stream flags.
	  (star): Fix a bug by using the `star' attribute instead of the
	  `times' attribute.
	  (DumpVisitor): Restore previous behaviour regarding stream flags,
	  to change some token representation.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix krat_exp_parser to handle one again.
	* include/vaucanson/algebra/implementation/series/krat_exp_parser.hxx:
	  Use type helpers to factor some codes. (Lexer): When parsing a
	  word and it returns the empty word, create the correct rat::exp
	  node.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Change default null series representation.
	* include/vaucanson/algebra/implementation/series/series_rep.hxx:
	  Initialize the `zero' attribute with the string "0" instead of
	  "null".

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cleanup polynoms implementation.
	* include/vaucanson/algebra/implementation/series/polynoms.hh:
	  Cosmetic changes. Remove useless (duplicated code with `op_rout')
	  `operator<<' declaration.
	* include/vaucanson/algebra/implementation/series/polynoms.hxx:
	  Cosmetic changes. Remove useless `operator<<' declaration.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Change empty word representation to match char letters defaults.
	* include/vaucanson/algebra/implementation/monoid/monoid_rep.hxx:
	  Initialize the `empty' attribute with the string "1" instead of
	  the string "0".

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add more type helpers for FreeMonoid and Series.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh
	  (FreeMonoid): Add `monoid_rep_t' and `shared_monoid_rep_t'
	  typedefs. Use new types in the `representation()' prototype and
	  attributes declarations.
	* include/vaucanson/algebra/implementation/series/series.hh
	  (Series): Add `series_rep_t' and `shared_series_rep_t' typedefs.
	  Use new types in the `representation()' prototype and attributes
	  declarations.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix op_parse for char letters.
	* include/vaucanson/algebra/implementation/letter/char_letter.hh:
	  Cosmetic changes. (op_parse): Use `FreeMonoid' specialization
	  instead of `FreeMonoidBase'. Rename `s' argument to `in', and
	  `set' to `s' to be more coherent with other parsers and dumpers.
	* include/vaucanson/algebra/implementation/letter/char_letter.hxx:
	  Cosmetic changes. Update prototypes based on the previous header
	  file. (op_parse): Remove useless `typename' keyword. Add support
	  for parsing empty word representations. It was handled by
	  krat_exp_parser before [2307]. Add more comments.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for series representation to make_rat_exp.
	* include/vaucanson/contexts/automaton_maker.thh (make_rat_exp):
	  Cosmetic changes. Remove useless parenthesis. Add a new argument
	  with default value to get a series representation.
	* include/vaucanson/contexts/automaton_maker.thxx: Update prototype
	  accordingly to header changes. (make_rat_exp): use new srep
	  argument when constructing series structures.

2008-11-03  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add representation typedefs in usual macros.
	* include/vaucanson/misc/usual_macros.hh
	  (AUTOMATON_TYPES_MAYBE_TYPENAME): Add typedefs `series_rep_t' and
	  `monoid_rep_t' to support series representations and monoid
	  representations respectively.

2008-10-31  Reuben Thomas  <rrt@sc3d.org>

	English fixes.
	Improve spelling and grammar in some comments.
	* include/vaucanson/algorithms/internal/has_neighbour.hxx: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: .

2008-10-31  Reuben Thomas  <rrt@sc3d.org>

	Get argp from gnulib.
	Get rid of externals annoyances by getting argp from gnulib, the way
	it should be done. It may be useful to use gnulib for other things
	too; in particular, current gnulib has just introduced complexity
	metrics and coverage checks.

	N.B. Only developers who wish to change the gnulib setup need to
	install gnulib; all the necessary files for compilation are in
	Subversion.

	Care is required when deciding what files should be checked in and
	which ignored, as gnulib does not (yet) support Subversion. Git users
	will be happy, as they are automatically catered for. I used a simple
	technique: before updating the gnulib settings, I removed the gnulib
	and m4 directories, and then I added to Subversion all the files that
	gnulib created.

	Also, note that because we already use lib/ for the Vaucanson libraries,
	gnulib-tool needs to be invoked with --source-base=gnulib, which is
	where it stores its source files.
	* Makefile.am: .
	* build-aux/link-warning.h: New.
	* configure.ac: .
	* gnulib/Makefile.am: New.
	* gnulib/alloca.c: New.
	* gnulib/alloca.in.h: New.
	* gnulib/argp-ba.c: New.
	* gnulib/argp-eexst.c: New.
	* gnulib/argp-fmtstream.c: New.
	* gnulib/argp-fmtstream.h: New.
	* gnulib/argp-fs-xinl.c: New.
	* gnulib/argp-help.c: New.
	* gnulib/argp-namefrob.h: New.
	* gnulib/argp-parse.c: New.
	* gnulib/argp-pin.c: New.
	* gnulib/argp-pv.c: New.
	* gnulib/argp-pvh.c: New.
	* gnulib/argp-xinl.c: New.
	* gnulib/argp.h: New.
	* gnulib/asnprintf.c: New.
	* gnulib/basename.c: New.
	* gnulib/dirname.c: New.
	* gnulib/dirname.h: New.
	* gnulib/error.c: New.
	* gnulib/error.h: New.
	* gnulib/exitfail.c: New.
	* gnulib/exitfail.h: New.
	* gnulib/float+.h: New.
	* gnulib/float.in.h: New.
	* gnulib/getopt.c: New.
	* gnulib/getopt.in.h: New.
	* gnulib/getopt1.c: New.
	* gnulib/getopt_int.h: New.
	* gnulib/gettext.h: New.
	* gnulib/intprops.h: New.
	* gnulib/malloc.c: New.
	* gnulib/mempcpy.c: New.
	* gnulib/printf-args.c: New.
	* gnulib/printf-args.h: New.
	* gnulib/printf-parse.c: New.
	* gnulib/printf-parse.h: New.
	* gnulib/rawmemchr.c: New.
	* gnulib/rawmemchr.valgrind: New.
	* gnulib/size_max.h: New.
	* gnulib/sleep.c: New.
	* gnulib/stdbool.in.h: New.
	* gnulib/stdint.in.h: New.
	* gnulib/stdio.in.h: New.
	* gnulib/stdlib.in.h: New.
	* gnulib/strcasecmp.c: New.
	* gnulib/strchrnul.c: New.
	* gnulib/strchrnul.valgrind: New.
	* gnulib/strerror.c: New.
	* gnulib/string.in.h: New.
	* gnulib/strings.in.h: New.
	* gnulib/stripslash.c: New.
	* gnulib/strncasecmp.c: New.
	* gnulib/strndup.c: New.
	* gnulib/strnlen.c: New.
	* gnulib/sysexits.in.h: New.
	* gnulib/unistd.in.h: New.
	* gnulib/vasnprintf.c: New.
	* gnulib/vasnprintf.h: New.
	* gnulib/vsnprintf.c: New.
	* gnulib/wchar.in.h: New.
	* gnulib/xalloc-die.c: New.
	* gnulib/xalloc.h: New.
	* gnulib/xmalloc.c: New.
	* gnulib/xsize.h: New.
	* gnulib/xstrndup.c: New.
	* gnulib/xstrndup.h: New.
	* gnulib: New.
	* m4/alloca.m4: New.
	* m4/argp.m4: New.
	* m4/dirname.m4: New.
	* m4/dos.m4: New.
	* m4/double-slash-root.m4: New.
	* m4/eoverflow.m4: New.
	* m4/error.m4: New.
	* m4/exitfail.m4: New.
	* m4/extensions.m4: New.
	* m4/float_h.m4: New.
	* m4/getopt.m4: New.
	* m4/gnulib-cache.m4: New.
	* m4/gnulib-common.m4: New.
	* m4/gnulib-comp.m4: New.
	* m4/gnulib-tool.m4: New.
	* m4/include_next.m4: New.
	* m4/inline.m4: New.
	* m4/intmax_t.m4: New.
	* m4/inttypes_h.m4: New.
	* m4/longlong.m4: New.
	* m4/malloc.m4: New.
	* m4/mempcpy.m4: New.
	* m4/printf.m4: New.
	* m4/rawmemchr.m4: New.
	* m4/size_max.m4: New.
	* m4/sleep.m4: New.
	* m4/stdbool.m4: New.
	* m4/stdint.m4: New.
	* m4/stdint_h.m4: New.
	* m4/stdio_h.m4: New.
	* m4/stdlib_h.m4: New.
	* m4/strcase.m4: New.
	* m4/strchrnul.m4: New.
	* m4/strerror.m4: New.
	* m4/string_h.m4: New.
	* m4/strings_h.m4: New.
	* m4/strndup.m4: New.
	* m4/strnlen.m4: New.
	* m4/sysexits.m4: New.
	* m4/unistd_h.m4: New.
	* m4/vasnprintf.m4: New.
	* m4/vsnprintf.m4: New.
	* m4/wchar.m4: New.
	* m4/wchar_t.m4: New.
	* m4/wint_t.m4: New.
	* m4/xalloc.m4: New.
	* m4/xsize.m4: New.
	* m4/xstrndup.m4: New.
	* m4: New.
	* taf-kit/src/Makefile.am: .
	* taf-kit/src/main.cc: .

2008-10-31  Reuben Thomas  <rrt@sc3d.org>

	Remove (classic) delta iterators.
	The classic delta iterators are used nowhere, so remove them.
	(Only deltac and deltaf are used.)
	Rejoice as nearly 1,400 lines of code disappears!
	* include/vaucanson/automata/concept/automata_base.hh: .
	* include/vaucanson/automata/concept/automata_base.hxx: .
	* include/vaucanson/automata/concept/automata_ops.hh: .
	* include/vaucanson/automata/concept/automata_ops.hxx: .
	* include/vaucanson/automata/concept/kinds.hh: Also add back missing brace
	  removed in r2313.
	* include/vaucanson/automata/concept/kinds.hxx: Also add back missing brace
	  removed in r2313.
	* include/vaucanson/automata/implementation/automaton_view.hh: .
	* include/vaucanson/automata/implementation/automaton_view.hxx: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hh: .
	* include/vaucanson/automata/implementation/bmig_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hh: .
	* include/vaucanson/automata/implementation/listg_graph_impl.hxx: .
	* include/vaucanson/automata/implementation/transpose_view.hh: .
	* include/vaucanson/automata/implementation/transpose_view.hxx: .
	* src/tests/include/tests/automata/implementation_check/rdelta_test.hh: .

2008-10-30  Reuben Thomas  <rrt@sc3d.org>

	Fix English typo.
	* include/vaucanson/algorithms/internal/build_pattern.hxx:
	  "an other" -> "another".

2008-10-30  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add more filters to generate_libvcsn.rb and expand.sh.
	* lib/generate_libvcsn.rb: Make `pair_to_fmp' a pair automaton only
	  algorithm.
	* vaucanswig/expand.sh: Ignore `pair_to_fmp'.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Use monoid representation for FMP words implementation.
	* include/vaucanson/algebra/implementation/monoid/pair_str_words.hh
	  (op_first, op_second, op_in_mirror, op_length): Remove `algebra'
	  namespace qualifier.
	  (op_rout): Rename the first template argument from `Self' to `F',
	  add the template argument `S' and remove the template argument
	  `T'. Remove `algebra' namespace qualifier. Use `FreeMonoidProduct'
	  and explicit word type. Cosmetic changes.
	* include/vaucanson/algebra/implementation/monoid/pair_str_words.hxx:
	  Cosmetic changes.
	  (op_rout): Update signature according to the header file. Use
	  monoid representation tokens (open_par, sep, close_par).

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add support for monoid representation in fmp.
	* include/vaucanson/algebra/concept/freemonoid_product.hh: Add
	  predeclaration of `FreeMonoidProduct'. Add specialization of
	  `monoid_rep' for the `FreeMonoidProduct' concept. Add constructor
	  to explicitly give the monoid representation. Add new attribute
	  and accessor `rep_'. Cosmetic changes.
	* include/vaucanson/algebra/concept/freemonoid_product.hxx: Add
	  initialization of the `rep_' attribute to all constructors. Add
	  implementation of the new constructor. Cosmetic changes.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add the missing op_rout for FMP_base.
	* include/vaucanson/algebra/concept/freemonoid_product_base.hh,
	* include/vaucanson/algebra/concept/freemonoid_product_base.hxx:
	  Here.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix free monoid words implementation.
	* include/vaucanson/algebra/implementation/monoid/str_words.hh
	  (op_rout): Change signature by adding the `const' qualifier to the
	  thirs argument.
	* include/vaucanson/algebra/implementation/monoid/str_words.hxx
	  (op_rout): Update third argument. Remove parenthesis after the
	  `empty' attribute.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add pair automaton to the test-suite and add pair_to_fmp test.
	* src/tests/include/Makefile.am: Add new file to the distribution.
	* src/tests/include/tests/automata/algos/README: Add a short
	  description of the new pair_automata folder.
	* src/tests/include/tests/automata/algos/pair_automata/pair_to_fmp_test.hh: New.
	* src/tests/test-suites/char_char_boolean_automaton.defs: New.
	* src/tests/test-suites/context_headers_char_char_boolean.defs: New.
	* src/tests/test-suites/context_headers_int_int_boolean.defs: New.
	* src/tests/test-suites/generate-all.sh: Generate tests for
	  `char_char_boolean_automaton' and `int_int_boolean_automaton'.
	* src/tests/test-suites/int_int_boolean_automaton.defs: New.
	* src/tests/test-suites/subdirs.mk: Update according to the new
	  tests.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add more specialization for the letter random generator.
	* include/vaucanson/misc/random.hh (generate): New macro
	  `DECLARE_PAIR_SPECIALIZATION' to declare three more specialization
	  for std::pair (std::pair<char,char>, std::pair<int,int> and
	  std::pair<int,char>).
	* include/vaucanson/misc/random.hxx (generate): New macro
	  `MAKE_PAIR_SPECIALIZATION' to make three more specialization for
	  std::pair (std::pair<char,char>, std::pair<int,int> and
	  std::pair<int,char>).

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Add the pair_to_fmp algorithm (close #173).
	* include/Makefile.am: Add new files to the distribution.
	* include/vaucanson/algorithms/pair_to_fmp.hh: New.
	* include/vaucanson/algorithms/pair_to_fmp.hxx: New.
	* doc/NEWS.txt: Update.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Minor updates to ltl_to_pair.
	* include/vaucanson/algorithms/ltl_to_pair.hh (mute_ltl_to_pair):
	  When calculating the `ret_impl_t', now explicitly specify the
	  implementation details required by `mute_graph_impl_monoid_traits'.
	* include/vaucanson/algorithms/ltl_to_pair.hxx: Cosmetic change.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Rework a trait used to mute graph implementations.
	* include/vaucanson/automata/concept/automata_base.hh
	  (mute_graph_impl_monoid_traits): Rename the `M' template argument
	  to `W'. Add the `L' template argument. Remove calculation of the
	  letter type, as it must now be provided by the user. Replace
	  `monoid_elt_value_t' by `W'. Replace `letter_t' by `L'. The trait
	  now only deals with implementation details.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Fix handling of the rep_ attribute in free_monoid.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh:
	  (representation): Add `const' qualifier.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hxx:
	  (CTORS): Reorder attributes initialization list.
	  (representation): Add `const' qualifier.

2008-10-29  Jerome Galtier  <jerome.galtier@lrde.epita.fr>

	Cosmetic changes.
	* include/vaucanson/algebra/concept/freemonoid_base.hxx,
	* include/vaucanson/algebra/implementation/series/polynoms.hxx: Here.

2008-10-29  Reuben Thomas  <rrt@sc3d.org>

	Improve some FIXMEs.
	* include/vaucanson/automata/concept/automata_base.hh: Annotate
	  "states", "series" and "transitions" better, and add a pointer
	  to Trac #191. Fix some English.
	* include/vaucanson/automata/concept/automata_base.hxx: Improve
	  comments for "transitions" and "states" methods.
	* include/vaucanson/automata/concept/transducer_base.hh: Fix English.
	* include/vaucanson/misc/usual_macros.hh: Add a FIXME pointing to
	  Trac #190 [sic].

2008-10-29  Reuben Thomas  <rrt@sc3d.org>

	Fix typo in previous commit: AutomataSet should be AutomatonSet.
	* include/vaucanson/automata/concept/automata.hh: AutomataSet ->
	  AutomatonSet.

2008-10-29  Reuben Thomas  <rrt@sc3d.org>

	Add some FIXMEs for Trac #3.
	* include/vaucanson/algebra/implementation/series/series.hh: .
	* include/vaucanson/automata/concept/automata.hh: .
	* include/vaucanson/automata/concept/transducer.hh: .

2008-10-29  Reuben Thomas  <rrt@sc3d.org>

	Correct comment: these are not "const versions" of methods.
	* /include/vaucanson/automata/conceptautomata_base.hh: The
	  methods states and transitions were marked as "const
	  versions" but they don't return a const type. Remove this
	  note on each method.

2008-10-29  Reuben Thomas  <rrt@sc3d.org>

	Correct typo.
	* /include/vaucanson/automata/conceptautomata_base.hh: "states"
	  should be "transitions".

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Fix English typo.
	* /home/rrt/vaucanson/trunk/include/vaucanson/design_pattern/element.hh:
	  theorical -> theoretical.

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Add Kind template parameter to Automata/Transducer types.
	Add Kind template parameter to Automata/Transducer types, and kind_t type to the classes.
	This is the first step on the way to the new label kinds regime.
	(Of course, this and future commits are being made on the label_kinds branch for
	the moment.)
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/extension.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/extension.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/invert.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/ltl_to_pair.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/ltl_to_pair.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/normalized_composition.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/search.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/search.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/thompson.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/thompson.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/automata.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/automata.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/automata_base.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/automata_kind.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/transducer.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/transducer.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/transducer_base.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/contexts/automaton.thh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/contexts/transducer.thh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/misc/usual_macros.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/xml/contexts/fmp.hh: .

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Merge wanted changes from trunk.
	* /home/rrt/vaucanson/branches/label_kinds/.: New.
	* /home/rrt/vaucanson/branches/label_kinds/ChangeLog: .
	* /home/rrt/vaucanson/branches/label_kinds/data/template_graph_impl.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algebra/concept/freemonoid_product.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algebra/concept/numerical_semiring.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algebra/concept/semigroup_base.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algebra/concept/tropical_semiring.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algebra/implementation/series/series.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/algorithms/realtime.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/kinds.hh: .
	* /home/rrt/vaucanson/branches/label_kinds/include/vaucanson/automata/concept/kinds.hxx: .
	* /home/rrt/vaucanson/branches/label_kinds/src/demos/one_rule_rewriting/Makefile.am: .
	* /home/rrt/vaucanson/branches/label_kinds/src/demos/one_rule_rewriting/ORR_demo.cc: .
	* /home/rrt/vaucanson/branches/label_kinds/src/demos/one_rule_rewriting/ORR_iterate.cc: New.
	* /home/rrt/vaucanson/branches/label_kinds/src/demos/one_rule_rewriting/shortest.hh: New.

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Remove the ancient and unused semigroup_kind type.
	The type semigroup_kind is defined for each semiring, but
	never used. The code is old, so if it hasn't been used for
	so long, it might as well be removed. (It's just another
	trap for the unwary, otherwise.)
	* include/vaucanson/algebra/concept/freemonoid_product.hh.
	* include/vaucanson/algebra/concept/numerical_semiring.hh.
	* include/vaucanson/algebra/concept/semigroup_base.hh.
	* include/vaucanson/algebra/concept/tropical_semiring.hh.
	* include/vaucanson/algebra/implementation/monoid/free_monoid.hh.
	* include/vaucanson/algebra/implementation/series/series.hh.

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Add "latteux" as ORR_iterate.
	Latteux is an iterative ORR program that obviously shares
	a history with the rest of the code in this directory.
	It should be more integrated, and it's not at all obvious
	that it works properly, but for the moment, I have just
	added it to the directory and made sure that it compiles,
	and at least runs. In future it should be tested thoroughly,
	debugged, and merged in with the rest of the code (at the
	moment there's a lot of code in ORR_iterate.cc that appears
	in other files in this directory).
	* src/demos/one_rule_rewriting/Makefile.am: Add ORR_iterate.
	* src/demos/one_rule_rewriting/ORR_iterate.cc: New.
	* src/demos/one_rule_rewriting/shortest.hh: New.

2008-10-27  Reuben Thomas  <rrt@sc3d.org>

	Use English for automaton names.
	* src/demos/one_rule_rewriting/ORR_demo.cc: Use "L" and "R"
	  rather than "G" and "D" in name labels.

2008-10-24  Reuben Thomas  <rrt@sc3d.org>

	Fix English.
	* data/template_graph_impl.hh: Fix some English.

2008-10-24  Reuben Thomas  <rrt@sc3d.org>

